commit 118164293cc7eb18ba03896f602aff816400134b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Oct 26 16:04:30 2016 +0200

    Fix "make distcheck"

 configure.ac | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit b6c765871b752c9436ec993e47b48f9d4fecaed5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Oct 26 10:33:33 2016 +0200

    [ci] Fix appveyor.yml syntax error

 appveyor.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0e79ebb3ca9b7b6d238a0007e5ca022845ee9afc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Oct 23 14:39:43 2016 +0200

    [gobject] Update for new MATH structs

 src/hb-gobject-structs.cc | 3 +++
 1 file changed, 3 insertions(+)

commit 8c854dc023b1f9e081a3bbd16416b88a4671c267
Merge: bb9805f c3fa5d0
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Tue Oct 25 00:31:36 2016 +0300

    Merge pull request #352 from fred-wang/makefile-am

    Remove inexistent file ttx file from test/api/Makefile.am

commit c3fa5d0e03b57be131c66ea8720806c946d0e10f
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Mon Oct 24 21:42:04 2016 +0200

    Remove inexistent file ttx file from test/api/Makefile.am

 test/api/Makefile.am | 1 -
 1 file changed, 1 deletion(-)

commit bb9805f5419f18c7f5cab32d660fd4109c30f7cc
Merge: 702d9f5 755a0c2
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Oct 22 12:23:05 2016 +0330

    Merge pull request #349 from ebraminio/mergebackvcpkgpatches

    [ci] Enable hb-freetype on Windows build tests

commit 755a0c20798e3c3e6bb933a28e38f9667fccdadc
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Oct 21 11:48:58 2016 +0330

    [ci] Enable freetype on msvc using vcpkg

 appveyor.yml | 15 +++++++++++++--
 1 file changed, 13 insertions(+), 2 deletions(-)

commit 4631d84c2bb51395efe3156f9c9f1a6b0e277947
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Tue Oct 18 14:30:00 2016 +0330

    Merge back @vlj's local patches of vcpkg

 win32/config-msvc.mak    | 7 +++++++
 win32/detectenv-msvc.mak | 3 +++
 2 files changed, 10 insertions(+)

commit 702d9f522d1ac4797700f0ea056f69169b8d1a78
Merge: 331c46c d8e2eb9
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Oct 14 13:54:55 2016 +0330

    Merge pull request #340 from ebraminio/nouniscribe

    Make Uniscribe optional on nmake win32 builds

commit d8e2eb9ee0f47af7e90056d8db5949d10a88786a
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Oct 9 09:06:05 2016 +0330

    Make Uniscribe optional on nmake win32 builds

    Most of harfbuzz clients don't need Uniscribe and DirectWrite support
    at all
    as harfbuzz is a replacement for Uniscribe so Chromium and Firefox
    are using
    harfbuzz without them on Windows.

    This removal also helps win32 nmake clients to have reduced binary
    size and
    libs count.

 appveyor.yml            |  2 +-
 win32/README.txt        | 13 +++++++------
 win32/config-msvc.mak   | 18 +++++++++++++-----
 win32/config.h.win32.in |  2 +-
 win32/info-msvc.mak     | 11 +++++++++--
 5 files changed, 31 insertions(+), 15 deletions(-)

commit 331c46c79b4d18cb4948be12c78ebb71a143e7ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 11 13:45:22 2016 -0700

    Fix configure on iOS

    Fixes https://github.com/behdad/harfbuzz/issues/342

 configure.ac | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit f6e194e77a2c34cd118b47c0d73a22afde85dfda
Merge: 7201fdd bef240b
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Tue Oct 11 17:23:41 2016 +0330

    Merge pull request #344 from ebraminio/fixmacci

    [ci] Whitelist more symbols and unbreak mac CI

commit bef240b36ee9086b0d92e351e4c5118c0bbb5df6
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Oct 10 17:27:52 2016 +0330

    [ci] Whitelist more symbols and unbreak mac CI

    Thanks to @khaledhosny, actually this is his work :)

 src/check-symbols.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 7201fdd0a8e26d49b13e289b53de375d5b1c9fcb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 4 14:53:17 2016 -0700

    LFS (large file system?) support in hb-*shap*, hb-view

    Fixes https://github.com/behdad/harfbuzz/issues/336

 configure.ac | 3 +++
 1 file changed, 3 insertions(+)

commit 34fc4a2cfa61089b7ec2d9510d99cdc4c13bceb4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Sep 28 19:17:27 2016 +0200

    Fix dist

 test/api/Makefile.am | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit d1c62370a0c2bdb365a1468dc8d782b9a7245946
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Sep 28 19:11:22 2016 +0200

    Aim math API for 1.3.3 instead of 1.4.0

 docs/harfbuzz-docs.xml     |  6 +++---
 docs/harfbuzz-sections.txt | 12 ++++++------
 src/hb-ot-layout.cc        | 18 +++++++++---------
 src/hb-ot-math.h           | 10 +++++-----
 4 files changed, 23 insertions(+), 23 deletions(-)

commit 7adbc5dd62ca03a65d1886e0f32e7026964dc5e5
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Fri Sep 30 04:01:24 2016 -0700

    Fix building math docs (#335)

 src/hb-ot-layout.cc | 9 ---------
 1 file changed, 9 deletions(-)

commit fd7a245d3525905ffbce57472b52900fcb0e330b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 17:56:35 2016 +0200

    Require glib >= 2.38.0 for G_TEST_DIST

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6d3e6abf0c6ad55dabae96c76b4da9ab14bf16ef
Merge: f73a87d c3e21a6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 17:15:59 2016 +0200

    Merge branch 'math'

    Supercedes https://github.com/behdad/harfbuzz/pull/326
    Fixes https://github.com/behdad/harfbuzz/pull/331

commit c3e21a6620c35500afa350d11620f69802920df3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 16:51:38 2016 +0200

    [MATH] Fix more docs

 src/hb-ot-layout.cc | 18 +++++++++---------
 src/hb-ot-math.h    | 25 +++++++++++++++++++++++++
 2 files changed, 34 insertions(+), 9 deletions(-)

commit 46cc4a3a2a529c80677babe38ca1542f9c773ac0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 16:44:22 2016 +0200

    [MATH] Rename hb_math_*_t types to hb_ot_math_*_t

    With this, I believe MATH table API is not ready to be merged.

 docs/harfbuzz-sections.txt     |  6 +++---
 src/hb-ot-layout-math-table.hh | 12 ++++++------
 src/hb-ot-layout.cc            |  8 ++++----
 src/hb-ot-math.h               | 16 ++++++++--------
 test/api/test-ot-math.c        |  4 ++--
 5 files changed, 23 insertions(+), 23 deletions(-)

commit db5ebcf10f8595d1f4a9df27befd6cb5e76ca94d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 16:42:25 2016 +0200

    Update docs

 docs/harfbuzz-docs.xml     |  9 +++++++++
 docs/harfbuzz-sections.txt | 30 ++++++++++++++++++++++++++++--
 2 files changed, 37 insertions(+), 2 deletions(-)

commit 0762b35474c47171e5661904e93851eb73a44e5c
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Tue Sep 27 15:28:35 2016 +0200

    Document API for MathVariants (#330)

 src/hb-ot-layout.cc | 56
 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 56 insertions(+)

commit 8d622f1114d6a0eca1786b94c7fc1a0bcd87f74b
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Tue Sep 27 13:53:34 2016 +0200

    Add tests for get_mathvariant (#329)

 test/api/test-ot-math.c | 160
 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 160 insertions(+)

commit f73a87d9a8c76a181794b74b527ea268048f78e3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 13:50:54 2016 +0200

    1.3.2

 NEWS         | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit 485e4873fb7cacfa9d853272c2275bbc5826023e
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Tue Sep 27 13:18:00 2016 +0200

    Add tests for hb_ot_math_get_glyph_variants (#328)

 test/api/test-ot-math.c | 126
 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 126 insertions(+)

commit f16bf6c2dacf5b9c82b2d1ffacc092cc396189a7
Author: Phil Krylov <phil.krylov@gmail.com>
Date:   Tue Sep 27 12:38:49 2016 +0200

    Allow building with graphite2 without pkg-config (#318)

 configure.ac | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit a5629a2ed9c2e69f2b4ebb74d85fbe0b5ba2be67
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 11:30:44 2016 +0200

    [MATH] Simplify test

 test/api/test-ot-math.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit edcfa789bf92c18f5badad31c0ad04a6a77d7226
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Tue Sep 27 11:02:08 2016 +0200

    test-ot-math: Use different scales for vertical
    and horizontal directions and add test for
    hb_ot_math_get_min_connector_overlap. (#327)

 test/api/test-ot-math.c | 81
 ++++++++++++++++++++++++++++++-------------------
 1 file changed, 49 insertions(+), 32 deletions(-)

commit bc19f7fe20e89823dba07a46c3d48c7406b781b6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 27 10:58:08 2016 +0200

    [MATH] Add HB_OT_MATH_SCRIPT

 src/hb-ot-math.h | 3 +++
 1 file changed, 3 insertions(+)

commit cdc9eef7da934ae71578694f29665e439686c3bd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 22:18:41 2016 +0200

    [MATH] Enable tests for glyph-assembly italics-correction

 test/api/test-ot-math.c | 49
 ++++++++++++++++++++++++++++++-------------------
 1 file changed, 30 insertions(+), 19 deletions(-)

commit 86106c7528d9bff8de6bc3e1487be780c31ea4fd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 22:12:48 2016 +0200

    [MATH] Rename all API to hb_ot_math_*

 src/hb-ot-layout-private.hh    |  10 --
 src/hb-ot-layout.cc            |  69 ++++----
 src/hb-ot-math.h               |  56 +++---
 test/api/Makefile.am           |   6 +-
 test/api/test-ot-layout-math.c | 382
 -----------------------------------------
 test/api/test-ot-math.c        | 381
 ++++++++++++++++++++++++++++++++++++++++
 6 files changed, 447 insertions(+), 457 deletions(-)

commit 1ba767cd4e3606beb9dc59806b83b1e61f5958d4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 21:57:14 2016 +0200

    [MATH] Move API from hb-ot-layout.h to hb-ot-math.h

 src/hb-ot-layout.h | 52
 --------------------------------------------------
 src/hb-ot-math.h   | 56
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot.h        |  1 +
 3 files changed, 57 insertions(+), 52 deletions(-)

commit 97b72da6006d8d6355ee90d514f627e6604a4936
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 21:53:25 2016 +0200

    Whitespace

 src/hb-ot-layout-math-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 559eb564472575ae4d87a241314b8a3ca24418c4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 21:46:05 2016 +0200

    [MATH] Wire up get_glyph_assembly()

 src/hb-ot-layout-math-table.hh | 64
 ++++++++++++++++++++++++++++++++++++++----
 src/hb-ot-layout.cc            | 26 +++++++++--------
 src/hb-ot-layout.h             | 14 ++++-----
 3 files changed, 81 insertions(+), 23 deletions(-)

commit 353f455af7ccbc1af8338dcb0c8ab87aef866c79
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 21:22:48 2016 +0200

    [MATH] Wire up get_glyph_variants()

 src/hb-font-private.hh         |  11 ++-
 src/hb-ot-layout-math-table.hh | 178
 +++++++++++++++++++----------------------
 src/hb-ot-layout.cc            |   7 +-
 src/hb-ot-layout.h             |   2 +-
 4 files changed, 95 insertions(+), 103 deletions(-)

commit 7fe0e28c22331a353d396f8bc1e3a60f1580a96d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 17:51:47 2016 +0100

    [MATH] Start fleshing out glyph variant API

 src/hb-font-private.hh         |  4 +++
 src/hb-ot-layout-math-table.hh | 10 ++----
 src/hb-ot-layout.cc            | 73
 +++++++++++++++---------------------------
 src/hb-ot-layout.h             | 20 ++++++++++++
 src/hb-ot-math.h               | 18 +++++++++++
 5 files changed, 71 insertions(+), 54 deletions(-)

commit 1f3327f21045df8a050a21a949b44b9ce186ceaa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 16:10:08 2016 +0100

    [MATH] Clean up math variants

 src/hb-ot-layout-math-table.hh | 35 +++++++++--------------------------
 1 file changed, 9 insertions(+), 26 deletions(-)

commit 51da7a1cd672aada84bdbb3a2a8dd77ab1134249
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Thu Aug 25 11:17:50 2016 +0200

    MATH table: Add API to access math variants.

 src/hb-ot-layout-math-table.hh          | 253
 +++++++++++++++++++++++++++++++-
 src/hb-ot-layout-private.hh             |  10 ++
 src/hb-ot-layout.cc                     |  54 +++++++
 test/api/fonts/MathTestFontPartial4.otf | Bin 0 -> 14360 bytes
 test/api/test-ot-layout-math.c          |  51 +++++++
 5 files changed, 364 insertions(+), 4 deletions(-)

commit 722e620f20fa2225cf874f4aeb115a064142fcf1
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Mon Sep 26 11:51:36 2016 +0200

    Use G_TEST_DIST to build the path of math test fonts

 test/api/Makefile.am           | 2 ++
 test/api/test-ot-layout-math.c | 8 ++++++--
 2 files changed, 8 insertions(+), 2 deletions(-)

commit 8d58e3433e242bd9dd18aa08f55ab0a406583fb0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 13:39:58 2016 +0100

    [MATH] Fix get_kerning() with negative y-scale

 src/hb-ot-layout-math-table.hh | 36 +++++++++++++++++++++---------------
 1 file changed, 21 insertions(+), 15 deletions(-)

commit 94f5df5626b223ad92d0c167f560c1f2e2f19042
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 13:31:47 2016 +0100

    [MATH] Clean up get_kerning()

 src/hb-ot-layout-math-table.hh | 29 +++++++++++++++++------------
 src/hb-ot-layout.cc            |  5 +----
 2 files changed, 18 insertions(+), 16 deletions(-)

commit 17ff30e9afde79e41c17786223293e867b49ebba
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 12:18:32 2016 +0100

    [MATH] Clean up get_top_accent_attachment()

    Note, the function now returns "half of horizontal advance width"
    if top accent attachment for glyph is not explicitly defined.
    This is what the spec requires.  Updated tests.

 src/hb-ot-layout-math-table.hh | 31 +++++++++++--------------------
 src/hb-ot-layout.cc            |  7 +------
 test/api/test-ot-layout-math.c |  8 ++++----
 3 files changed, 16 insertions(+), 30 deletions(-)

commit 8bcf517fe59608d2247a8974445b3ff0f4b4b4ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 12:12:41 2016 +0100

    [MATH] Clean up get_italics_correction()

 src/hb-ot-layout-math-table.hh | 16 ++++++++--------
 src/hb-ot-layout.cc            | 17 ++++++-----------
 src/hb-ot-layout.h             |  4 ++--
 test/api/test-ot-layout-math.c | 18 +++++++++---------
 4 files changed, 25 insertions(+), 30 deletions(-)

commit 06003f71ba0d0327fb1a17098a9d7faa8fb336f0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 12:07:29 2016 +0100

    [MATH] Clean up a bit more

 src/hb-ot-layout-math-table.hh | 12 +--------
 src/hb-ot-layout.cc            | 57
 ++++++++++++++++--------------------------
 2 files changed, 22 insertions(+), 47 deletions(-)

commit 54c0cc38fba24fa4370231408ba121589b190a28
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 11:56:40 2016 +0100

    [MATH] Clean up get_math_constant implementation

 src/hb-ot-layout-math-table.hh | 10 +++++-----
 src/hb-ot-layout.cc            |  5 ++---
 2 files changed, 7 insertions(+), 8 deletions(-)

commit 8a8cfad9a0834fe278a747c1d755144bd78f564b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 11:47:05 2016 +0100

    [MATH] Cleanup previous commit a bit

 src/hb-ot-layout-math-table.hh | 186
 ++++++++++++++++++++---------------------
 src/hb-ot-layout.cc            |  30 +++----
 src/hb-ot-layout.h             |  14 ++--
 3 files changed, 113 insertions(+), 117 deletions(-)

commit d7182d129612c619b9026ee9b15f2dcfada132db
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Thu Aug 25 11:15:31 2016 +0200

    MATH Table: Add API to access glyph info.

 src/hb-ot-layout-math-table.hh          | 271
 +++++++++++++++++++++++++++++++-
 src/hb-ot-layout.cc                     | 114 ++++++++++++++
 src/hb-ot-layout.h                      |  18 +++
 src/hb-ot-math.h                        |   7 +
 test/api/fonts/MathTestFontPartial1.otf | Bin 0 -> 14348 bytes
 test/api/fonts/MathTestFontPartial2.otf | Bin 0 -> 14356 bytes
 test/api/fonts/MathTestFontPartial3.otf | Bin 0 -> 14380 bytes
 test/api/test-ot-layout-math.c          | 155 ++++++++++++++++++
 8 files changed, 563 insertions(+), 2 deletions(-)

commit 6fd2fe418dc838743f0d4a8a2222cdcaf587500c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 11:24:39 2016 +0100

    [MATH] Fixup math constants commit a bit more

 src/hb-ot-layout-math-table.hh | 24 +++++++++++-------------
 1 file changed, 11 insertions(+), 13 deletions(-)

commit 1a381153a2e6a15bded1f8e31f6b0e0cadb078af
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 11:15:59 2016 +0100

    [MATH] Fixups for math constants commit

 src/hb-ot-layout-math-table.hh | 19 +++++++++----------
 1 file changed, 9 insertions(+), 10 deletions(-)

commit 319ff59161e6b027391f8b9fdce0db6dd44cc20d
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Thu Aug 25 11:06:41 2016 +0200

    MATH Table: Add API to access math contants.

 src/Makefile.sources                |   1 +
 src/hb-ot-layout-math-table.hh      | 146
 +++++++++++++++++++++++++++++++++++-
 src/hb-ot-layout.cc                 |  25 ++++++
 src/hb-ot-layout.h                  |   5 ++
 src/hb-ot-math.h                    | 100 ++++++++++++++++++++++++
 test/api/fonts/MathTestFontFull.otf | Bin 0 -> 25412 bytes
 test/api/test-ot-layout-math.c      |  72 ++++++++++++++++++
 7 files changed, 345 insertions(+), 4 deletions(-)

commit 4d3892e9b05a4df67b2f5cfd6dd3a1e0f5b38fc7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Sep 26 10:45:58 2016 +0100

    [MATH] Fixups for previous commit

 src/hb-ot-layout-math-table.hh |  8 ++++----
 src/hb-ot-layout.cc            | 29 +++++++++++++++++++----------
 src/hb-ot-layout.h             |  2 ++
 test/api/Makefile.am           |  6 ++----
 test/api/test-ot-layout-math.c | 16 +++++++++-------
 5 files changed, 36 insertions(+), 25 deletions(-)

commit 5fbcb992bd7887f95b1cf2ca045c9226de8148fc
Author: Frédéric Wang <fred.wang@free.fr>
Date:   Thu Aug 25 10:47:15 2016 +0200

    MATH Table: Add API to check availability of math data.

 src/Makefile.sources                 |   1 +
 src/hb-ot-layout-math-table.hh       |  60 +++++++++++++++++++++
 src/hb-ot-layout-private.hh          |   3 ++
 src/hb-ot-layout.cc                  |  45 ++++++++++++++++
 src/hb-ot-layout.h                   |   7 +++
 test/api/Makefile.am                 |  14 ++++-
 test/api/fonts/MathTestFontEmpty.otf | Bin 0 -> 14320 bytes
 test/api/fonts/MathTestFontNone.otf  | Bin 0 -> 14284 bytes
 test/api/test-ot-layout-math.c       |  98
 +++++++++++++++++++++++++++++++++++
 9 files changed, 227 insertions(+), 1 deletion(-)

commit 02bfd965af588640250c47f344ad3096c8a373e0
Author: Gregory Morse <gregory.morse@live.com>
Date:   Mon Sep 12 10:22:15 2016 +0200

    Update detectenv-msvc.mak (#316)

    Windows x86 ARM capability

 win32/detectenv-msvc.mak | 3 +++
 1 file changed, 3 insertions(+)

commit fc4e671f311241e21c1cc3ed941b1fc651875a2e
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Sep 9 23:28:28 2016 +0430

    [coretext] Use intended coretext version check logic (#315)

 src/hb-coretext.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 48677345281a93d8829dd37d0480a6062945416a
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Thu Sep 8 04:44:37 2016 +0300

    Try to unbreak building on older macOS again (#314)

 src/hb-coretext.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d22ab6cf040467e7f17476ccdfe9cab4dce16639
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Sep 7 14:28:47 2016 -0700

    1.3.1

 NEWS         | 9 +++++++++
 configure.ac | 2 +-
 2 files changed, 10 insertions(+), 1 deletion(-)

commit b717cd7be506217e466e32a456df9af4d2720c0c
Author: Dominik Röttsches <d-r@roettsches.de>
Date:   Wed Sep 7 23:56:57 2016 +0300

    Do reconfigure the cascade list for Emoji font on OS X 10.9.5 (#313)

    This seems to fix crash issues on 10.9.5 reported on Chrome, compare
    crbug.com/549610

 src/hb-coretext.cc | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

commit 67e9fdf427e8536f0a134f84ad3bf1740245fe12
Author: Dominik Röttsches <d-r@roettsches.de>
Date:   Mon Sep 5 11:27:25 2016 +0300

    Blacklist Padauk 2.80 and 3.00 (#311)

    According to comments in issue #305 broken GDEF tables lead
    to incorrect rendering of Latin characters. Blacklisting
    this font.

 src/hb-ot-layout.cc | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 17f0dd2dfb9a15aed9d1a229115940cc23bdbc97
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Sep 2 01:21:48 2016 +0430

    [ci] Add msys2 build to CI and run its testsuite on Windows (#310)

 appveyor.yml | 20 ++++++++++++++++----
 1 file changed, 16 insertions(+), 4 deletions(-)

commit 5362ce6a6455c539d615e7fb221a904ac744b74c
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Sep 1 20:05:45 2016 +0430

    [dwrite] Minor, don't include unnecessary headers (#309)

 src/hb-directwrite.cc | 4 ----
 1 file changed, 4 deletions(-)

commit c4f36b04e32ae5111ef11d225e5d6e82c8216185
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Sep 1 17:31:16 2016 +0430

    [ci] Add Windows CI support, provided by AppVeyor (#308)

 README                  |  1 +
 appveyor.yml            | 28 ++++++++++++++++++++++++++++
 win32/generate-msvc.mak |  2 +-
 3 files changed, 30 insertions(+), 1 deletion(-)

commit 3d976d20f1b97c771e64a9cfed2760ebec64037a
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Sat Aug 27 16:38:42 2016 +0300

    Show the shaper name in the debug message (#306)

 src/hb-shape-plan.cc | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 547ddb0721365dca985aef5b759d08718f7c5f82
Merge: bd1aac9 e7ecbba
Author: Sascha Brawer <sascha@brawer.ch>
Date:   Thu Aug 18 22:33:14 2016 +0200

    Merge pull request #303 from behdad/fonnapa

    Support Americanist Phonetic Notation

commit e7ecbba2cc3c9369c5e7dc7296cb210018aca3bb
Author: Sascha Brawer <sascha@brawer.ch>
Date:   Thu Aug 18 12:48:38 2016 +0200

    Support Americanist Phonetic Notation

    OpenType language system tag: `APPH`
    https://www.microsoft.com/typography/otspec/languagetags.htm

    IETF BCP47 variant tag: `fonnapa`
    http://www.iana.org/assignments/language-subtag-registry/language-subtag-registry

 src/hb-ot-tag.cc       | 14 ++++++++++++--
 test/api/test-ot-tag.c |  6 ++++++
 2 files changed, 18 insertions(+), 2 deletions(-)

commit bd1aac9c0021a936058637424a478abf792533dd
Merge: 18c19dd a0f1b44
Author: Sascha Brawer <sascha@brawer.ch>
Date:   Thu Aug 18 13:59:38 2016 +0200

    Merge pull request #302 from khaledhosny/master

    [travis] Fix MacOS libtool issue

commit a0f1b44b6c0e3b1e6a1ba63dde2be22e0425353f
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Tue Aug 16 03:09:04 2016 +0200

    [coretext] Blind fix for build on MacOS 10.9

 src/hb-coretext.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0634d5600e559a69a92d49173ffb8e715fe7576c
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Tue Aug 16 02:49:48 2016 +0200

    [travis] Fix MacOS libtool issue

    Reveals another MacOS build breakage in the Core Text shaper.

 .travis.yml | 1 +
 1 file changed, 1 insertion(+)

commit 18c19dd34dcdcaab0a6d47768339f8fb70c0d3f0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 9 13:03:14 2016 -0700

    Fix build

 test/api/test-ot-tag.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 91f2585411aaf5565fcf0c991b9055b0b397f1cd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 8 18:08:08 2016 -0700

    Actually add test

 test/shaping/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit f1b76275da716a4174092e6389979e03c0e3be59
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 8 18:06:09 2016 -0700

    Add tests for Chinese language tags

    Using font from https://github.com/behdad/harfbuzz/issues/300

 .../sha1sum/6991b13ce889466be6de3f66e891de2bc0f117ee.ttf | Bin 0 ->
 5596 bytes
 test/shaping/tests/language-tags.tests                   |  12
 ++++++++++++
 2 files changed, 12 insertions(+)

commit 37f21bdbb75c98d741e749b7f1e0f367941aef4e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 8 17:57:06 2016 -0700

    Map Macao to ZHH lang tag

    Fixes https://github.com/behdad/harfbuzz/issues/300

 src/hb-ot-tag.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 09c7a2d6bf00dc902343e999f92cac0e8146f949
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 8 17:28:54 2016 -0700

    Limit bits-per-feature to eight

    Limits number of alternatives per glyph per feature to 255, so be it.
    That's better than possibly breaking shaping because of one bad
    feature
    value.

 src/hb-ot-map.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 333173103bb618f721bd25d0c565a3c3c9ea224e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 8 17:24:04 2016 -0700

    Fix sign of shift operators

    This one:

      map->mask = (1 << (next_bit + bits_needed)) - (1 << next_bit);

    before the fix, the shift was done as an int, causing overflow
    if it ever got to 1 << 31.  Sprinkle 'u's around.

    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=634805

 src/hb-buffer-private.hh | 6 +++---
 src/hb-cache-private.hh  | 8 ++++----
 src/hb-coretext.cc       | 2 +-
 src/hb-directwrite.cc    | 2 +-
 src/hb-face.cc           | 2 --
 src/hb-font.cc           | 2 --
 src/hb-ft.cc             | 6 ++++--
 src/hb-ot-map.cc         | 4 ++--
 src/hb-set-private.hh    | 4 ++--
 src/hb-uniscribe.cc      | 4 ++--
 10 files changed, 19 insertions(+), 21 deletions(-)

commit 10a0d4aa2254f783758bb908175047df3a0b41fe
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 8 16:51:08 2016 -0700

    Map zh-Hant-HK to ZHH

    Fixes https://github.com/behdad/harfbuzz/issues/300

 src/hb-ot-tag.cc | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit dd31fc9f7e6d23b414b22874de96eb3c002c80ba
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Fri Jul 22 02:26:54 2016 +0300

    Don’t build UCDN support when building with GLib (#296)

    Regression from: b424b6c372dfe4c0ed75a49761eb34a416819446.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 489acf6c3180d3726158864fa0e1adeea3c23fae
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jul 22 17:41:43 2016 -0700

    [coretext] "Fix" crashes on CoreText < 10.10

    Fixes https://github.com/behdad/harfbuzz/issues/297

 src/hb-coretext.cc | 8 ++++++++
 1 file changed, 8 insertions(+)

commit a732e00ea4fffebaa85a89420f09df4c11d650e0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jul 21 01:58:00 2016 -0700

    1.3.0

 NEWS         | 15 +++++++++++++++
 configure.ac |  2 +-
 2 files changed, 16 insertions(+), 1 deletion(-)

commit 08c08af2f9ed683ad20322c3ef1ba0f87ce15426
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jul 21 01:23:33 2016 -0700

    [ucdn] Update to Unicode 9.0.0

    Fixes https://github.com/grigorig/ucdn/issues/12

 src/hb-ucdn.cc               |    6 +
 src/hb-ucdn/README           |    1 -
 src/hb-ucdn/ucdn.c           |   80 +-
 src/hb-ucdn/ucdn.h           |   98 +-
 src/hb-ucdn/unicodedata_db.h | 4750
 +++++++++++++++++++++++-------------------
 5 files changed, 2783 insertions(+), 2152 deletions(-)

commit f3f6c1ccbf89e15cda03e0c3a2df4297e98adf60
Author: jfkthame <jfkthame@gmail.com>
Date:   Thu Jun 16 00:10:42 2016 +0100

    Blacklist GDEF tables of more fonts

    This is based on bug reports that have been filed against Firefox
    since it
    updated to a version of harfbuzz that uses zeroing by GDEF rather
    than by
    Unicode. I'm sure there are a bunch more font versions that should
    also be
    included; these are just the ones I have on hand and have confirmed
    as having
    bad GDEF data.

    Given how the list here is growing, I think we should reconsider
    the approach,
    and perhaps revert to zeroing by Unicode instead.

    Fixes https://github.com/behdad/harfbuzz/issues/264
    Fixes https://github.com/behdad/harfbuzz/pull/266

 src/hb-ot-layout.cc | 39 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 39 insertions(+)

commit 34f9aa582c3a03b578c7eae3d2e8860a0bd5cb00
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jul 20 02:35:54 2016 -0700

    Implement symbol cmap in ft and ot fonts

    Fixes https://github.com/behdad/harfbuzz/issues/236
    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=627953

 src/hb-ft.cc      | 27 +++++++++++++++++++++++----
 src/hb-ot-font.cc | 50 ++++++++++++++++++++++++++++++++++++++------------
 2 files changed, 61 insertions(+), 16 deletions(-)

commit 6363d7df28dc4307ef1abb9857d14c35e656b85a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jul 20 01:43:56 2016 -0700

    Clean up buffer area when rewinding

    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=614647
    If allocation fails, we might be leaving junk behind.  At least
    clear it up.

 src/hb-buffer.cc | 8 ++++++++
 1 file changed, 8 insertions(+)

commit f80c34eb556d12c45c961d6742c289baef58899d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jul 12 11:18:26 2016 -0700

    Whitespace

 src/hb-unicode-private.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 874421203e0161db2cbfb27be6c039cba57f7c63
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Tue Jul 12 03:49:21 2016 +0430

    [coretext] Speculative fix for CoreText nullptr access (#288)

 src/hb-coretext.cc | 14 +++++++++-----
 1 file changed, 9 insertions(+), 5 deletions(-)

commit 6bf9db4f1e1d51f9acb5e37b89caa8f4d275e7ce
Author: Birunthan Mohanathas <birunthan@mohanathas.com>
Date:   Mon Jul 11 13:38:23 2016 -0700

    [ft] Fix unsafe cast of FT_Done_Face in
    hb_ft_{face,font}_create_referenced (#289)

    Prior to this change the function `FT_Error FT_Done_Face(FT_Face
    *)` was
    called through a pointer with the signature `void (void *)`
    resulting in
    undefined behaviour.

 src/hb-ft.cc | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 0b8f3ab0220ca4731516313828515f26bb480645
Author: Steve Lhomme <slhomme@matroska.org>
Date:   Mon Jul 11 21:57:26 2016 +0200

    clang in MSVC mode doesn't like when we redefine __attribute__ (#283)

 src/hb-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2f522fd485c2e946c9bce9e3828b6ff6247c59e4
Merge: d3e2a06 e4d451e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jul 1 17:09:28 2016 -0700

    Merge pull request #286 from khaledhosny/gi-tag_from_string

    [introspection] Fix hb_tag_from_string annotation

commit e4d451ee55a57e1231b4076fcd1e87994f6b9528
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Sat Jul 2 00:04:57 2016 +0200

    [introspection] Fix hb_tag_from_string annotation

 src/hb-common.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d3e2a06b0f2587e913a9c3ff1a20c187f260db80
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jun 30 11:01:22 2016 -0700

    [python] Use utf-32 / utf-16 based on build of Python

    Fixes https://github.com/behdad/harfbuzz/pull/271

 src/sample.py | 22 +++++++++++++++++++++-
 1 file changed, 21 insertions(+), 1 deletion(-)

commit fc9de44a03a97f6e93bd98d804596cb1f9f4b5fd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jun 30 09:46:52 2016 -0700

    Comments

 src/hb-coretext.cc | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit 46809dee30232d493539519b1bb527fa816c37db
Merge: 70e72e5 1bea49e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jun 30 09:41:03 2016 -0700

    Merge pull request #268 from drott/conflictingFontFix

    Discard reconfigured CTFont if URL changes

commit 1bea49eb4b7a94ab6222f9c3c40320cbdb247b2d
Merge: 7aa3631 70e72e5
Author: Dominik Röttsches <d-r@roettsches.de>
Date:   Wed Jun 29 12:10:41 2016 +0200

    Merge branch 'master' into conflictingFontFix

commit 70e72e5f61d73c33d3c8f3bf07f5a9afd0db046a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jun 28 21:00:37 2016 -0700

    [gobject] Fix a few warnings

    Part of https://github.com/behdad/harfbuzz/issues/277

 src/hb-buffer.cc         |  2 +-
 src/hb-gobject-structs.h | 12 ++++++++++++
 src/hb-shape.cc          |  2 --
 src/hb-unicode.h         | 15 ---------------
 4 files changed, 13 insertions(+), 18 deletions(-)

commit d8273aac19771033c5064a2f079c29d09a86e7c0
Merge: abae93f ae9054c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jun 28 21:15:28 2016 -0700

    Merge pull request #280 from behdad/revert-271-patch-2

    Revert "use utf32"

commit ae9054c740631e36b7582b44c5afb42ff4509461
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jun 28 21:14:38 2016 -0700

    Revert "use utf32"

 src/sample.py | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 7aa3631dd06af74a1fa9f0bfaa5f721876be817f
Merge: f7da048 abae93f
Author: Dominik Röttsches <d-r@roettsches.de>
Date:   Tue Jun 28 09:52:18 2016 +0200

    Merge branch 'master' into conflictingFontFix

commit abae93faef32562f34a72981d252c848cc4f7565
Merge: 07461d0 8179ff5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jun 27 14:33:27 2016 -0400

    Merge pull request #273 from ebraminio/master

	[dwrite] Use stream font loader instead GDI interop

commit 8179ff5d7ba4a140cf6743729a22072800e98a79
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Mon Jun 27 03:54:15 2016 +0430

    [dwrite] Don't allocate more than needed

    Addressing Nikolay Sivov reviews on harfbuzz mailing list

 src/hb-directwrite.cc | 15 ++++++---------
 1 file changed, 6 insertions(+), 9 deletions(-)

commit 07b724f3419a28c479cd8a75ae0eecb841a6d2f3
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Fri Jun 24 12:23:25 2016 +0430

    [dwrite] Delete remained objects

    No longer noticeable memory increase on create/destroy iterations,
    highly better than current state of uniscribe backend

 src/hb-directwrite.cc | 33 ++++++++++++++++++++++++---------
 1 file changed, 24 insertions(+), 9 deletions(-)

commit be565d17141818e006aa1e4582f3ae14c726fa85
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Fri Jun 24 11:42:01 2016 +0430

    [dwrite] Release allocated blob on face destroy

    This reduces memory consumption of my iterated font create/destroy
    cycle test
    significantly and makes it much better than uniscribe backend even

 src/hb-directwrite.cc | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit f3f0ea980a359343ac0e3d359a95855c2cf7be25
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Thu Jun 23 16:41:37 2016 +0430

    [dwrite] Remove ifdefs without breaking execution on old Windows
    versions

 src/hb-directwrite.cc | 205
 +++++++++++++++++++++++++-------------------------
 1 file changed, 103 insertions(+), 102 deletions(-)

commit 6b861dbd8b3662d0fa0e51fad1736d72192da868
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Tue Jun 21 13:57:26 2016 +0430

    [dwrite] Use stream font loader instead GDI interop

    With help of
    https://dxr.mozilla.org/mozilla-central/source/gfx/2d/NativeFontResourceDWrite.cpp

 src/hb-directwrite.cc | 350
 +++++++++++++++++++-------------------------------
 src/hb-directwrite.h  |   2 +-
 2 files changed, 135 insertions(+), 217 deletions(-)

commit f7da0486ed8884481d477ce08fcf928c4da9a0a3
Merge: a022327 07461d0
Author: Dominik Röttsches <d-r@roettsches.de>
Date:	Mon Jun 20 10:25:43 2016 +0300

    Merge branch 'master' into conflictingFontFix

commit 07461d06d242cd5cfda7ccb891189f074a89b460
Author: Kelvin <kelvinsthirteen@gmail.com>
Date:	Sat Jun 18 22:46:38 2016 +0000

    Use UTF-32	in Python sample

 src/sample.py | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit fca0c61d67aa309fc824fb18f247493c2b7701ef
Merge: 4b8de1e 9883505
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Sun Jun 19 00:08:51 2016 +0300

    Merge pull request #270 from khaledhosny/travis-failure

    Fix make check on Travis

commit 988350586f607c7a46bbb658a2abecfd004f41fb
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Sat Jun 18 21:12:19 2016 +0200

    [tests] Workaround Python 2 “narrow” builds

    The so-called Python 2 “narrow” builds support UCS2 only, this
    is a
    workaround to allow unichr to work with any Unicode character in such
    builds. This fixes Travis-CI failure as it has narrow Python 2 builds.

    Copied from:
    https://github.com/behdad/fonttools/blob/master/Lib/fontTools/misc/py23.py

 test/shaping/hb_test_tools.py | 38 +++++++++++++++++++++++++++++++++++++-
 1 file changed, 37 insertions(+), 1 deletion(-)

commit a0223274b97e82fe02730fd45729172511fec459
Author: Dominik Röttsches <drott@chromium.org>
Date:	Thu Jun 16 14:19:39 2016 +0200

    Discard reconfigured CTFont if URL changes

    Fixes https://github.com/behdad/harfbuzz/issues/267

 src/hb-coretext.cc | 24 +++++++++++++++++++++---
 1 file changed, 21 insertions(+), 3 deletions(-)

commit 4b8de1ea804b225e8357422d0686aad76b05ccf3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jun 6 23:08:54 2016 -0700

    Round, not truncate, when scaling values

    Fixes https://github.com/behdad/harfbuzz/issues/255

 src/hb-font-private.hh | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit a93078a0ece6dcdea8c5b46cabd30854dd7cf593
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jun 6 15:58:41 2016 -0700

    Change bugreport URL to github

    That's where everything is happening these days.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bed201d2b839c1b1e727e17efc2e0c8f705b86c5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jun 6 14:14:24 2016 -0700

    Update for latest Unicode 9 data files

 src/hb-ot-shape-complex-indic-table.cc | 10 +++++-----
 src/hb-ot-shape-complex-indic.cc	|  5 -----
 src/hb-ot-shape-complex-use-table.cc	|  4 ++--
 3 files changed, 7 insertions(+), 12 deletions(-)

commit aba4b0ca52f490adfc2f3c6ec0accddd6596fdf6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Jun 1 16:57:29 2016 -0700

    Add TODO

 src/hb-font.cc | 1 +
 1 file changed, 1 insertion(+)

commit a2b03de5b30b7e83f7fbf3457e9ba9c00eb88d00
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 17:56:07 2016 +0100

    [myanmar] Handle U+AA74..U+AA76

    Fixes https://github.com/behdad/harfbuzz/issues/218

 src/hb-ot-shape-complex-myanmar.cc | 5 +++++
 1 file changed, 5 insertions(+)

commit 6c0aa9e92bbd22011c85d98c6db021012f7b4101
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 17:50:06 2016 +0100

    Fix build on droid.io

 test/shaping/tests/use.tests | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9b6312f9451db790db00dc2c2e27a5a1db852e72
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 17:41:49 2016 +0100

    [use] Update to draft spec from Andrew Glass from August 2015

 src/gen-use-table.py				    |  29 +++--
 src/hb-ot-shape-complex-use-machine.rl		    |  15 +--
 src/hb-ot-shape-complex-use-private.hh		    |	1 -
 src/hb-ot-shape-complex-use-table.cc		    | 142
 ++++++++++-----------
 src/hb-ot-shape-complex-use.cc			    |  11 +-
 .../6ff0fbead4462d9f229167b4e6839eceb8465058.ttf   | Bin 0 -> 1148 bytes
 test/shaping/tests/use.tests			    |	1 +
 7 files changed, 93 insertions(+), 106 deletions(-)

commit 3e4e7616a8ca80a50a438601b84428b4ba4c8694
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 17:28:25 2016 +0100

    [use] Add a catch-all clause to the machine

 src/hb-ot-shape-complex-use-machine.rl | 2 ++
 src/hb-ot-shape-complex-use.cc		| 2 ++
 2 files changed, 4 insertions(+)

commit d04e461fe3310ccaf8633efcb79b8eb6ca2201c3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 17:17:00 2016 +0100

    [use] Fix 'Number-joiner terminated cluster' to use HN instead of H

    From draft update to USE.

 src/hb-ot-shape-complex-use-machine.rl | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 359dead960c825edeb4587915a511d323f1c1f2a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 16:19:19 2016 +0100

    Allow MultipleSubst to delete glyph

    Fixes https://github.com/behdad/harfbuzz/issues/253

    Hopefully we got the logic right.

 src/hb-ot-layout-gsub-table.hh       | 17 +++++++----------
 src/hb-ot-layout-gsubgpos-private.hh | 11 +++++++----
 2 files changed, 14 insertions(+), 14 deletions(-)

commit 3c1666cfb589275de96d54eecb95a13a98e3819e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 16:05:07 2016 +0100

    [indic] Remove more unused logic after Javanese is gone

 src/hb-ot-shape-complex-indic.cc | 50
 +++++++++++++++-------------------------
 1 file changed, 18 insertions(+), 32 deletions(-)

commit 8b5d6e755b271d0d22b31a7726d5bfbf2aae8b2f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 15:59:27 2016 +0100

    [indic] Remove unused Javanese bits

 src/hb-ot-shape-complex-indic-machine.rl | 3 +--
 src/hb-ot-shape-complex-indic-private.hh | 5 ++---
 src/hb-ot-shape-complex-indic.cc	  | 4 ----
 3 files changed, 3 insertions(+), 9 deletions(-)

commit 30e6e29f0f0f77eb65bfd1c4576b38c2da555017
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 15:52:27 2016 +0100

    [indic/use] Move Javanese from Indic shaper to USE

    Fixes https://github.com/behdad/harfbuzz/issues/243

    With javatext.ttf, the reodering medial Ra gets its advance width
    zero'ed in Uniscribe implementation, and the font adds the advance
    back.  Our Indic shaper does not do that, but USE does.  So, route
    Javanese through USE.  That's what Microsoft does anyway.  Test:

      U+A9A5,U+A9BA

    This also seems to fix the following sequence, and variations thereof:

      U+A99F,U+A9C0,U+A9A2,U+A9BF

 src/gen-indic-table.py				    |  1 -
 src/hb-ot-shape-complex-indic-table.cc		    | 23
 ++++------------------
 src/hb-ot-shape-complex-private.hh		    |  5 +----
 .../south-east-asian/script-javanese/misc.txt	    |  1 +
 4 files changed, 6 insertions(+), 24 deletions(-)

commit c6ee5f5f06a27a6f147f63aaf51186622821f20b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 15:39:02 2016 +0100

    Add Javanese sample text

 .../south-east-asian/script-javanese/misc.txt	    | 53
 ++++++++++++++++++++++
 1 file changed, 53 insertions(+)

commit e21921a68a959b7e929f71a4260a6cbe055ab4e6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 15:24:39 2016 +0100

    Minor

 BUILD.md | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 01a30a6aa9a5827c93245961e3392a1f361745fe
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 11:50:02 2016 +0100

    [indic] Remove data for scripts that don't go thorough this shaper

 src/gen-indic-table.py			|  29 +-
 src/hb-ot-shape-complex-indic-table.cc | 604
 +--------------------------------
 2 files changed, 43 insertions(+), 590 deletions(-)

commit 7cd9269f4eba7b85cd72301a3fc39fab42a4e439
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 11:34:46 2016 +0100

    Update tables to Unicode 9.0.0 beta

    Fixes https://github.com/behdad/harfbuzz/issues/251

 src/hb-ot-shape-complex-arabic-table.hh |  56 ++++++++-----
 src/hb-ot-shape-complex-indic-table.cc  | 137
 +++++++++++++++++++++++---------
 src/hb-ot-shape-complex-use-table.cc	 |  86 ++++++++++++++------
 3 files changed, 196 insertions(+), 83 deletions(-)

commit f718fe370ea89e8aeb407addaa6cc926d52a4cdb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 11:21:12 2016 +0100

    Minor

 src/gen-indic-table.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 691086f131cb6c9d97e98730c27673484bf93f87
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 12:08:18 2016 +0100

    Add Unicode 9 beta scripts

    These are frozen, so good time to add.

 src/hb-common.cc		    | 3 +++
 src/hb-common.h		    | 9 +++++++++
 src/hb-ot-shape-complex-private.hh | 9 +++++++++
 src/hb-ot-shape-complex-use.cc     | 3 +++
 4 files changed, 24 insertions(+)

commit bc5198fe1277d662926a4f616913c085cd4fc8ee
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri May 6 11:59:05 2016 +0100

    Whitespace

 src/hb-common.h | 13 +++++++------
 1 file changed, 7 insertions(+), 6 deletions(-)

commit a5b7b0dd4508d8a1e7573b75c4cb8832c9e34e3f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon May 2 10:44:13 2016 +0200

    1.2.7

 NEWS	      | 12 ++++++++++++
 configure.ac |  2 +-
 2 files changed, 13 insertions(+), 1 deletion(-)

commit 9879fc1db3cad684f412c2f3d6b49e0435697d0e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon May 2 10:29:12 2016 +0200

    [ot-font] Remove unused 'post' table include for now

    To make a release...

 src/hb-ot-font.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f8061ae7972462ad800c23be7cd7b3d7ab94b93b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon May 2 10:28:24 2016 +0200

    [tests] Fix test

 test/shaping/Makefile.am						 |
 2 +-
 .../tests/{fallback-positioning.test => fallback-positioning.tests}
 | 0
 2 files changed, 1 insertion(+), 1 deletion(-)

commit f00ab2a33ab34ba64f38cbbe65830c770a3e071e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon May 2 10:24:00 2016 +0200

    [hb-ot-font] Make 'glyf' table loading lazy

    Apparently some clients have reference-table callbacks that copy
    the table.
    As such, avoid loading 'glyf' table which is only needed if fallback
    positioning
    happens.

 src/hb-ot-font.cc				    |  45
 ++++++++++++++++++++-
 test/shaping/Makefile.am			    |	1 +
 .../7ef276fc886ea502a03b9b0e5c8b547d5dc2b61c.ttf   | Bin 0 -> 784 bytes
 test/shaping/tests/fallback-positioning.test	    |	2 +
 4 files changed, 46 insertions(+), 2 deletions(-)

commit 587d46227a56940a7f5bb053cbeda6144394acf7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Apr 30 19:20:56 2016 +0200

    [ot-font] Start implementing 'post' table, for accessing glyph names

 src/Makefile.sources	     |	 1 +
 src/hb-open-type-private.hh |	12 ++++-
 src/hb-ot-font.cc	     |	 1 +
 src/hb-ot-post-table.hh     | 119
 ++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 132 insertions(+), 1 deletion(-)

commit 9abaaac409b8e3a0a9182b67dc384133013f7878
Merge: 2f560ee 264b7a7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Apr 27 03:38:24 2016 -0700

    Merge commit '264b7a728a41becfbf23ce258fc2a3af19d0cbbe' into HEAD

commit 2f560ee44b7b08683e8e6955fe3b95187e8bda32
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Apr 27 03:11:41 2016 -0700

    [tibetan] Reorder marks to better match Uniscribe

    Fixes https://github.com/behdad/harfbuzz/issues/237

    Note that Uniscribe enforces a certain syllable order.  We don't.
    But with this change, I get all of the tibetan contractions pass
    with Microsoft Himalaya font.

 src/hb-unicode-private.hh | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit f68390f196216718c22c434e1d8921118e646824
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Apr 27 02:44:35 2016 -0700

    [test] Add text for Tibetan shorthand contractions

    From http://www.babelstone.co.uk/Tibetan/Contractions.html

 .../script-tibetan/misc/contractions.txt	    | 612
 +++++++++++++++++++++
 1 file changed, 612 insertions(+)

commit 264b7a728a41becfbf23ce258fc2a3af19d0cbbe
Merge: 7e2da03 adafdcd
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Apr 27 03:48:23 2016 +0300

    Merge pull request #247 from khaledhosny/update-opentype-language-tags

    Update opentype language tags

commit adafdcddced076da4bfa3114a00e15a387aaf1f7
Author: Arthur Reutenauer <arthur.reutenauer@normalesup.org>
Date:	Sat Nov 7 23:37:21 2015 +0000

    Mass-added “difficult” tags – to be curated.

 src/hb-ot-tag.cc | 69
 +++++++++++++++++++++++++++++---------------------------
 1 file changed, 36 insertions(+), 33 deletions(-)

commit 3d6a2c0d7d9f6c5b3097f78c1123f9e59dcc76e2
Author: Arthur Reutenauer <arthur.reutenauer@normalesup.org>
Date:	Sat Nov 7 22:59:13 2015 +0000

    Initial import of missing OpenType 1.7 language tags.

 src/hb-ot-tag.cc | 67
 +++++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 61 insertions(+), 6 deletions(-)

commit 7e2da035f68e46ce8f4759b67b4ed3a1b211d793
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Apr 26 16:42:25 2016 -0700

    Undo accidental change

 src/hb-ot-shape-complex-arabic.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b20305022a8235b19e6b640bc62651854e1336f1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Apr 26 16:41:17 2016 -0700

    Do NOT ignore Mongolian Free Variation Selectors during matching

    Fixes https://github.com/behdad/harfbuzz/issues/234

 src/hb-ot-layout-gsubgpos-private.hh		    |	2 +-
 src/hb-ot-layout-private.hh			    |  23
 +++++++++++++++++++--
 src/hb-ot-shape-complex-arabic.cc		    |	2 +-
 .../a34a7b00f22ffb5fd7eef6933b81c7e71bc2cdfb.ttf   | Bin 0 -> 3700 bytes
 .../tests/mongolian-variation-selector.tests	    |	1 +
 5 files changed, 24 insertions(+), 4 deletions(-)

commit 21ab5501f5f5267d20cf23256866dd9d82a667ef
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Apr 26 16:02:04 2016 -0700

    Move ZWJ/ZWNJ bits to top byte of unicode_props()

    To make room to remember Mongolian Free Variation Selectors.
    Part of fixing https://github.com/behdad/harfbuzz/issues/234

 src/hb-ot-layout-private.hh | 40 ++++++++++++++++++++++------------------
 1 file changed, 22 insertions(+), 18 deletions(-)

commit de508516cb06ddb064d75bd7be8e843a5ebcf70d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Apr 26 11:28:37 2016 -0700

    [util] Print out --debug buffer to stderr

 util/main-font-text.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 29393884b9f045460fb65d6ad10a94461ba93430
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Apr 26 10:35:23 2016 -0700

    Annotate blacklisted fonts with their sha1sum

 src/hb-ot-layout.cc | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

commit 14bb4a56971fd45063cd6c1288d911627088abb2
Merge: 1c625df 5069062
Author: Sascha Brawer <sascha@brawer.ch>
Date:	Tue Apr 26 11:38:16 2016 +0200

    Merge pull request #245 from KonstantinRitt/fixes/ce

    Unbreak build on Windows CE

commit 5069062d0a9342bb716eebf3ddc1efad91924caa
Author: Konstantin Ritt <ritt.ks@gmail.com>
Date:	Tue Apr 26 12:02:26 2016 +0400

    Unbreak build on Windows CE

    0475ef2f97e3035a2eea9a0f96031331e07e8e29 broke the build by using
    vsnprintf(), which is not defined on Windows CE

 src/hb-private.hh | 1 +
 1 file changed, 1 insertion(+)

commit 1c625dff2269c54ff429ca45be88893ff1fa6c34
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Apr 9 12:53:23 2016 -0700

    Minor

 src/hb-ot-layout.cc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 851b0db36d1b724fc1e0db506445119c78186285
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Apr 8 23:46:55 2016 -0700

    Minor.  We should never get to this branch, but fix it anyway.

 src/hb-ot-layout-common-private.hh | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 00ea66f35754a1e6e4d3b7b139d611a9a623a9d1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Apr 8 13:51:01 2016 -0700

    1.2.6

 NEWS	      | 10 ++++++++++
 configure.ac |  2 +-
 2 files changed, 11 insertions(+), 1 deletion(-)

commit 4f3d59a1877dcb94d09da48e9694a6c1b05a86fe
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Apr 8 13:41:20 2016 -0700

    Blacklist another set of timesi.ttf and timesbi.ttf

 src/hb-ot-layout.cc | 2 ++
 1 file changed, 2 insertions(+)

commit ef476be80d773332e0c768a3465d99381d76edd9
Merge: a0331b5 d3134a6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Apr 8 13:16:33 2016 -0700

    Merge pull request #239 from ebraminio/dwfix

    Improve DirectWrite backend

commit d3134a66ad551ded726db9528d3c25459088f105
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Tue Apr 5 21:01:05 2016 +0000

    Fix when no feature is given

 src/hb-directwrite.cc | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit a0331b55f7b45437980e1fc323251f4091bf2c4e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Apr 4 16:25:32 2016 -0700

    1.2.5

 NEWS	      | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit 6e55199b5f097ac93bad38f32e9813e2da14c5a7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Apr 4 16:24:27 2016 -0700

    Add test for 6dd80faf0dcb3e8a8915c3a25da44e2a67cb0cd8

 test/shaping/Makefile.am				 |   1 +
 .../f22416c692720a7d46fadf4af99f4c9e094f00b9.ttf	 | Bin 0 ->
 16736 bytes
 test/shaping/tests/mark-filtering-sets.tests		 |   5 +++++
 3 files changed, 6 insertions(+)

commit 59089622dbb8dda783b1639c932123f125c3592d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Apr 4 14:54:32 2016 -0700

    [coretext] Clarify comment

 src/hb-coretext.cc | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit 6dd80faf0dcb3e8a8915c3a25da44e2a67cb0cd8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Apr 4 14:34:25 2016 -0700

    Fix FixedVersion::to_int()

    Ouch.  Had broken it in 9a13ed453ef96822a47d6e6f58332b87f38d5c59

    Fixes https://github.com/behdad/harfbuzz/issues/238
    Will add test soon.

 src/hb-open-type-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4a104021697439fd21390a1f4cdc9310348882fa
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Sat Apr 2 13:47:59 2016 +0000

    Hide justification behind HB_DIRECTWRITE_EXPERIMENTAL_JUSTIFICATION

 src/hb-directwrite.cc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 63ee9ca5d81b53eb035972754ed95572821c393c
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Fri Apr 1 15:47:07 2016 +0000

    Use standard types instead Windows favourites ones

 src/hb-directwrite.cc | 100
 +++++++++++++++++++++++++-------------------------
 1 file changed, 50 insertions(+), 50 deletions(-)

commit adf20ba0d18d1506e633dcd9b4827a6c93abcadd
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Fri Apr 1 15:36:40 2016 +0000

    Limit GetJustifiedGlyphs only to scripts with custom justification
    character

 src/hb-directwrite.cc | 98
 +++++++++++++++++++++++++++++++--------------------
 1 file changed, 60 insertions(+), 38 deletions(-)

commit 32ae9d1b3ffbe7e26e654437a56a26a95fe9f5a6
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Fri Apr 1 06:39:57 2016 +0000

    Add justification support

 src/hb-directwrite.cc | 321
 ++++++++++++++++++++++++++++++++------------------
 1 file changed, 205 insertions(+), 116 deletions(-)

commit 10c3d9e41520595c88dd2a8321590e03ce8fcf47
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Thu Mar 31 18:19:44 2016 +0000

    Basic opentype features support

 src/hb-directwrite.cc | 62
 ++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 42 insertions(+), 20 deletions(-)

commit d129897120d3ad414220d603557c15a60aa69fa6
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Thu Mar 31 13:45:37 2016 +0000

    Refactor and remove dupe getglyphs call

 src/hb-directwrite.cc | 106
 ++++++++++++++++++++++++--------------------------
 1 file changed, 51 insertions(+), 55 deletions(-)

commit 5f1a8961008b93f72acc47336109af3a64e248d0
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Thu Mar 31 12:26:16 2016 +0000

    Better glyph offset support

 src/hb-directwrite.cc | 44 ++++++++++++++++++++++++--------------------
 1 file changed, 24 insertions(+), 20 deletions(-)

commit d691ba3f405738c6857450752b8cc0911dfcdb01
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Wed Mar 30 20:21:40 2016 +0000

    Don't fail when language is not set

 src/hb-directwrite.cc | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 1c00a46c7a608ebc0b03c5abfcfe7f2b9881d0df
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Wed Mar 30 20:15:09 2016 +0000

    Make DirectWrite backend to work with different font sizes

    Actually copyedited same logic from Uniscribe to make it just work

 src/hb-directwrite.cc | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 0251b0cc5c39272d2299d4b2ab802faaafe96837
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Mar 17 14:37:11 2016 -0700

    1.2.4

 NEWS	      | 15 +++++++++++++++
 configure.ac |  2 +-
 2 files changed, 16 insertions(+), 1 deletion(-)

commit 69f9fbc4200442a35484d3c790ae8f4979be5d60
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Mar 17 11:59:43 2016 -0700

    Synthesize GDEF glyph class for any glyph that does not have one
    in GDEF

    Previously we only synthesized GDEF glyph classes if the glyphClassDef
    array in GDEF was null.  This worked well enough, and is indeed what
    OpenType requires: "If the font does not include a GlyphClassDef
    table,
    the client must define and maintain this information when using the
    GSUB and GPOS tables."  That sentence does not quite make sense since
    one needs Unicode properties as well, but is close enough.

    However, looks like Arial Unicode as shipped on WinXP, does have GDEF
    glyph class array, but defines no classes for Hebrew.  This results
    in Hebrew marks not getting their widths zeroed.  So, with this
    change,
    we synthesize glyph class for any glyph that is not specified in the
    GDEF glyph class table.  Since, from our point of view, a glyph not
    being listed in that table is a font bug, any unwanted consequence of
    this change is a font bug :).

    Note that we still don't get the same rendering as Uniscribe, since
    Uniscribe seems to do fallback positioning as well, even though the
    font does have a GPOS table (which does NOT cover Hebrew!).  We are
    not going to try to match that though.

    Test string for Arial Unicode:

	U+05E9,U+05B8,U+05C1,U+05DC

    Before:		[gid1166=3+991|gid1142=0+737|gid5798=0+1434]
    After:		[gid1166=3+991|gid1142=0+0|gid5798=0+1434]
    Uniscribe:	[gid1166=3+991|gid1142=0@348,0+0|gid5798=0+1434]

    Note that our new output matches what we were generating until July
    2014, because the Hebrew shaper used to zero mark advances based on
    Unicode, NOT GDEF.	That's 9e834e29e0b657f0555df1ab9cea79ff7abcf08d.

    Reported by Greg Douglas.

 src/hb-ot-layout-gsub-table.hh | 22 ++++++++++++++++++++--
 src/hb-ot-shape.cc		| 29 -----------------------------
 2 files changed, 20 insertions(+), 31 deletions(-)

commit fef5dd9a72f326c160a7194f558749d24bac7283
Merge: 01ea9ea 5f995db
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Mar 12 19:15:15 2016 -0800

    Merge pull request #232 from c0nk/wip-icu

    Add --with-icu=builtin option; fix compile error

commit 01ea9eaac373d9f3de6e56c1ca26cdcd259ecc8e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Mar 11 18:50:02 2016 -0800

    [build] Use tar-ustar instead of tar-pax

    The default tar-v7 is not good enough for us (99 char filename
    limit), so I have had bumped to tar-pax.  We got one complaint
    that someone's tar couldn't handle tar-pax.  Set to tar-ustar
    which is ~13 years earlier than tar-pax and is good enough for us.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3e10460a1dd41de32752e308771aa30d23565cc0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Mar 11 18:45:19 2016 -0800

    Minor comment

 src/hb-unicode-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d14fea4bdcc1423fe9a585af3abdefa9605d17e6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Mar 8 12:16:41 2016 -0800

    Remove default clause in minor switch statements

    Bending to clang warnings...
    https://bugs.chromium.org/p/chromium/issues/detail?id=593057

 src/hb-ot-shape-complex-indic.cc | 4 ----
 src/hb-ot-shape-complex-thai.cc  | 1 -
 2 files changed, 5 deletions(-)

commit ce8ae9970102f83b67bb1e8e8b2bf894a0e26c07
Merge: 731a430 71248a8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Mar 4 17:20:35 2016 -0800

    Merge pull request #231 from KonstantinRitt/post123buildfix

    Fix build with HB_DISABLE_DEPRECATED

commit 731a430cd36caabcef04e099b21ebc6daedd536f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Mar 2 13:32:42 2016 -0800

    Fix requiredFeature stage handling logic

    Originally the way Jonathan had written this was correct in
    "continue"ing:

    https://github.com/jfkthame/harfbuzz/commit/35e28c7a733eaffcd9f062b18d7db9fbb3d990fc#diff-ead86a33a5cc9ad7f6e6381031a0baddR199

    When I rewrote his patch, I messed it up:

    https://github.com/behdad/harfbuzz/commit/da132937989acb4d8ca9bd41c79f98750e7dda30#diff-ead86a33a5cc9ad7f6e6381031a0baddR209

    the intended behavior was NOT to set found=TRUE and NOT to continue.
    This was resulting in feature_index[table_index] being left unset.
    Oops!

 src/hb-ot-map.cc | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 68b6296d3333fd38bd5442d2ba087ced481603bc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Mar 1 16:41:53 2016 +0900

    Add F2DOT14 type

 src/hb-open-type-private.hh | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 082b79fe9f06607998178dcdcbe817af28b017de
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Mar 1 16:41:26 2016 +0900

    Use FWORD and UFWORD when it makes sense

    I had forgotten about those types.

 src/hb-ot-glyf-table.hh | 8 ++++----
 src/hb-ot-hmtx-table.hh | 6 +++---
 2 files changed, 7 insertions(+), 7 deletions(-)

commit 5f995db10381172ec63fd7ffbb0acf2c6b3dae5e
Author: Kal Conley <kcconley@gmail.com>
Date:	Fri Feb 26 00:36:17 2016 +0100

    Fix missing ICU #include

    Fix compile error in hb-icu.cc when ICU configured with
    U_NO_DEFAULT_INCLUDE_UTF_HEADERS=1

 src/hb-icu.cc | 1 +
 1 file changed, 1 insertion(+)

commit b424b6c372dfe4c0ed75a49761eb34a416819446
Author: Kal Conley <kcconley@gmail.com>
Date:	Fri Feb 26 00:35:15 2016 +0100

    Add --with-icu=builtin configure option

 configure.ac	 | 33 +++++++++++++++++++--------------
 src/Makefile.am |  7 +++++++
 2 files changed, 26 insertions(+), 14 deletions(-)

commit 71248a843f976c86022eb5bb8c6e8880b2499937
Author: Konstantin Ritt <ritt.ks@gmail.com>
Date:	Thu Feb 25 18:55:28 2016 +0400

    Fix build with HB_DISABLE_DEPRECATED

    When HB_DISABLE_DEPRECATED is defined, no code from hb-deprecated.h
    should be used, even from within HB itself.

 src/hb-font.cc | 4 ++++
 1 file changed, 4 insertions(+)

commit 0c7fb7419c20d04b803412945565562c32b42929
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 14:40:09 2016 +0900

    Speed up buffer variable allocation sanity check

    This makes defining HB_NDEBUG much less relevant, to the
    point of irrelevance.  Sorry about all the fuss in previous
    release!

 src/hb-buffer-private.hh | 67
 ++++++++++++++++++++++++++++-----------------
 src/hb-buffer.cc	  | 70
 ------------------------------------------------
 2 files changed, 43 insertions(+), 94 deletions(-)

commit 91dd11565221bdb108c138662ea013aac14bb968
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 13:56:47 2016 +0900

    Add HB_NDEBUG

    API changes:
    - If NDEBUG is defined, define HB_NDEBUG
    - Disable costlier sanity checks if HB_NDEBUG is defined.

    In 1.2.3 introduced some code to disable costly sanity checks if
    NDEBUG is defined.	NDEBUG, however, disables all assert()s as
    well.  With HB_NDEBUG, one can disable costlier checks but keep
    assert()s.

    I'll probably add a way to define HB_NDEBUG automatically in
    release tarballs.  But for now, production systems that do NOT
    define NDEBUG, are encouraged to define HB_NDEBUG for our build.

 src/Makefile.am	  | 2 +-
 src/hb-buffer-private.hh | 4 ++--
 src/hb-buffer.cc	  | 4 ++--
 src/hb-private.hh	  | 9 +++++++++
 4 files changed, 14 insertions(+), 5 deletions(-)

commit 75568b0a7f811ea18e23037735ec8541a7431f88
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 12:26:26 2016 +0900

    1.2.3

 NEWS	      | 42 ++++++++++++++++++++++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 43 insertions(+), 1 deletion(-)

commit 988165021f8d48dc7120b071d056491256569f4f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 12:23:02 2016 +0900

    Disable internal buffer variable bookkeeping in NDEBUG builds

    Saves some sweet time and binary size!

 src/Makefile.am	  |  1 +
 src/hb-buffer-private.hh | 30 ++++++++++++++++++++----------
 src/hb-buffer.cc	  |  6 ++++--
 3 files changed, 25 insertions(+), 12 deletions(-)

commit 94dd0bb7e78125994cb7c833a5b03110f1ffc822
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 11:31:03 2016 +0900

    Add blacklist signature for Times New Roman (Bold) Italic on OS X

 src/hb-ot-layout.cc | 2 ++
 1 file changed, 2 insertions(+)

commit dd8598c1c7f29fc92253b0cd4e856c1941b1d0c0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 11:20:05 2016 +0900

    [test] Pass closure to hb_font_set_glyph_func()

    Exercises fix in c335fd7986fe360ab8e1c032c9b988d0d30511eb

 test/api/test-shape.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e23cf902e91142a10229e3514be4ceee69efde04
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 11:11:15 2016 +0900

    Blacklist GDEF table of timesi.ttf and timesbi.ttf on Win 7

    See discussion:
    https://lists.freedesktop.org/archives/harfbuzz/2016-February/005489.html

 src/hb-ot-layout.cc | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)

commit c335fd7986fe360ab8e1c032c9b988d0d30511eb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 25 09:16:05 2016 +0900

    In trampoline implementation of get_glyph(), don't destroy user
    data twice!

 src/hb-font.cc | 41 +++++++++++++++++++++++++++--------------
 1 file changed, 27 insertions(+), 14 deletions(-)

commit 23335deaad9d4d9824ff41343264514d3f9f7e37
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 20:27:13 2016 +0900

    [ot-font] Accelerate cmap format4 get_glyph

 src/hb-ot-cmap-table.hh | 111
 ++++++++++++++++++++++++++++--------------------
 src/hb-ot-font.cc	 |  14 +++++-
 2 files changed, 77 insertions(+), 48 deletions(-)

commit e0f16a715bc3e621ff21a8be88102e9672630574
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 19:52:36 2016 +0900

    [ot-font] Towards accelerating get_glyph()

 src/hb-ot-font.cc | 23 ++++++++++++++++++++---
 1 file changed, 20 insertions(+), 3 deletions(-)

commit 5473ebfb84c7b6059ac16e04676b363acc51aa00
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 19:32:43 2016 +0900

    [ot-font] Remove level of indirection in get_glyph_variant

 src/hb-ot-cmap-table.hh | 14 ++------------
 src/hb-ot-font.cc	 | 13 +++++++++----
 2 files changed, 11 insertions(+), 16 deletions(-)

commit 49fe6ecf19522413e79a11a29aa0ffc5bdfcd2f8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 19:10:06 2016 +0900

    [TODO] Update

    This file is rather obsolete.  Still, give it a refresh.

 TODO | 16 ++--------------
 1 file changed, 2 insertions(+), 14 deletions(-)

commit 8b5bc141cd3a6bfcea3c91a882a630426876ceb3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 19:05:23 2016 +0900

    Add get_nominal_glyph() and get_variation_glyph() instead of
    get_glyph()

    New API:
    - hb_font_get_nominal_glyph_func_t
    - hb_font_get_variation_glyph_func_t
    - hb_font_funcs_set_nominal_glyph_func()
    - hb_font_funcs_set_variation_glyph_func()
    - hb_font_get_nominal_glyph()
    - hb_font_get_variation_glyph()

    Deprecated API:
    - hb_font_get_glyph_func_t
    - hb_font_funcs_set_glyph_func()

    Clients that implement their own font-funcs are encouraged to replace
    their get_glyph() implementation with a get_nominal_glyph() and
    get_variation_glyph() pair.  The variation version can assume that
    variation_selector argument is not zero.

 src/hb-deprecated.h		    |  10 ++
 src/hb-fallback-shape.cc	    |	4 +-
 src/hb-font-private.hh		    |  26 +++--
 src/hb-font.cc			    | 203
 ++++++++++++++++++++++++++++++++++---
 src/hb-font.h			    |  55 +++++++---
 src/hb-ft.cc			    |  38 ++++---
 src/hb-ot-font.cc		    |  57 +++++++----
 src/hb-ot-shape-complex-indic.cc   |	8 +-
 src/hb-ot-shape-complex-myanmar.cc |	2 +-
 src/hb-ot-shape-complex-use.cc     |	2 +-
 src/hb-ot-shape-fallback.cc	    |	6 +-
 src/hb-ot-shape-normalize.cc	    |  18 ++--
 src/hb-ot-shape.cc		    |	6 +-
 13 files changed, 344 insertions(+), 91 deletions(-)

commit b30a971bf792b9c683c345e1be25c5a5869a113c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 17:32:22 2016 +0900

    1.2.2

 NEWS	      | 14 +++++++++++++-
 configure.ac |  2 +-
 2 files changed, 14 insertions(+), 2 deletions(-)

commit af48e3d27c01c538f46f1dc376d994a0c24a8170
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 16:06:40 2016 +0900

    Fix recent test

    Not sure why the FT functions were returning advance 1024.	This
    caused failure on drone.io.  Switch to hb-ot-font and disable
    glyph names.

 test/shaping/tests/cursive-positioning.tests | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 17c831701756bb46300c412fd64b19d67f299c18
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 16:06:23 2016 +0900

    [tests] Fix for multiple options in test runner scripts

 test/shaping/run-tests.sh | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit ebd7431f824c718db6ce5b85e94f2b3911127af4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 15:53:40 2016 +0900

    Partially revert 86c68c7a2c971efe8e35b1f1bd99401dc8b688d2

    That commit moved the advance adjustment for mark positioning to
    be applied immediately, instead of doing late before.  This breaks
    if mark advances are zeroed late, like in Arabic.  Also, easier to
    hit it in RTL scripts since a single mark with non-zero advance is
    enough to hit the bug, whereas in LTR, at least two marks are needed.

    This reopens https://github.com/behdad/harfbuzz/issues/211
    The cursive+mark interaction is broken again.  To be fixed in a
    different way.

 src/hb-ot-layout-gpos-table.hh		      | 28
 ++++++++++++----------------
 test/shaping/tests/cursive-positioning.tests |  2 +-
 2 files changed, 13 insertions(+), 17 deletions(-)

commit 284481b3120963353f5f34ed094f07ffc13480ef
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 15:52:37 2016 +0900

    Add test for mark positioning in rtl with non-zero mark advance

    Apparently I broke this 86c68c7a2c971efe8e35b1f1bd99401dc8b688d2.
    Fix coming.

 .../sha1sum/07f054357ff8638bac3711b422a1e31180bba863.ttf  | Bin 0 ->
 848 bytes
 test/shaping/tests/cursive-positioning.tests		   |   1 +
 2 files changed, 1 insertion(+)

commit 56a84e8dd18c63782b8db3a86e94651dae5bb01b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 15:50:33 2016 +0900

    [tests] Allow commenting out tests to be skipped

 test/shaping/run-tests.sh | 4 ++++
 1 file changed, 4 insertions(+)

commit 7cfd6cc486f2751d7f78c5008a636d677af4e12f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 24 12:30:57 2016 +0900

    [Android.mk] Update with warning flags

 Android.mk | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit dabf32a5ad706726412ba5c64e1ea614a707b928
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 23 15:38:43 2016 +0900

    1.2.1

 NEWS	      | 13 +++++++++++++
 configure.ac |  2 +-
 2 files changed, 14 insertions(+), 1 deletion(-)

commit 525cc7d28cbe4e8149ddba677224f134dc0a3274
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 23 15:19:27 2016 +0900

    Add note re only adding tests with Free Software fonts

 test/shaping/README.md | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 6a09d7e34b949f9929f616ee53278b2edfd9b7ea
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 23 13:47:16 2016 +0900

    [test] Add README about how to add shaping tests

 test/shaping/Makefile.am |  1 +
 test/shaping/README.md   | 37 +++++++++++++++++++++++++++++++++++++
 2 files changed, 38 insertions(+)

commit f8ee7906d0454d950081c621f2b04a6d08e1b92f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 23 13:45:38 2016 +0900

    Remove MANIFEST files

    They are unused currently.	We can add later if we hook them up
    to anything useful.

 test/shaping/fonts/sha1sum/MANIFEST		    | 52
 ----------------------
 test/shaping/tests/MANIFEST			    | 19 --------
 test/shaping/texts/MANIFEST			    |  1 -
 test/shaping/texts/in-tree/MANIFEST		    |  9 ----
 test/shaping/texts/in-tree/shaper-arabic/MANIFEST  |  6 ---
 .../in-tree/shaper-arabic/script-arabic/MANIFEST   |  3 --
 .../script-arabic/language-persian/MANIFEST	    |  1 -
 .../script-arabic/language-urdu/MANIFEST	    |  1 -
 .../script-arabic/language-urdu/crulp/MANIFEST     |  1 -
 .../language-urdu/crulp/ligatures/MANIFEST	    |  7 ---
 .../shaper-arabic/script-arabic/misc/MANIFEST	    |  1 -
 .../script-arabic/misc/diacritics/MANIFEST	    |  7 ---
 .../in-tree/shaper-arabic/script-mandaic/MANIFEST  |  1 -
 .../shaper-arabic/script-mandaic/misc/MANIFEST     |  0
 .../shaper-arabic/script-mongolian/MANIFEST	    |  1 -
 .../shaper-arabic/script-mongolian/misc/MANIFEST   |  4 --
 .../in-tree/shaper-arabic/script-nko/MANIFEST	    |  1 -
 .../in-tree/shaper-arabic/script-nko/misc/MANIFEST |  1 -
 .../in-tree/shaper-arabic/script-phags-pa/MANIFEST |  1 -
 .../shaper-arabic/script-phags-pa/misc/MANIFEST    |  1 -
 .../in-tree/shaper-arabic/script-syriac/MANIFEST   |  1 -
 .../shaper-arabic/script-syriac/misc/MANIFEST	    |  2 -
 test/shaping/texts/in-tree/shaper-default/MANIFEST |  5 ---
 .../shaper-default/script-ethiopic/MANIFEST	    |  1 -
 .../shaper-default/script-ethiopic/misc/MANIFEST   |  1 -
 .../in-tree/shaper-default/script-han/MANIFEST     |  1 -
 .../shaper-default/script-han/misc/MANIFEST	    |  1 -
 .../shaper-default/script-hiragana/MANIFEST	    |  1 -
 .../shaper-default/script-hiragana/misc/MANIFEST   |  2 -
 .../shaper-default/script-linear-b/MANIFEST	    |  1 -
 .../shaper-default/script-linear-b/misc/MANIFEST   |  1 -
 .../shaper-default/script-tifinagh/MANIFEST	    |  1 -
 .../shaper-default/script-tifinagh/misc/MANIFEST   |  1 -
 test/shaping/texts/in-tree/shaper-hangul/MANIFEST  |  1 -
 .../in-tree/shaper-hangul/script-hangul/MANIFEST   |  1 -
 .../shaper-hangul/script-hangul/misc/MANIFEST	    |  1 -
 test/shaping/texts/in-tree/shaper-hebrew/MANIFEST  |  1 -
 .../in-tree/shaper-hebrew/script-hebrew/MANIFEST   |  1 -
 .../shaper-hebrew/script-hebrew/misc/MANIFEST	    |  1 -
 test/shaping/texts/in-tree/shaper-indic/MANIFEST   |  2 -
 .../texts/in-tree/shaper-indic/indic/MANIFEST	    | 11 -----
 .../shaper-indic/indic/script-assamese/MANIFEST    |  2 -
 .../indic/script-assamese/misc/MANIFEST	    |  0
 .../indic/script-assamese/utrrs/MANIFEST	    |  3 --
 .../indic/script-assamese/utrrs/codepoint/MANIFEST |  7 ---
 .../indic/script-assamese/utrrs/gpos/MANIFEST	    |  2 -
 .../indic/script-assamese/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-bengali/MANIFEST     |  2 -
 .../indic/script-bengali/misc/MANIFEST		    |  2 -
 .../indic/script-bengali/utrrs/MANIFEST	    |  3 --
 .../indic/script-bengali/utrrs/codepoint/MANIFEST  |  7 ---
 .../indic/script-bengali/utrrs/gpos/MANIFEST	    |  2 -
 .../indic/script-bengali/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-devanagari/MANIFEST  |  2 -
 .../indic/script-devanagari/misc/MANIFEST	    |  6 ---
 .../indic/script-devanagari/utrrs/MANIFEST	    |  3 --
 .../script-devanagari/utrrs/codepoint/MANIFEST     |  9 ----
 .../indic/script-devanagari/utrrs/gpos/MANIFEST    |  2 -
 .../indic/script-devanagari/utrrs/gsub/MANIFEST    |  1 -
 .../shaper-indic/indic/script-gujarati/MANIFEST    |  2 -
 .../indic/script-gujarati/misc/MANIFEST	    |  0
 .../indic/script-gujarati/utrrs/MANIFEST	    |  3 --
 .../indic/script-gujarati/utrrs/codepoint/MANIFEST |  7 ---
 .../indic/script-gujarati/utrrs/gpos/MANIFEST	    |  2 -
 .../indic/script-gujarati/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-gurmukhi/MANIFEST    |  2 -
 .../indic/script-gurmukhi/misc/MANIFEST	    |  1 -
 .../indic/script-gurmukhi/utrrs/MANIFEST	    |  3 --
 .../indic/script-gurmukhi/utrrs/codepoint/MANIFEST |  7 ---
 .../indic/script-gurmukhi/utrrs/gpos/MANIFEST	    |  2 -
 .../indic/script-gurmukhi/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-kannada/MANIFEST     |  2 -
 .../indic/script-kannada/misc/MANIFEST		    |  2 -
 .../indic/script-kannada/utrrs/MANIFEST	    |  3 --
 .../indic/script-kannada/utrrs/codepoint/MANIFEST  |  8 ----
 .../indic/script-kannada/utrrs/gpos/MANIFEST	    |  1 -
 .../indic/script-kannada/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-malayalam/MANIFEST   |  2 -
 .../indic/script-malayalam/misc/MANIFEST	    |  3 --
 .../indic/script-malayalam/utrrs/MANIFEST	    |  2 -
 .../script-malayalam/utrrs/codepoint/MANIFEST	    |  7 ---
 .../indic/script-malayalam/utrrs/gsub/MANIFEST     |  1 -
 .../shaper-indic/indic/script-oriya/MANIFEST	    |  2 -
 .../shaper-indic/indic/script-oriya/misc/MANIFEST  |  2 -
 .../shaper-indic/indic/script-oriya/utrrs/MANIFEST |  2 -
 .../indic/script-oriya/utrrs/codepoint/MANIFEST    |  9 ----
 .../indic/script-oriya/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-sinhala/MANIFEST     |  2 -
 .../indic/script-sinhala/misc/MANIFEST		    |  4 --
 .../indic/script-sinhala/utrrs/MANIFEST	    |  3 --
 .../indic/script-sinhala/utrrs/codepoint/MANIFEST  |  5 ---
 .../indic/script-sinhala/utrrs/gpos/MANIFEST	    |  1 -
 .../indic/script-sinhala/utrrs/gsub/MANIFEST	    |  7 ---
 .../shaper-indic/indic/script-tamil/MANIFEST	    |  2 -
 .../shaper-indic/indic/script-tamil/misc/MANIFEST  |  1 -
 .../shaper-indic/indic/script-tamil/utrrs/MANIFEST |  3 --
 .../indic/script-tamil/utrrs/codepoint/MANIFEST    | 10 -----
 .../indic/script-tamil/utrrs/gpos/MANIFEST	    |  2 -
 .../indic/script-tamil/utrrs/gsub/MANIFEST	    |  1 -
 .../shaper-indic/indic/script-telugu/MANIFEST	    |  2 -
 .../shaper-indic/indic/script-telugu/misc/MANIFEST |  1 -
 .../indic/script-telugu/utrrs/MANIFEST		    |  3 --
 .../indic/script-telugu/utrrs/codepoint/MANIFEST   |  7 ---
 .../indic/script-telugu/utrrs/gpos/MANIFEST	    |  1 -
 .../indic/script-telugu/utrrs/gsub/MANIFEST	    |  1 -
 .../in-tree/shaper-indic/south-east-asian/MANIFEST |  1 -
 .../south-east-asian/script-khmer/MANIFEST	    |  1 -
 .../south-east-asian/script-khmer/misc/MANIFEST    |  3 --
 test/shaping/texts/in-tree/shaper-myanmar/MANIFEST |  1 -
 .../in-tree/shaper-myanmar/script-myanmar/MANIFEST |  1 -
 .../shaper-myanmar/script-myanmar/misc/MANIFEST    |  3 --
 test/shaping/texts/in-tree/shaper-thai/MANIFEST    |  2 -
 .../texts/in-tree/shaper-thai/script-lao/MANIFEST  |  1 -
 .../in-tree/shaper-thai/script-lao/misc/MANIFEST   |  1 -
 .../texts/in-tree/shaper-thai/script-thai/MANIFEST |  1 -
 .../in-tree/shaper-thai/script-thai/misc/MANIFEST  |  4 --
 test/shaping/texts/in-tree/shaper-tibetan/MANIFEST |  1 -
 .../in-tree/shaper-tibetan/script-tibetan/MANIFEST |  1 -
 .../shaper-tibetan/script-tibetan/misc/MANIFEST    |  1 -
 test/shaping/texts/in-tree/shaper-use/MANIFEST     |  6 ---
 .../texts/in-tree/shaper-use/script-batak/MANIFEST |  1 -
 .../in-tree/shaper-use/script-buginese/MANIFEST    |  1 -
 .../texts/in-tree/shaper-use/script-cham/MANIFEST  |  1 -
 .../in-tree/shaper-use/script-kaithi/MANIFEST	    |  1 -
 .../in-tree/shaper-use/script-kharoshti/MANIFEST   |  1 -
 .../in-tree/shaper-use/script-tai-tham/MANIFEST    |  2 -
 126 files changed, 381 deletions(-)

commit 815bdd7700155efcffa9a4c3ca5bfc31833d0586
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 18:22:44 2016 +0900

    In cluster-level=0, group ZWJ/ZWNJ with previous cluster

    This better emulates Unicode grapheme clusters.

    Note that Uniscribe does NOT do this, but should be harmless with
    most clients,
    and improve fallback with clients that use HarfBuzz cluster as unit
    of fallback.

    Fixes https://github.com/behdad/harfbuzz/issues/217

 src/hb-ot-layout-private.hh			       | 6 ++++++
 src/hb-ot-shape.cc				       | 3 ++-
 test/shaping/tests/indic-joiner-candrabindu.tests     | 2 +-
 test/shaping/tests/mongolian-variation-selector.tests | 2 +-
 4 files changed, 10 insertions(+), 3 deletions(-)

commit 89137e325a19d62fb00979e1e8ab2ca59a2c1147
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 16:00:59 2016 +0900

    Minor

 src/hb-coretext.cc | 2 +-
 src/hb-ot-shape.cc | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 15063b12f7619d4f44981248e28f38c172d12e1f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:56:29 2016 +0900

    [coretext] Move CTFont construction to face_data

 src/hb-coretext.cc | 66
 +++++++++++++++++++++++++-----------------------------
 1 file changed, 30 insertions(+), 36 deletions(-)

commit ba3d49d9a56932d341bf1916a30f322be665e3a6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:50:12 2016 +0900

    [coretext] Move code around

 src/hb-coretext.cc | 70
 +++++++++++++++++++++++++++++++-----------------------
 1 file changed, 40 insertions(+), 30 deletions(-)

commit 90194efb8480d58c55b7a19962624c7aadbdca63
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:42:53 2016 +0900

    [coretext] Move code around

 src/hb-coretext.cc | 46 ++++++++++++++++++++++++++--------------------
 1 file changed, 26 insertions(+), 20 deletions(-)

commit ca539e37a4b71e585a267a288db1a3975cbb99fc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:37:18 2016 +0900

    [build] git.mk fix for m4/gtk-doc.m4

 Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 54788cb1ecc5a5ffd63d07cd1f0b07b2afa9a8ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:32:52 2016 +0900

    [win32] Install git.mk

 win32/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 9a13ed453ef96822a47d6e6f58332b87f38d5c59
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 11:44:45 2016 +0900

    Make FixedVersion a template

 src/hb-open-file-private.hh	      | 4 ++--
 src/hb-open-type-private.hh	      | 9 +++++----
 src/hb-ot-head-table.hh	      | 4 ++--
 src/hb-ot-hhea-table.hh	      | 2 +-
 src/hb-ot-layout-gdef-table.hh       | 2 +-
 src/hb-ot-layout-gsubgpos-private.hh | 2 +-
 src/hb-ot-layout-jstf-table.hh       | 2 +-
 src/hb-ot-maxp-table.hh	      | 2 +-
 8 files changed, 14 insertions(+), 13 deletions(-)

commit 238b943e850ea1ab0093e12c74d2cd7c686f318e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:31:22 2016 +0900

    [coretext] Fix leak!

 src/hb-coretext.cc | 1 +
 1 file changed, 1 insertion(+)

commit e561122856a50ed405d71cb1629317e7ae63f316
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:28:37 2016 +0900

    [coretext] Move code around

 src/hb-coretext.cc | 109
 ++++++++++++++++++++++++++++++-----------------------
 1 file changed, 62 insertions(+), 47 deletions(-)

commit 04c64431530a4a6d9ebd33674c4665a8e6d25bdd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:12:27 2016 +0900

    [coretext] Ignore PPEM in font size selection

 src/hb-coretext.cc | 14 ++++----------
 1 file changed, 4 insertions(+), 10 deletions(-)

commit 62c2711121fe78f373c15c0f53090b62b52d11c1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 15:07:20 2016 +0900

    [coretext] Limit grapheme-cluster forming to cluster-level=0

 src/hb-coretext.cc | 1 +
 src/hb-ot-shape.cc | 2 +-
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 061105ec443eb7350ffe217305f9d8902c179e2f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Feb 22 14:59:39 2016 +0900

    [coretext] Fix shaping with varying font size

    Fixes https://github.com/libass/libass/issues/212

 src/hb-coretext.cc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 27847cab1264b4ce8342603f4626b4e0645979e4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 19 15:56:50 2016 +0700

    1.2.0

 NEWS	      | 20 ++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 21 insertions(+), 1 deletion(-)

commit c3731559042e1730e85d19574321ad850010f7de
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 19 15:13:07 2016 +0700

    [fuzzing] Add test for recent fix

    Test from https://github.com/behdad/harfbuzz/issues/223

    I forgot that we do run hb-fuzzer on tests in
    shaping/tests/fuzzed.tests.

 .../sha1sum/205edd09bd3d141cc9580f650109556cc28b22cb.ttf | Bin 0 ->
 1966 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   1 +
 test/shaping/tests/fuzzed.tests			  |   1 +
 3 files changed, 2 insertions(+)

commit aa33cb72ab29c31e87f0cca9a0e72fe3a68247b7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 19 15:12:24 2016 +0700

    [fuzzing] Make test runner actually work

 test/fuzzing/Makefile.am | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 2735555c6b0c95db7dfc2b391f92a1a5c06084c4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 19 15:12:16 2016 +0700

    [fuzzing] Add TODO item

 test/fuzzing/hb-fuzzer.cc | 1 +
 1 file changed, 1 insertion(+)

commit b87e36f6f119fac80b8fd55f3abae563c2c5b798
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 19 14:52:31 2016 +0700

    Avoid buffer->move_to() in case of buffer error

    Fixes https://github.com/behdad/harfbuzz/issues/223

    Right now we cannot test this because it has to be tested using
    hb-fuzzer.
    We should move all fuzzing tests from test/shaping/tests/fuzzed.tests
    to
    test/fuzzing/ and have its own test runner.  At that point, should add
    test from this issue as well.

 src/hb-buffer.cc		      | 2 ++
 src/hb-ot-layout-gsubgpos-private.hh | 2 +-
 2 files changed, 3 insertions(+), 1 deletion(-)

commit 7e76bbabbaa56af314abff8ddba8866c634919cd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 19 14:43:39 2016 +0700

    [fuzzing] Make "make hb-fuzzer" build lib dependency

    Not going to do with util/, but is convenient here.

 test/fuzzing/Makefile.am | 3 +++
 1 file changed, 3 insertions(+)

commit 568a0c60e8695a6ad8a93ec60d55b137c48890cb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 18 19:31:51 2016 +0700

    Remove pointless overflow check in pointer math

    Fixes https://github.com/behdad/harfbuzz/issues/227

 src/hb-blob.cc | 1 -
 1 file changed, 1 deletion(-)

commit aae2847099cbf05bf0668fbe526fc58736837c1b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 18 17:06:25 2016 +0700

    Emoji skin tone modifiers need to be treated as combining marks

    Fixes https://github.com/behdad/harfbuzz/issues/169

 src/hb-ot-layout-private.hh | 15 ++++++++++++++-
 src/hb-unicode-private.hh   |	5 +++--
 2 files changed, 17 insertions(+), 3 deletions(-)

commit da41e48f0a1a6af6d44ef25185d2421a29bd4166
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 16 17:16:33 2016 +0700

    [USE] Zero mark advances by GDEF early

    This is what Microsoft's implementation does.  Marks that need advance
    need to add it back using 'dist' or other feature in GPOS.
    Update tests to
    match.

 src/hb-ot-shape-complex-use.cc				  |   2 +-
 test/shaping/fonts/sha1sum/MANIFEST			  |   1 +
 .../sha1sum/f518eb6f6b5eec2946c9fbbbde44e45d46f5e2ac.ttf | Bin 0 ->
 1356 bytes
 test/shaping/tests/context-matching.tests		  |   2 +-
 test/shaping/tests/use.tests				  |   2 ++
 5 files changed, 5 insertions(+), 2 deletions(-)

commit 86c68c7a2c971efe8e35b1f1bd99401dc8b688d2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 16 16:07:20 2016 +0700

    [GPOS] Fix interaction of mark attachments and cursive chaining

    Fixes https://github.com/behdad/harfbuzz/issues/211

    What happens in that bug is that a mark is attached to base first,
    then a second mark is cursive-chained to the first mark.  This only
    "works" because it's in the Indic shaper where mark advances are
    not zeroed.

    Before, we didn't allow cursive to run on marks at all.  Fix that.
    We also where updating mark major offsets at the end of GPOS, such
    that changes in advance of base will not change the mark attachment
    position.  That was superior to the alternative (which is what
    Uniscribe
    does BTW), but made it hard to apply cursive to the mark after it
    was positioned.  We could track major-direction offset changes and
    apply that to cursive in the post process, but that's a much trickier
    thing to do than the fix here, which is to immediately apply the
    major-direction advance-width offsets...  Ie.:

    https://github.com/behdad/harfbuzz/issues/211#issuecomment-183194739

    If this breaks any fonts, the font should be fixed to do mark
    attachment
    after all the advances are set up first (kerning, etc).

    Finally, this, still doesn't make us match Uniscribe, for I explained
    in that bug.  Looks like Uniscribe applies minor-direction cursive
    adjustment immediate as well.  We don't, and we like it our way, at
    least for now.  Eg. the sequence in the test case does this:

    - The first subscript attaches with mark-to-base, moving in x only,
    - The second subscript attaches with cursive attachment to first
    subscript
      moving in x only,
    - A final context rule moves the first subscript up by 104 units.

    The way we do, the final shift-up, also shifts up the second subscript
    mark because it's cursively-attached.  Uniscribe doesn't.  We get:

    [ttaorya=0+1307|casubscriptorya=0@-242,104+-231|casubscriptnarroworya=0@20,104+507]

    while Uniscribe gets:

    [ttaorya=0+1307|casubscriptorya=0@-242,104+-211|casubscriptnarroworya=0+487]

    note the different y-offset of the last glyph.  In our view,
    after cursive,
    things move together, period.

 src/hb-ot-layout-gpos-table.hh			    |  31
 +++++++++++----------
 .../706c5d7b625f207bc0d874c67237aad6f1e9cd6f.ttf   | Bin 0 -> 3868 bytes
 test/shaping/fonts/sha1sum/MANIFEST		    |	1 +
 test/shaping/tests/cursive-positioning.tests	    |	1 +
 4 files changed, 18 insertions(+), 15 deletions(-)

commit 80c8855cfeffa028d74a25df884d0e5577c95c6c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Feb 12 12:50:17 2016 +0700

    Minor

 src/hb-common.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6ab920224c32e38072a0bec5e84d4b0d58b74167
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 16:57:52 2016 +0700

    [GPOS] Minor

    No effect.

 src/hb-ot-layout-gpos-table.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit cbc3a76c5a38ab24f72e80357377711bd3f54d56
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 16:48:13 2016 +0700

    [GPOS] Merge fixing of offsets for cursive and mark attachments

    Part of fixing https://github.com/behdad/harfbuzz/issues/211

 src/hb-buffer-private.hh	|  3 +-
 src/hb-ot-layout-gpos-table.hh | 73
 ++++++++++++++++++------------------------
 2 files changed, 33 insertions(+), 43 deletions(-)

commit 7d8d58ac81fe267e29ea68cdc6f4a4fa8c22d40f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 16:34:28 2016 +0700

    [GPOS] Divide position_finish() into two phases, for advances
    and offsets

    Right now the position_finish_advances() is empty.	To be used for
    spacing attachments proposal later.

 src/hb-ot-layout-gpos-table.hh | 11 +++++++++--
 src/hb-ot-layout-gsub-table.hh |  6 ------
 src/hb-ot-layout-private.hh	| 19 +++++++++----------
 src/hb-ot-layout.cc		| 16 ++++++++--------
 src/hb-ot-shape.cc		|  7 +++----
 5 files changed, 29 insertions(+), 30 deletions(-)

commit 8474231567a08873cc5e0aa08fea60316a04c27e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 16:27:41 2016 +0700

    [ot] Minor shuffling code around

 src/hb-ot-layout-gpos-table.hh |  2 --
 src/hb-ot-shape.cc		| 13 ++++++++-----
 2 files changed, 8 insertions(+), 7 deletions(-)

commit b0b11614e9fb9ecd1faae28b0ed71ac6bf5c1266
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 15:28:55 2016 +0700

    [GPOS] Add harmless recursion in fix_mark_attachment()

    Will do nothing.  Just useful for merging two functions.

 src/hb-ot-layout-gpos-table.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 686567baab5a32ffea843538643e01de2885fa4f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 15:25:28 2016 +0700

    [GPOS] Merge attach_chain() and cursive_chain()

    Differentiate, using new attach_type().

 src/hb-ot-layout-gpos-table.hh | 50
 +++++++++++++++++++++++++++---------------
 1 file changed, 32 insertions(+), 18 deletions(-)

commit 806ad8dc65931ab7893bff7d5592a67a9bd237ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 14:53:11 2016 +0700

    [GPOS] Minor shuffling

 src/hb-ot-layout-gpos-table.hh | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 0f6278d1fbb75856132f1fa2d29648979f033316
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 14:49:10 2016 +0700

    [GPOS] Negate sign of attach_lookback(), and rename it to
    attach_chain()

    No behavior change.  Preparing to unify how cursive and mark
    attachments
    work.

 src/hb-ot-layout-gpos-table.hh | 17 +++++++++--------
 1 file changed, 9 insertions(+), 8 deletions(-)

commit 5b5dc2c0406d8180e72d97a54334c722fda325b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 12:15:38 2016 +0700

    [tests] Add test for advance zeroing of an ASCII letter marked as
    mark in GDEF

 test/shaping/fonts/sha1sum/MANIFEST			  |   1 +
 .../sha1sum/a98e908e2ed21b22228ea59ebcc0f05034c86f2e.ttf | Bin 0 ->
 1016 bytes
 test/shaping/tests/zero-width-marks.tests		  |   1 +
 3 files changed, 2 insertions(+)

commit 660c9d3fc21172e8dc340b017122c084dac6334c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Feb 11 12:14:27 2016 +0700

    Remove font-dependent ASCII-only perf hack

    Is confusing.  I already hit it myself.  Remove.  We can optimize
    ASCII based on Unicode properties.	But should not do based on
    assumptions on the font.

 src/hb-ot-shape.cc | 4 ----
 1 file changed, 4 deletions(-)

commit 3fe0cf10401875f1e9b8b5fbaf59826e64ea61d2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 18:43:43 2016 +0700

    Fix previous commit!

 test/shaping/fonts/sha1sum/MANIFEST	   | 6 +++---
 test/shaping/tests/zero-width-marks.tests | 6 +++---
 2 files changed, 6 insertions(+), 6 deletions(-)

commit 293a210eee0a53b59f4b33298f42ec6e59d785e0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 18:39:59 2016 +0700

    [tests] Fix fonts in cc4a78bf22c4a735b84c89b04be3bb531f42135e

    They had an invalid LookupFlag (32).

 .../sha1sum/0dd3a51c3ea50997cb1f72515d1060408f8b4b59.ttf | Bin 1412 ->
 0 bytes
 .../sha1sum/56cfd0e18d07f41c38e9598545a6d369127fc6f9.ttf | Bin 0 ->
 1412 bytes
 .../sha1sum/828114d00931885bc25abf7cdb878b2914a2e743.ttf | Bin 1448 ->
 0 bytes
 .../sha1sum/894e96a367f00c196d82e6243673a1d4414f4f6a.ttf | Bin 1448 ->
 0 bytes
 .../sha1sum/cc5f3d2d717fb6bd4dfae1c16d48a2cb8e12233b.ttf | Bin 0 ->
 1448 bytes
 .../sha1sum/ffa0f5d2d9025486d8469d8b1fdd983e7632499b.ttf | Bin 0 ->
 1448 bytes
 6 files changed, 0 insertions(+), 0 deletions(-)

commit eaadcbbc53e02838c847e53ef214a55d6915d677
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 18:29:54 2016 +0700

    Remove now-unused mark zeroing BY_UNICODE

 src/hb-ot-shape-complex-private.hh |  2 --
 src/hb-ot-shape.cc		    | 29 -----------------------------
 2 files changed, 31 deletions(-)

commit cc4a78bf22c4a735b84c89b04be3bb531f42135e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 18:24:08 2016 +0700

    [tests] Add tests for Latin mark zeroing

 .../sha1sum/0dd3a51c3ea50997cb1f72515d1060408f8b4b59.ttf | Bin 0 ->
 1412 bytes
 .../sha1sum/828114d00931885bc25abf7cdb878b2914a2e743.ttf | Bin 0 ->
 1448 bytes
 .../sha1sum/894e96a367f00c196d82e6243673a1d4414f4f6a.ttf | Bin 0 ->
 1448 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   4 ++++
 .../sha1sum/fcdcffbdf1c4c97c05308d7600e4c283eb47dbca.ttf | Bin 0 ->
 1344 bytes
 test/shaping/tests/zero-width-marks.tests		  |   4 ++++
 6 files changed, 8 insertions(+)

commit 55ff34b9c157a839d026465af8f30424ce7f891b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 18:20:02 2016 +0700

    [tests] Add tests for Thai mark zeroing

 .../sha1sum/45855bc8d46332b39c4ab9e2ee1a26b1f896da6b.ttf | Bin 0 ->
 1088 bytes
 .../sha1sum/7a37dc4d5bf018456aea291cee06daf004c0221c.ttf | Bin 0 ->
 1080 bytes
 .../sha1sum/8099955657a54e9ee38a6ba1d6f950ce58e3cc25.ttf | Bin 0 ->
 1024 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   4 ++++
 .../sha1sum/bb0c53752e85c3d28973ebc913287b8987d3dfe8.ttf | Bin 0 ->
 976 bytes
 test/shaping/tests/zero-width-marks.tests		  |   4 ++++
 6 files changed, 8 insertions(+)

commit b3582a8ee82942a931130a83b2867b239f8ca71a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 18:10:15 2016 +0700

    Change default mark advance zeroing behavior from Unicode to GDEF

    See thread at:
    https://lists.freedesktop.org/archives/harfbuzz/2016-February/005462.html

 src/hb-ot-shape-complex-default.cc | 2 +-
 src/hb-ot-shape-complex-thai.cc    | 2 +-
 src/hb-ot-shape-complex-tibetan.cc | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 43bb2b8fb00705c3334730a58ade7984181018b2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 14:11:43 2016 +0700

    Minor

 test/shaping/hb_test_tools.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bdaa784bb610ec65626d63cc068a0958ff5005fc
Merge: a168db4 f6ffba6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 11:11:36 2016 +0700

    Merge pull request #164 from fanc999/msvc.build

    Enable Build of HarfBuzz under Visual Studio using NMake Makefiles

commit a168db4739148459bc33c7dae88e73efa0153d72
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Feb 10 11:10:08 2016 +0700

    [README] Add ABI Tracker link

 README | 1 +
 1 file changed, 1 insertion(+)

commit f6ffba634bb33d6d4b051abce9c23fcae280c3fe
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Wed Dec 9 14:57:15 2015 +0800

    MSVC builds: Add support to build DirectWrite shaping backend

    Add into the NMake Makefiles to build the DirectWrite shaping backend,
    but as PR #134 mentions, this is considered to be in an experimental
    state,
    so don't include this in the build by default for now.  This is
    most probably
    going to replace the Uniscribe backend eventually, since DirectWrite
    is meant
    to be Uniscribe's replacement, and is needed for Windows Store apps
    if a
    system shaping API is to be used.

 win32/README.txt	 |  4 ++++
 win32/config-msvc.mak	 | 10 ++++++++++
 win32/config.h.win32.in |  3 +++
 win32/info-msvc.mak	 |  7 +++++++
 4 files changed, 24 insertions(+)

commit c6792854557ca104948e8f0b142c9384105b0d05
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Wed Feb 3 18:31:23 2016 +0800

    build: Build the DirectWrite sources if requested

    This adds to the autotools build system so that the (experimental)
    DirectWrite support for HarfBuzz is built (and dist'ed).

 configure.ac	      | 25 +++++++++++++++++++++++++
 src/Makefile.am      |  7 +++++++
 src/Makefile.sources |  3 +++
 3 files changed, 35 insertions(+)

commit d7b6636e5ebf1ddf7d7a04007ffbc411cf7e462e
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Tue Nov 3 19:00:42 2015 +0800

    build: Support Visual Studio builds using NMake

    This adds a set of NMake Makefiles that can be used to build
    HarfBuzz, from
    the standard basic build building the minimal HarfBuzz DLL (consisting
    of OpenType, fallback and Uniscribe support only), to a full
    fledged build
    consisting of GLib and FreeType support, as well as building the
    utilities,
    the test programs in src/ and test/api, and HarfBuzz-ICU and
    HarfBuzz-GObject, and up to building the introspection files.
    This means a
    flexible build mechanism is supported here, so anything that is
    supported
    for a Windows build (code-wise), should all be supported by this build
    system.

    As in an earlier commit, the source listings are shared with the
    autotools
    builds with the various Makefile.sources in src/, src/hb-ucdn and
    util/, and
    this set of NMake Makefiles will transform these lists into the
    form they
    want.

    In the current form, all the test programs in test/api pass, and
    this has
    been checked successfully with 'make -j8 distcheck'.

 BUILD.md			 |   4 +-
 Makefile.am			 |   2 +-
 configure.ac			 |   2 +
 win32/Makefile.am		 |  14 +++
 win32/Makefile.vc		 |  52 +++++++++++
 win32/README.txt		 |  75 ++++++++++++++++
 win32/build-rules-msvc.mak	 | 140 ++++++++++++++++++++++++++++++
 win32/config-msvc.mak		 | 188
 ++++++++++++++++++++++++++++++++++++++++
 win32/create-lists-msvc.mak	 | 151 ++++++++++++++++++++++++++++++++
 win32/create-lists.bat		 |  42 +++++++++
 win32/detectenv-msvc.mak	 | 136 +++++++++++++++++++++++++++++
 win32/generate-msvc.mak	 |  26 ++++++
 win32/hb-introspection-msvc.mak |  42 +++++++++
 win32/info-msvc.mak		 | 130 +++++++++++++++++++++++++++
 win32/install.mak		 |  29 +++++++
 win32/introspection-msvc.mak	 |  73 ++++++++++++++++
 16 files changed, 1104 insertions(+), 2 deletions(-)

commit 5c3e7260bcb4999b8b7cb9afb26e6eaff867634b
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Tue Nov 3 18:52:46 2015 +0800

    MSVC builds: Add a pre-configured config.h(.win32) template

    This adds a pre-configured config.h template that can be used
    for Visual
    Studio builds, where autotools is not normally available.  This has
    the
    configs that are suitable for Visual Studio builds, as well as all the
    features used for Windows builds enabled (HAVE_OT, HAVE_FALLBACK and
    HAVE_UNISCRIBE).

    Note that the optional features are not enabled here, they are
    enabled by
    /D's (or -D's) in the NMake Makefiles as requested.

 win32/config.h.win32.in | 155
 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 155 insertions(+)

commit 35ded3af74a5bc4b038a07308354d5f7501ae3c7
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Tue Nov 3 16:56:27 2015 +0800

    build: Move source listings into separate Makefile snippets

    This moves all the source listings in src/Makefile.am,
    src/hb-ucdn/Makefile.am and util/Makefile.am into separate Makefile
    snippets, so that they may be shared between different Makefile-based
    build systems, such as NMake for Visual Studio.

 src/Makefile.am	      | 165
 +++++++++----------------------------------
 src/Makefile.sources	      | 147 ++++++++++++++++++++++++++++++++++++++
 src/hb-ucdn/Makefile.am      |   6 +-
 src/hb-ucdn/Makefile.sources |   4 ++
 util/Makefile.am	      |  34 ++-------
 util/Makefile.sources	      |  32 +++++++++
 6 files changed, 223 insertions(+), 165 deletions(-)

commit b894a85ad1e7c3ecfb6d3732a7c9779f5462fe70
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 2 16:39:19 2016 +0800

    Fix more hangs in case of buffer allocation errors

    Hopefully
    fixes https://github.com/behdad/harfbuzz/issues/214

 src/hb-ot-shape-complex-indic.cc   | 2 +-
 src/hb-ot-shape-complex-myanmar.cc | 2 +-
 src/hb-ot-shape-complex-use.cc     | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit b693992ea160b66541f678dc9be29b513c77a30b
Merge: 9a6a33c 498574e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Feb 2 12:33:32 2016 +0800

    Merge pull request #222 from n8willis/master

    Add usermanual chapter on cluster levels

commit 498574e6c1a83bbd2768925af6e39806fe1ea8bb
Author: n8willis <nwillis@glyphography.com>
Date:	Thu Jan 28 12:21:32 2016 -0600

    Update Makefile.am

 docs/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit e12fc666994573dbabb6928a8b2e8698667088ce
Author: n8willis <nwillis@glyphography.com>
Date:	Thu Jan 28 12:14:12 2016 -0600

    Added initial usermanual chapter on cluster levels.

 docs/harfbuzz-docs.xml       |   1 +
 docs/usermanual-clusters.xml | 304
 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 305 insertions(+)

commit 9a6a33ccbea8a2e23e779bd955958fa41974c1c7
Merge: d05b783 146fe25
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jan 18 12:47:18 2016 +0100

    Merge pull request #216 from mhosken/master

    Refactor graphite2 to make ovleraps into negative width spaces

commit 146fe252c3ebd0253344ce20981554e40926497b
Author: Martin Hosken <martin_hosken@sil.org>
Date:	Sat Jan 16 17:24:00 2016 -0600

    Refactor graphite2 to make ovleraps into negative width spaces

 src/hb-graphite2.cc | 71
 ++++++++++++++++++++++++++++++++---------------------
 1 file changed, 43 insertions(+), 28 deletions(-)

commit d05b783322d90208b2ddf06a5ebffc7c301be3d7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Jan 12 16:17:21 2016 +0000

    Fix compiler warning

    Fixes https://github.com/behdad/harfbuzz/issues/212

 src/hb-ot-tag.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d163dc18e66c9e2f404d09310482464245cae704
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Jan 12 13:05:01 2016 +0000

    Minor

 src/hb-ot-layout-common-private.hh | 30 +++++++++++++++---------------
 1 file changed, 15 insertions(+), 15 deletions(-)

commit 505b7d4732c6a8c423f43c0de46e05dc583e82c0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jan 11 18:31:04 2016 +0000

    [fuzzing] Fuzz input text

    Very rudimentary right now, but will get kcc's bot going.

    From
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-163580783

 test/fuzzing/hb-fuzzer.cc | 25 +++++++++++++++++++------
 1 file changed, 19 insertions(+), 6 deletions(-)

commit 3e704521f67e021fb51cda7319925fd39eba4f97
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jan 11 17:38:41 2016 +0000

    [OT] Get list of lookup subtables once and loop through them

    This speeds up shaping the Amiri font by over 15%.

    This was primarily needed for my work on OpenType GX, since
    we will be collecting only sublookups that are "active" for
    current font instance; but it's a nice boost in general as
    well.

    We might, in the future, collect subtables in the lookup_accel.
    That would also allow us to do a per-subtbale set-digest, which
    should speed things up some more, specially for ContextChainFormat3
    lookups...	Amiri, for example, contains one lookup with 53
    subtables!

 src/hb-ot-layout.cc | 120
 +++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 81 insertions(+), 39 deletions(-)

commit 11441291bbf4326dca9b14ec3e9cad3d4d229303
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jan 11 13:16:35 2016 +0000

    1.1.3

 NEWS	      | 29 +++++++++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 30 insertions(+), 1 deletion(-)

commit 97624d9244de0fdb9c03f60e03fe242028efa8a1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jan 11 12:58:45 2016 +0000

    [docs] Minor fixes.

 src/hb-buffer.h | 26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

commit a39ff95fce39226e80850ff251cb34a7aad12bd7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Jan 11 12:28:37 2016 +0000

    [coretext] Speed up CoreText font fallback

    Fixes https://code.google.com/p/chromium/issues/detail?id=547912

 src/hb-coretext.cc | 45 ++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 40 insertions(+), 5 deletions(-)

commit 5afebbdcb2dab0e9a42d580df629d8e60b50d2f9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Jan 7 22:53:59 2016 +0000

    Add Homebrew build instructions

 BUILD.md | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit e8a27d79476a5d7a83cf2287d92ca291257546f4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Jan 7 22:52:16 2016 +0000

    Don't build hb-fuzzer in "make", only "make check"

 test/fuzzing/Makefile.am | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 25671466d245449187f8ab17e1a233f1d087d5ed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Jan 7 19:11:41 2016 +0000

    Add 9 reserved entries to hb_font_extents_t

    Might add italic-angle, underline/strikethrough-position/thickness
    in the future.  Do this before new struct goes into a release.

 src/hb-font.h | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit e6d5e4c3106180cb22253c2c278b40f7c4c98f2f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Jan 6 12:29:50 2016 +0000

    [uniscribe] Fix negative advance

    This happens with at least one test font I have.

 src/hb-uniscribe.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 99d34955762d0fff4b66a30e6fbe65fd1cf9976b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Jan 6 12:20:47 2016 +0000

    [test] Add test text for Kaithi

 test/shaping/texts/in-tree/shaper-hangul/MANIFEST	      | 1 +
 test/shaping/texts/in-tree/shaper-hebrew/MANIFEST	      | 1 +
 test/shaping/texts/in-tree/shaper-tibetan/MANIFEST	      | 1 +
 test/shaping/texts/in-tree/shaper-use/MANIFEST		      | 1 +
 test/shaping/texts/in-tree/shaper-use/script-kaithi/MANIFEST | 1 +
 test/shaping/texts/in-tree/shaper-use/script-kaithi/misc.txt | 6 ++++++
 6 files changed, 11 insertions(+)

commit 53c47c85827a7e3ca82000e3baa9aa87c5770ce9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Jan 5 13:26:20 2016 +0000

    Increase sanitize edit count from 8 to 32

    See previous commit.

 src/hb-open-type-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit da2fcfdc51a2cc0d0a782efa6c91b733f7aa84ba
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Jan 5 13:23:45 2016 +0000

    Don't count fixing-up FeatureParams offset as error

    The font Garamond Premier Pro Caption (and possibly many other
    Adobe fonts), have many FeatureParamsSize tables with the old
    wrong offset.  We handle fixing those up, but they were still
    contributing to edit_count, and when I reduced HB_SANITIZE_MAX_EDIT
    from 100 to 8 in 14c2de321826c36037adde859ccca3e2011325a9, these
    fonts were now getting GPOS dropped and hence kerning disabled.

    Fix, by not counting edits made towareds offset fix-up.  I'll
    also increase edit count again, in the next commit.

 src/hb-ot-layout-common-private.hh | 3 +++
 1 file changed, 3 insertions(+)

commit d0adc80965506810820f9ec165b8df80cc8907e3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Jan 2 13:25:18 2016 +0000

    Check magicNumber in head table during sanitize

 src/hb-ot-head-table.hh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 3a48c776701a919e11b067129586e40372d90d54
Merge: 9230911 4b4948d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Jan 2 00:59:14 2016 +0000

    Merge pull request #208 from khaledhosny/travis-trusty

    [travis] Try building on Trusty

commit 4b4948d360a2141e0ffda2994aa308645dc32f59
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Sat Jan 2 00:36:19 2016 +0400

    [travis] Try building on Trusty

    Trusty has gtk-doc 1.20 which has better markdown support which should
    fix some of the brokenness in the newly added documentation. The build
    seems to be as fast as the current container-based build on Precise.

 .travis.yml | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 9230911facf90c06626e54023ca4d99f5e05f1a4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Jan 1 19:06:43 2016 +0000

    [travis] Only run coveralls if testing behdad/harfbuzz

    Fixes failures in others' forks, like:
    https://travis-ci.org/khaledhosny/harfbuzz/jobs/99719710#L3912

 .travis.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6f66f05757d3d5738571b3d4ee40afffb8f26ff9
Merge: bfdf684 9ab9f97
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Jan 1 16:44:01 2016 +0000

    Merge pull request #207 from khaledhosny/docs-4

    [docs] More buffers documentation

commit 9ab9f974d42e0001966e243a23a64e6aefbd4764
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Fri Jan 1 20:38:21 2016 +0400

    [docs] More buffers documentation

 docs/harfbuzz-sections.txt |  4 +-
 src/hb-buffer-serialize.cc | 85
 ++++++++++++++++++++++++++++++-------------
 src/hb-buffer.cc	    | 91
 +++++++++++++++++++++++++++++++++++-----------
 src/hb-buffer.h	    | 78 +++++++++++++++++++++++++--------------
 src/hb-shape.cc	    | 10 +++--
 5 files changed, 187 insertions(+), 81 deletions(-)

commit bfdf684f7957645dd016fbf76700c5911c4bee2d
Merge: d7ed6f5 85c2443
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 22:20:14 2015 +0100

    Merge pull request #205 from khaledhosny/more-docs

    More docs

commit d7ed6f50b4ff13a94701131913d931f13a4d1266
Merge: b758e5e a7f0e25
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 22:20:00 2015 +0100

    Merge pull request #206 from nico/patch-3

    Remove unused HB_SHAPER_DATA_ENSURE_DECLARE lines.

commit a7f0e25dafa90bd21b01c38cb0782ade54b75cdc
Author: Nico Weber <nicolasweber@gmx.de>
Date:	Wed Dec 30 16:05:52 2015 -0500

    Remove unused HB_SHAPER_DATA_ENSURE_DECLARE lines.

    The coretext_aat shaper delegates to the regular coretext_..._ensure()
    functions, so coretext_aat_..._ensure() functions defined by these
    macros are unused. The compiler warns about them, which in turn can
    confuse people to think that the coretext_aat_..._ensure() functions
    weren't called by accident.

 src/hb-coretext.cc | 4 ----
 1 file changed, 4 deletions(-)

commit 85c2443b737335b77c7e9bb6fd6741912f70fcef
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Dec 30 22:57:04 2015 +0400

    [docs] Reduce gtkdoc-check errors

    Now it is just reporting one error about “503 undocumented or
    incomplete
    symbols”, that will be the easy part I guess.

 docs/harfbuzz-docs.xml     | 74
 ++++++++++++++++++++++++++++++++++++++++++++++
 docs/harfbuzz-sections.txt | 40 +++++++++++++++++++++++++
 2 files changed, 114 insertions(+)

commit 9cffe329f15b3a74a3af4e68c1884f1dbda49666
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Dec 30 22:50:08 2015 +0400

    [docs] Typo

 src/hb-buffer.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b758e5ea223eced0fde9a3e62d0fdf04c04914a1
Merge: 266bfa3 8b1224f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 16:44:19 2015 +0100

    Merge pull request #203 from nico/patch-1

    Remove unused `retry:` label.

commit 266bfa3772e75fedcd93db22bf8672a13ad7a7d9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 16:25:48 2015 +0100

    [docs] Minor

 .ci/deploy-docs.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d08035f8f15b7ddd89a318ea34bc386a9e33a8ea
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 16:15:36 2015 +0100

    [docs] Fix up build, really

 .ci/deploy-docs.sh | 9 ++++-----
 .travis.yml	    | 2 +-
 2 files changed, 5 insertions(+), 6 deletions(-)

commit 0d45c3cf63692151166ca7071f755dfaa8922a67
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 16:09:39 2015 +0100

    [docs] Turn bash tracing on

 .ci/deploy-docs.sh | 4 ++++
 1 file changed, 4 insertions(+)

commit 33b2d981a0b12ea165ef9282204a73f4a1ce0477
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 15:56:56 2015 +0100

    [docs] Another try, not sure why the bot isn't building

 .ci/deploy-docs.sh | 13 ++++---------
 1 file changed, 4 insertions(+), 9 deletions(-)

commit f3a051149b3b565b5ad4e489bf730c5203c3549e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 15:45:43 2015 +0100

    [docs] Shuffling code around in deploy-docs.sh

    Temporarily makes it rebuild docs on every change again.

 .ci/deploy-docs.sh | 46 +++++++++++++++++++++++++++-------------------
 1 file changed, 27 insertions(+), 19 deletions(-)

commit 8f31d0a94b27bb658aabe600472fc10bc47885f6
Merge: 9d280cf fb192c2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 30 15:13:37 2015 +0100

    Merge pull request #202 from khaledhosny/doc-fixes

    Doc fixes

commit fb192c263e17081c87f4cc971274d9be42f19513
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Dec 30 15:05:50 2015 +0400

    [docs] A bit more buffers documentation

 docs/harfbuzz-sections.txt |  2 ++
 src/hb-buffer.cc	    |  7 +++---
 src/hb-buffer.h	    | 56
 ++++++++++++++++++++++++++++++++++++++++++++--
 3 files changed, 60 insertions(+), 5 deletions(-)

commit 8ab797c5b86c33eab6ee024471fd3c147325d26a
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Tue Dec 29 17:42:16 2015 +0400

    [docs] A bit more buffers documentation

 docs/harfbuzz-sections.txt | 60 +++++++++++++++---------------
 src/hb-buffer.cc	    | 93
 +++++++++++++++++++++++++++++++---------------
 src/hb-buffer.h	    |  7 +++-
 src/hb-common.cc	    | 43 +++++++++++++--------
 src/hb-common.h	    | 15 +++++---
 5 files changed, 135 insertions(+), 83 deletions(-)

commit f18d2226b62f20d29e6299c01ae8467c725ea971
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Tue Dec 29 15:21:20 2015 +0400

    [docs] Some documentation on buffers

    Some of it (create, reference, destroy) are adapted from Cairo docs.

 docs/harfbuzz-sections.txt |  55 +++++++-------
 src/hb-buffer.cc	    | 174
 +++++++++++++++++++++++++++------------------
 2 files changed, 132 insertions(+), 97 deletions(-)

commit d7bf9d05c519a369a7b3a02e9ed5ecc05a20cd3e
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Tue Dec 29 02:23:24 2015 +0400

    [docs] Fix comment syntax

    To lower the number of gtk-doc warnings.

 .travis.yml	       |  2 +-
 src/hb-directwrite.cc |  4 ++--
 src/hb-ot-layout.cc   | 14 ++++++++++++++
 src/hb-unicode.h      | 16 ++++++++++++++++
 4 files changed, 33 insertions(+), 3 deletions(-)

commit 8b1224f0eece7a5b6846e206333e57ac4653a705
Author: Nico Weber <nicolasweber@gmx.de>
Date:	Mon Dec 28 21:31:28 2015 -0500

    Remove unused `retry:` label.

    Fixes a -Wunused-label warning when building harfbuzz with clang
    -Wall.

 src/hb-coretext.cc | 1 -
 1 file changed, 1 deletion(-)

commit 1f5559293f9bb1b4e911f4bdecf276ff1f6ae01c
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Tue Dec 29 02:15:21 2015 +0400

    [docs] Ignore the new HB_EXTERN decoration

    Otherwise, almost all API functions are not extracted.

 docs/Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 9d280cf49f25181f64c978752f926b79e7c3746a
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Sat Dec 26 06:45:51 2015 +0400

    Fix previous commit

 .ci/deploy-docs.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b789199f107912cfce5e4a95d6152f9a1a7993f2
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Sat Dec 26 06:35:08 2015 +0400

    [travis] Build docs only on tagged revisions

    Lets see if it works…

 .ci/deploy-docs.sh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit e5b90c08a4c1f475560209a5e47628f695606d89
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 25 18:41:41 2015 +0100

    [travis] Remove secure var

    I've set up a secure var for behdad/harfbuzz through Travis web
    interface, no need
    to set the var here.

 .ci/deploy-docs.sh | 2 +-
 .travis.yml	    | 1 -
 2 files changed, 1 insertion(+), 2 deletions(-)

commit e75c1ffdf548185ce1f1df7937f0d028e5e40efe
Merge: 6173c2a d25317f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 25 18:21:08 2015 +0100

    Merge pull request #199 from behdad/travis-docs

    Deploy docs to gh-pages branch from Travis builds

commit 6173c2a6fc6ea0bf812f7f398770b5342974f9bf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 25 18:18:23 2015 +0100

    Fix flaky test

    This test font had a upem of 769, which results in rounding-related
    errors with
    the FreeType font funcs.  Change the upem to 1024 to fix that.

    Fixes https://github.com/behdad/harfbuzz/issues/201

 ...> 1c2fb74c1b2aa173262734c1f616148f1648cfd6.ttf} | Bin 4064 ->
 4064 bytes
 test/shaping/fonts/sha1sum/MANIFEST		    |	2 +-
 test/shaping/tests/ligature-id.tests		    |  70
 ++++++++++-----------
 3 files changed, 36 insertions(+), 36 deletions(-)

commit 3fcae6d82da389c9944386a8ab41eb1c13b99330
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 25 18:18:02 2015 +0100

    [tests] Add --reference, for re-recording tests

 test/shaping/run-tests.sh | 18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit d25317f67f3c5c77f9059961935b0f35cbaa9ac4
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Dec 23 01:29:48 2015 +0400

    Move more docs from FreeDesktop page

 docs/Makefile.am		      |  1 +
 docs/harfbuzz-docs.xml		      | 15 ++++----
 docs/usermanual-install-harfbuzz.xml | 70
 ++++++++++++++++++++++++++++++++++++
 3 files changed, 80 insertions(+), 6 deletions(-)

commit 493a92220844c8996be67c8a7a2c5447942fe2c1
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Dec 23 00:33:41 2015 +0400

    Rename user manual files

    Use chapter ids instead of numbers, so that we can reorder them,
    introduce new ones etc. without the numbers becoming out of date.

 docs/Makefile.am					      | 12
 ++++++------
 docs/harfbuzz-docs.xml					      | 12
 ++++++------
 ... => usermanual-buffers-language-script-and-direction.xml} |  0
 docs/{usermanual-ch04.xml => usermanual-fonts-and-faces.xml} |  0
 ...{usermanual-ch06.xml => usermanual-glyph-information.xml} |  0
 docs/{usermanual-ch02.xml => usermanual-hello-harfbuzz.xml}  |  0
 ...{usermanual-ch05.xml => usermanual-opentype-features.xml} |  0
 .../{usermanual-ch01.xml => usermanual-what-is-harfbuzz.xml} |  0
 8 files changed, 12 insertions(+), 12 deletions(-)

commit 4dc2265918089ee08c6d82eed0cfd41e02d7d231
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Wed Dec 23 00:26:20 2015 +0400

    Intro from freedesktop.org/wiki/Software/HarfBuzz/

 docs/HarfBuzz.png	| Bin 0 -> 3419 bytes
 docs/Makefile.am	|   3 ++-
 docs/harfbuzz-docs.xml |  31 ++++++++++++++++++++++++++++++-
 3 files changed, 32 insertions(+), 2 deletions(-)

commit 22b07782ced6503a0bf33f2fe157b70540238f6d
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Mon Dec 14 23:33:51 2015 +0400

    Deploy docs to gh-pages branch from Travis builds

    Build docs in Travis and push them to the gh-pages branch, which makes
    them available at http://behdad.github.io/harfbuzz/

 .ci/deploy-docs.sh | 25 +++++++++++++++++++++++++
 .travis.yml	    |  4 ++++
 2 files changed, 29 insertions(+)

commit fc38e6034c76d5450f5398d667184bc3696efcc4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 23 14:50:53 2015 +0100

    [layout] Collect coverage glyphs in PairPos

    Apparently class=0 is used for ClassDef1.  See:
    https://github.com/adobe-type-tools/afdko/issues/90

 src/hb-ot-layout-gpos-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8718dae818b22c3933c33bdfc8a7413ef4c3110a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 18 19:53:40 2015 +0000

    [python] Hook up sample debugger

 src/sample.py | 6 ++++++
 1 file changed, 6 insertions(+)

commit 0475ef2f97e3035a2eea9a0f96031331e07e8e29
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 18 18:17:07 2015 +0000

    [buffer] Add debugging, aka, message, API

    Currently just announces lookup applications.  Message-API *will*
    change.
    hb-shape / hb-view are updated to print-out messages to stder
    if --debug
    is specified.

 src/hb-buffer-private.hh | 18 ++++++++++++++++++
 src/hb-buffer.cc	  | 44
 ++++++++++++++++++++++++++++++++++++++++++++
 src/hb-buffer.h	  | 15 +++++++++++++++
 src/hb-ot-layout.cc	  | 12 ++----------
 util/main-font-text.hh   | 18 ++++++++++++++++++
 5 files changed, 97 insertions(+), 10 deletions(-)

commit 9ea0aa43ac5cf243b698aae0ec80241b5efd7488
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 18 17:30:18 2015 +0000

    Don't deserialize positions if buffer has no positions

 src/hb-buffer-serialize.cc | 3 +++
 src/hb-ot-layout.cc	    | 2 --
 2 files changed, 3 insertions(+), 2 deletions(-)

commit 862b1644e9469a7e70555141f53729409d50d0d2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 18 13:54:06 2015 +0000

    [use] Only set syllable-based topographical features if not
    Arabic-joining

 src/hb-ot-shape-complex-use.cc | 3 +++
 1 file changed, 3 insertions(+)

commit 45b7ec365225109eb0854e6c417f48860b5f24af
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 18 13:47:16 2015 +0000

    [indic] Followup fix for Malayalam context matching

    We regeressed Malayalam in 508cc3d3cfcfb0383df0fe795cc28db4e0fd5729
    This brings down the failures to 198 (from 750).

    BENGALI: 353725 out of 354188 tests passed. 463 failed (0.130722%)
    DEVANAGARI: 707307 out of 707394 tests passed. 87 failed (0.0122987%)
    GUJARATI: 366349 out of 366457 tests passed. 108 failed (0.0294714%)
    GURMUKHI: 60732 out of 60747 tests passed. 15 failed (0.0246926%)
    KANNADA: 951190 out of 951913 tests passed. 723 failed (0.0759523%)
    KHMER: 299070 out of 299124 tests passed. 54 failed (0.0180527%)
    MALAYALAM: 1048136 out of 1048334 tests passed. 198 failed
    (0.0188871%)
    ORIYA: 42320 out of 42329 tests passed. 9 failed (0.021262%)
    SINHALA: 271662 out of 271847 tests passed. 185 failed (0.068053%)
    TAMIL: 1091753 out of 1091754 tests passed. 1 failed (9.15957e-05%)
    TELUGU: 970555 out of 970573 tests passed. 18 failed (0.00185457%)
    MYANMAR: 1123865 out of 1123883 tests passed. 18 failed (0.00160159%)

 src/hb-ot-shape-complex-indic.cc | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit 2813e3049a69d64e5395f68c52c4690e1d256d55
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Dec 18 11:05:11 2015 +0000

    [indic] Update data tables to Unicode 8.0

    Test stats remain unchanged, except for Malayalam, which we
    investigate:

    BENGALI: 353725 out of 354188 tests passed. 463 failed (0.130722%)
    DEVANAGARI: 707307 out of 707394 tests passed. 87 failed (0.0122987%)
    GUJARATI: 366349 out of 366457 tests passed. 108 failed (0.0294714%)
    GURMUKHI: 60732 out of 60747 tests passed. 15 failed (0.0246926%)
    KANNADA: 951190 out of 951913 tests passed. 723 failed (0.0759523%)
    KHMER: 299070 out of 299124 tests passed. 54 failed (0.0180527%)
    MALAYALAM: 1047584 out of 1048334 tests passed. 750 failed
    (0.0715421%)
    ORIYA: 42320 out of 42329 tests passed. 9 failed (0.021262%)
    SINHALA: 271662 out of 271847 tests passed. 185 failed (0.068053%)
    TAMIL: 1091753 out of 1091754 tests passed. 1 failed (9.15957e-05%)
    TELUGU: 970555 out of 970573 tests passed. 18 failed (0.00185457%)

    Myanmar, compared to Windows 10 mmrtext.ttf:

    MYANMAR: 1123865 out of 1123883 tests passed. 18 failed (0.00160159%)

 src/gen-indic-table.py			  |   1 +
 src/hb-ot-shape-complex-indic-private.hh |  40 ++--
 src/hb-ot-shape-complex-indic-table.cc   | 372
 ++++++++++++++++++-------------
 src/hb-ot-shape-complex-indic.cc	  |  23 +-
 src/hb-ot-shape-complex-myanmar.cc	  |   4 +
 5 files changed, 244 insertions(+), 196 deletions(-)

commit fc06cff40f136440f6402d0a5e735e2a4a3c062a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 17:47:35 2015 +0000

    Remove HB_OT_SHAPE_ZERO_WIDTH_MARKS_DEFAULT

    The DEFAULT naming wasn't helpful, so just remove it.

 src/hb-ot-shape-complex-default.cc | 2 +-
 src/hb-ot-shape-complex-private.hh | 4 +---
 src/hb-ot-shape-complex-thai.cc    | 2 +-
 src/hb-ot-shape-complex-tibetan.cc | 2 +-
 4 files changed, 4 insertions(+), 6 deletions(-)

commit 508cc3d3cfcfb0383df0fe795cc28db4e0fd5729
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 17:31:17 2015 +0000

    [indic] Allow context when matching for Malayalam new-spec

    Test sequence:
	U+0995,U+09CD,U+09B0

    With Nirmala shipped on Windows 10, this failed to form the below
    form.
    Works now.

    Reported by Sairus.

 src/hb-ot-shape-complex-indic.cc | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

commit eaf1e93ef1ee19a3e72d781e8abbd7f1165c1618
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 16:57:47 2015 +0000

    [uniscribe] Handle E_NOT_SUFFICIENT_BUFFER as well as E_OUTOFMEMORY

    On Windows 10 we are seeing that other error message...

    Test sequence: U+0995,U+-9CD,U+09B0
    With Nirmala shipped on Windows 10, this failed to form the below
    form.
    Works now.

    Reported by Sairus.

 src/hb-uniscribe.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 21e5d7edc4f28157254ef29a8ac247f3a572f6a6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 16:28:38 2015 +0000

    [util] Use O_BINARY instead of _O_BINARY

    The latter doesn't seem to be available in Cygwin.	I'm surprised it
    compiled before...

 util/options.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 100fbeaf196515774c985ee839d0fa0695f9a6fa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 15:23:09 2015 +0000

    Fix ligature component of a mark happening after a ligature within
    a ligature!

    Say, if we are ligating "A B_C m D", then previously 'm' was being
    attached to 'B' in the combined A_B_C_D ligature.  Now we attach it
    to 'C'.  No test for this though :(.

 src/hb-ot-layout-gsubgpos-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2f02fc79a5018e3348fccf366c470803554e1e58
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 15:21:14 2015 +0000

    Improve ligature-component handling

    We use three bits for lig_id these days, so we finally got a report of
    two separate ligatures with the same lig_id happening adjacent to each
    other, and then the component-handling code was breaking things.
    Protect against that by ignoring same-lig-id but lig-comp=0 glyphs
    after
    a new ligature.

    Fixes https://github.com/behdad/harfbuzz/issues/198

 src/hb-ot-layout-gsubgpos-private.hh		    |  12 +++++--
 test/shaping/Makefile.am			    |	1 +
 test/shaping/fonts/sha1sum/MANIFEST		    |	1 +
 .../c78d1f25ea1df1210414f2fe2e0e1e53082bba76.ttf   | Bin 0 -> 4064 bytes
 test/shaping/tests/MANIFEST			    |	1 +
 test/shaping/tests/ligature-id.tests		    |  35
 +++++++++++++++++++++
 6 files changed, 47 insertions(+), 3 deletions(-)

commit 2ab0de9fbd03231b647345b01e31b136e2e00978
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 11:59:15 2015 +0000

    [use] Fix halant detection

    Before, we were just checking the use_category().  This detects as
    halant a ligature that had the halant as first glyph (as seen in
    NotoSansBalinese.)	Change that to use the is_ligated() glyph prop
    bit.  The font is forming this ligature in ccmp, which is before
    the rphf / pref tests.  So we need to make sure the "ligated" bit
    survives those tests.  Since those only check the "substituted" bit,
    we now only clear that bit for them and "ligated" survives.

    Fixes https://github.com/behdad/harfbuzz/issues/180

 src/hb-ot-layout-private.hh			      |   6 ++----
 src/hb-ot-shape-complex-use.cc			      |  19
 ++++++++++++-------
 test/shaping/Makefile.am			      |   1 +
 test/shaping/fonts/sha1sum/MANIFEST		      |   1 +
 .../fbb6c84c9e1fe0c39e152fbe845e51fd81f6748e.ttf     | Bin 0 ->
 2616 bytes
 test/shaping/tests/MANIFEST			      |   1 +
 test/shaping/tests/use.tests			      |   1 +
 7 files changed, 18 insertions(+), 11 deletions(-)

commit 86bcbd65b0d98357fb3d67a2f4f2a704ace55e10
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 17 11:04:33 2015 +0000

    [arabic] Use glyph advance width in apply_stch() instead of extents

    That seems to be what Windows is doing, and makes more sense.

 src/hb-ot-shape-complex-arabic.cc | 24 +++++++-----------------
 1 file changed, 7 insertions(+), 17 deletions(-)

commit f11c11a1f123ef245e59ba892230db14170a8e5a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Dec 16 17:08:36 2015 +0100

    Fix Since: tags for new API

    https://github.com/behdad/harfbuzz/commit/e1d4d0f1dbd8518b5672245c05d73f22a9ed03ea#commitcomment-15006653

 src/hb-font.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 15f2c055c17c54b0a6ae6eef50dcda13c58cda75
Merge: 49e7263 a13b023
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 14 14:19:03 2015 +0100

    Merge pull request #196 from srl295/aix

    AIX fixes

commit a13b023dbfd0532e8cd74c356fbbd4453d0ffaa0
Author: Steven R. Loomis <srloomis@us.ibm.com>
Date:	Fri Dec 11 10:21:27 2015 -0800

    AIX fixes

    - use '-w' instead of '\<...\>' for check-header-guards
      grep manpage says these are the same

    - put '-q' first in the grep options

    - move VAR into hb-private.hh

    - hb-font-private.hh - use [VAR] instead of [] for variable array

 src/check-header-guards.sh  | 5 ++---
 src/hb-font-private.hh      | 2 +-
 src/hb-open-type-private.hh | 3 ---
 src/hb-private.hh	     | 2 ++
 4 files changed, 5 insertions(+), 7 deletions(-)

commit 49e72634af74a9fbad01f42f48e104218413acc0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 10 17:44:19 2015 +0100

    Limit use of AIX intrinsics to IBM's compiler

 src/hb-atomic-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e1d4d0f1dbd8518b5672245c05d73f22a9ed03ea
Merge: 70b33ed 808d3fc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 10 16:56:07 2015 +0100

    Merge branch 'font-extents'

    Fixes https://github.com/behdad/harfbuzz/pull/165

commit 808d3fc0eadd379909f2a0308fd3db474f1efde8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 10 16:55:16 2015 +0100

    [util] Port hb-view to use font metrics from HarfBuzz instead of cairo

 util/helper-cairo.cc |  4 +++-
 util/view-cairo.cc   | 24 ++++++++++++------------
 2 files changed, 15 insertions(+), 13 deletions(-)

commit 31fa3892947138c7950303ea3719bb5ceb813625
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 10 16:38:29 2015 +0100

    [ft] Use ftface->size->metrics for font extent info

 src/hb-ft.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 3ad16048fdd841f31f1cb98d7ff9ea1871841146
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 10 16:37:49 2015 +0100

    [ot-font] Respect OS/2 fsSelection USE_TYPO_METRICS bit

 src/hb-ot-font.cc | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 70b33edae7c8b9c031b83c95f00cb383789f1041
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Dec 10 15:54:42 2015 +0100

    Add atomic ops for AIX

    Patch from Volker Simonis.

 src/hb-atomic-private.hh | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)

commit 98460779bae19e4d64d29461ff154b3527bf8420
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 7 21:38:47 2015 +0100

    Remove final pause from Arabic shaper

    Back in the old days, we used to apply 'calt' and 'cswh' in Arabic
    shaper,
    with a pause in between.  Then we disabled the 'cswh' because
    Microsoft
    disabled it, but forgot to remove the unnecessary pause.  Do that now.

    This has the benefit that it fixes shaping with monbaiti from
    Windows 10.
    In that version of that font, the lookups from 'calt' are duplicated
    in
    'rclt', and Mongolian was changed to go through Universal Shaping
    Engine.
    We still use the Arabic shaper for Mongolian.  With a pause after
    'calt',
    we were applying the duplicate lookups from 'calt' and 'rclt' twice.
    It
    happened to be the case that these lookups were NOT idempotent.  So we
    were getting wrong shaping.  See thread "Windows 10 monbaiti.ttf
    upgrade
    (5.01 -> 5.51) caused loss of diacritical marks when shaped with
    harfbuz"
    on the mailing list.  This fixes that.

 src/hb-ot-shape-complex-arabic.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit dee0fbf9e2eac8b61730efc4978bc10c552b5227
Merge: 255df68 a7ffe35
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 7 10:44:08 2015 +0100

    Merge pull request #192 from behdad/jfkthame-stch

    [issue 191] Make apply_stch() give a more precise fit

commit 255df6801201fb22402420f7b7b7ea8b042df8ba
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 7 10:34:47 2015 +0100

    Fix undefined behavior in cmp function

    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=93274

 src/hb-ot-map-private.hh | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit fcf9e61bad13c828b5482f26491c82db65d91c96
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 7 10:30:43 2015 +0100

    Fix sorting order of ot_languages array

    Looks like the original sort was wrongly done.
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=93275

 src/hb-ot-tag.cc | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit 70952ddb5a29c5bcbb4b6c3a05a428496033234a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 7 10:28:46 2015 +0100

    Add test to make sure ot-languages array is sorted

    Currently fails.  Part of
    https://bugs.freedesktop.org/show_bug.cgi?id=93275

 src/Makefile.am  |  9 ++++++++-
 src/hb-ot-tag.cc | 23 +++++++++++++++++++++++
 2 files changed, 31 insertions(+), 1 deletion(-)

commit 8c37556f730d7e961394075cd863f624af4c53c4
Merge: 8e5f902 f35b3e9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Dec 7 09:34:58 2015 +0100

    Merge pull request #134 from ebraminio/dwrite

    Add working but less prefect DirectWrite backend

commit a7ffe3535836032dba5559080dffeec79473197b
Author: jfkthame <jfkthame@gmail.com>
Date:	Sat Dec 5 17:47:37 2015 +0000

    Make apply_stch() give a more precise fit

    This aims to make Syriac Abbr Mark sizing more accurate when repeating
    segments are used, by adding an extra repeat and tightening up the
    spacing slightly rather than leaving a shortfall corresponding to
    a partial repeat-width.

 src/hb-ot-shape-complex-arabic.cc | 15 ++++++++++++++-
 1 file changed, 14 insertions(+), 1 deletion(-)

commit 8e5f902656d2882d24c30e8b26ddbd3963baa55c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 30 16:53:21 2015 -0800

    src/test.cc: wrong field printed

    Fixes https://github.com/behdad/harfbuzz/issues/188
    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=93182

 src/test.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6f2e6de1fae0ab2269b472a750788817de6c2a6e
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Mon Oct 26 16:23:22 2015 +0900

    Get font ascender and descender metrics from OS/2 table.

 src/hb-font-private.hh |  39 ++++++++++++++++++-
 src/hb-font.cc		| 102
 ++++++++++++++++++++++++++++++++++++++++++++++++-
 src/hb-font.h		|  62 ++++++++++++++++++++++++++++--
 src/hb-ft.cc		|  21 ++++++++++
 src/hb-ot-font.cc	|  58 ++++++++++++++++++++++++++--
 5 files changed, 274 insertions(+), 8 deletions(-)

commit 097c998a0c7b250924801bb69f5fa0c529edd183
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Mon Oct 26 16:22:38 2015 +0900

    Parse the OS/2 table.

 src/Makefile.am	|   1 +
 src/hb-ot-os2-table.hh | 105
 +++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 106 insertions(+)

commit d44d52bd0da033865641dfd39d94852119fd4fd7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 19:35:43 2015 -0500

    1.1.2

 NEWS	      | 15 +++++++++++++++
 configure.ac |  2 +-
 2 files changed, 16 insertions(+), 1 deletion(-)

commit 35d18585fc57750d817f57bfffe569069f9803b5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 19:30:37 2015 -0500

    Fix a few docs blocks

 src/hb-buffer.cc    | 4 ++++
 src/hb-glib.cc      | 2 ++
 src/hb-ot-font.cc   | 2 ++
 src/hb-ot-layout.cc | 6 ++++++
 src/hb-ot-shape.cc  | 4 ++++
 5 files changed, 18 insertions(+)

commit 0e38c918b66df31978d8fd3d8271a9b781384545
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 19:26:26 2015 -0500

    [introspection] Make scanner happy with HB_EXTERN

 src/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit ea512f71084296be3bd893f78650def894066de0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 19:22:22 2015 -0500

    Use C-style casts instead of compare to 0, to convert hb_bool_t
    to bool

 src/hb-common.cc		   | 2 +-
 src/hb-fallback-shape.cc	   | 2 +-
 src/hb-font-private.hh		   | 2 +-
 src/hb-ot-layout.cc		   | 2 +-
 src/hb-ot-map.cc		   | 2 +-
 src/hb-ot-shape-complex-hangul.cc | 2 +-
 src/hb-ot-shape-complex-hebrew.cc | 2 +-
 src/hb-ot-shape-complex-indic.cc  | 4 ++--
 src/hb-ot-shape-normalize.cc	   | 6 +++---
 src/hb-ot-shape.cc		   | 2 +-
 10 files changed, 13 insertions(+), 13 deletions(-)

commit 67a36a725e2a61a096ba0324f359d17f9b02d312
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 18:48:42 2015 -0500

    Fix vertical GPOS

    This was brorken earlier, though, it's really hard to notice it.
    Unlike the glyph_h_origin(), an unset glyph_v_origin() does NOT
    mean that the vertical origin is at 0,0.

    Related to https://github.com/behdad/harfbuzz/issues/187

 src/hb-ot-shape.cc | 13 ++++++++-----
 1 file changed, 8 insertions(+), 5 deletions(-)

commit 1c6a057dd1a52511474630896a597bf8e5215214
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 18:48:30 2015 -0500

    Add tests for previous commit

 test/shaping/Makefile.am				  |   1 +
 .../sha1sum/49c9f7485c1392fa09a1b801bc2ffea79275f22e.ttf | Bin 0 ->
 1496 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   1 +
 test/shaping/tests/MANIFEST				  |   1 +
 test/shaping/tests/simple.tests			  |   2 ++
 5 files changed, 5 insertions(+)

commit c41c145c7386ebe72b1cfb0475d836a689fecc5e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 26 18:43:15 2015 -0500

    Make nil glyph_h_origin() function return true

    Fixes https://github.com/behdad/harfbuzz/issues/187

    Funcs implementations that have a non-zero horizontal origin must
    implement the glyph_h_origin() callback, nothing new here.

    Other implementations (all I know of!) can simply not set
    glyph_h_origin() now.  I did that for hb-ot and hb-ft in
    44f82750807475aa5b16099ccccd917d488df703, though that broke the
    fallback shaper because the default was returning false...

 src/hb-font.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 766963adba6770dcd45de4417481ed8eda60a716
Merge: b344af8 f798b8e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 24 15:38:43 2015 -0600

    Merge pull request #114 from ThePhD/vc++-fixes

    Fix all VC++ warnings and errors

commit b344af80ca95b9eddfd6017aa6ae103388d6b5f8
Merge: 662acd2 835bbdc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 24 15:30:27 2015 -0600

    Merge pull request #177 from fanc999/exporting

    Enable use of compiler directives to export symbols

commit 662acd26d10c38e96a9afcdaab2cb2979794966f
Merge: b24e93e 1979f6f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 24 15:29:44 2015 -0600

    Merge pull request #181 from mhosken/master

    Fix y_scale problems in hb-gr

commit b24e93e3a4d98111c4684fa08e9080b471881d5c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 24 13:18:20 2015 -0600

    1.1.1

 NEWS	      | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit 233944ac91bb81250c0e63150eecfedfaf09f590
Merge: 5a24b1d d538201
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Tue Nov 24 18:37:35 2015 +0400

    Merge pull request #185 from khaledhosny/travis-osx

    [travis] Enable Mac OS X support

commit d538201918e6932ef7645f8d5b2c3491954936f8
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:	Tue Nov 24 12:46:35 2015 +0400

    [travis] Enable Mac OS X support

    Fixes https://github.com/behdad/harfbuzz/issues/182

 .travis.yml | 22 ++++++++++++++++------
 1 file changed, 16 insertions(+), 6 deletions(-)

commit 5a24b1d25c59865e298bf105f54503e79587265c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 23 16:46:14 2015 -0600

    [travis] Remove coverity scan

    I never could get it to work, and it's a proprietary platform.

 .travis.yml | 11 -----------
 README      |	1 -
 2 files changed, 12 deletions(-)

commit 1979f6fedca82fa1e4f65491de491db1aa6dc645
Author: Martin Hosken <martin_hosken@sil.org>
Date:	Mon Nov 23 10:03:56 2015 +0700

    Fix y_scale problems in hb-gr

 src/hb-graphite2.cc | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 835bbdc7c92bd774ff92c42a9277ded72066d29d
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Thu Nov 19 18:34:12 2015 +0800

    Public headers: Decorate public symbols with HB_EXTERN

    This prepares the headers for exporting symbols using visibility
    attributes or __declspec(dllexport), so that we do not need to
    maintain
    symbols listing files, as this is what was and is done in GLib
    and GTK+.

 src/hb-blob.h		     |	24 +++++-----
 src/hb-buffer.h	     | 100 +++++++++++++++++++-------------------
 src/hb-common.h	     |	22 ++++-----
 src/hb-coretext.h	     |	 6 +--
 src/hb-face.h		     |	34 ++++++-------
 src/hb-font.h		     | 114
 ++++++++++++++++++++++----------------------
 src/hb-ft.h		     |	18 +++----
 src/hb-glib.h		     |	 8 ++--
 src/hb-gobject-enums.h.tmpl |	 2 +-
 src/hb-gobject-structs.h    |	26 +++++-----
 src/hb-graphite2.h	     |	 4 +-
 src/hb-icu.h		     |	 6 +--
 src/hb-ot-font.h	     |	 2 +-
 src/hb-ot-layout.h	     |	56 +++++++++++-----------
 src/hb-ot-shape.h	     |	 4 +-
 src/hb-ot-tag.h	     |	 8 ++--
 src/hb-set.h		     |	52 ++++++++++----------
 src/hb-shape-plan.h	     |	18 +++----
 src/hb-shape.h		     |	10 ++--
 src/hb-unicode.h	     |	52 ++++++++++----------
 src/hb-uniscribe.h	     |	 4 +-
 src/hb-version.h.in	     |	 6 +--
 src/hb.h		     |	 4 ++
 23 files changed, 292 insertions(+), 288 deletions(-)

commit f798b8e2d683a1b89b6905b1a8615375b847b468
Author: ThePhD <phdofthehouse@gmail.com>
Date:	Sat Nov 21 16:57:26 2015 -0500

    c-style cast

 src/hb-ot-shape-complex-use.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a6991813659376a6a11c00a9f67d85b4f7ba9b5d
Merge: 1dc32ea f19c6db
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 20 13:28:42 2015 -0800

    Merge pull request #176 from behdad/missing-braces

    Add braces for subobject initializer in _hb_font_funcs_nil

commit 1dc32ea4d2f294f9d1ae1c8fd19fb75f9278223b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 20 13:24:19 2015 -0800

    Whitespace

 src/hb-private.hh | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit f94c0ecbb1488138d3ec3b9d6d9fb78113dfee4f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 20 13:21:29 2015 -0800

    Define HB_MARK_AS_FLAG_T as a macro instead of using templates

    The generic template operator overloading was causing more problems
    than it
    solved.  Eg:

    https://github.com/behdad/harfbuzz/pull/163
    https://github.com/behdad/harfbuzz/issues/175

    So, just use macros.

    Fixes https://github.com/behdad/harfbuzz/issues/175
    Fixes https://github.com/behdad/harfbuzz/pull/178

 src/hb-private.hh | 27 +++++++++++----------------
 1 file changed, 11 insertions(+), 16 deletions(-)

commit f19c6db18e2e2dd0e9a406fc7e8533049fab48b0
Author: jfkthame <jfkthame@gmail.com>
Date:	Fri Nov 20 08:43:49 2015 +0000

    Add braces for subobject initializer in _hb_font_funcs_nil

    To avoid triggering -Wmissing-braces; see
    https://bugzilla.mozilla.org/show_bug.cgi?id=1226175#c8

 src/hb-font.cc | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 9cc1ed4fa68075b3b142a2737438109772dd0002
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 19 12:39:09 2015 -0800

    Do not allow recursiving to same position and same lookup

    This is just to make it harder to be extremely slow.  There definitely
    are ways still, just harder.  Oh well... how do we tame this problem
    without solving halting problem?!

    Fixes https://github.com/behdad/harfbuzz/issues/174

 src/hb-ot-layout-gsubgpos-private.hh			  |   5 +++++
 test/shaping/fonts/sha1sum/MANIFEST			  |   1 +
 .../sha1sum/fab39d60d758cb586db5a504f218442cd1395725.ttf | Bin 0 ->
 1894 bytes
 test/shaping/tests/fuzzed.tests			  |   1 +
 4 files changed, 7 insertions(+)

commit 7d75eee799bbb5ee7eef2651cf7b7d3aee6f09b0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 19 12:03:04 2015 -0800

    [fuzzing] Run fuzzing tests using hb-fuzzer as well

 test/fuzzing/Makefile.am | 4 ++++
 1 file changed, 4 insertions(+)

commit 13188cba7f0eaacd587beeb1c2258526ae24c438
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 19 11:59:03 2015 -0800

    Revert "Fix hang in OOM situations"

    This reverts commit f0599db761d7fc2d585d86e757a797f75ebc7499.

    Commit abadc1717d997b69f987fdf1be9e12156d2d13d6 provides a better
    fix for this.

 src/hb-buffer-private.hh | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

commit 18e1c6b6ef7c85a1b02e3dae86280d8ed6b65118
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 19 11:50:58 2015 -0800

    Revert "Make sure we make progress in OOM situations"

    This reverts commit 68b507a3c3c62c28c38e13fee733702bb703b6ca.

    Commit abadc1717d997b69f987fdf1be9e12156d2d13d6 provides a better
    fix for this.

 src/hb-buffer-private.hh |  7 +++++--
 src/hb-buffer.cc	  | 31 ++++++++-----------------------
 2 files changed, 13 insertions(+), 25 deletions(-)

commit e1118aeac3b5556df0ce502732df8ac92bdac45a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 23:40:47 2015 -0800

    1.1.0

 NEWS	      | 22 ++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 23 insertions(+), 1 deletion(-)

commit 63fe05c8b1cd4f08b525028409e1299f34750810
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 23:52:34 2015 -0800

    Fix make distcheck

 src/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 9b087dec7753ad96d256ce1b9ae347bd8d697c75
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 23:23:35 2015 -0800

    [travis] Only coverity-scan the coverity_scan branch

    This essentially disables coverity-scan right now, until we find
    a pattern to continuously submit branches there.

    For background reasoning, see:
    Fixes https://github.com/behdad/harfbuzz/issues/171

 .travis.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 85062e3b4655ec6d5c3cf5344ce22cd88c21a2aa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 23:09:13 2015 -0800

    Add tests for previous two commits

    To fully test what these are supposed to test, they should be run
    against libharfbuzz-fuzzing.la instead of libharfbuzz.la, but for
    now just record the files.

 .../sha1sum/43979b90b2dd929723cf4fe1715990bcb9c9a56b.ttf | Bin 0 ->
 1804 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   2 ++
 .../sha1sum/b9e2aaa0d75fcef6971ec3a96d806ba4a6b31fe2.ttf | Bin 0 ->
 1804 bytes
 test/shaping/tests/fuzzed.tests			  |   2 ++
 4 files changed, 4 insertions(+)

commit 37b40cd8a18e25d3324f829acec197f016f4a524
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 23:04:45 2015 -0800

    Fix another move_to assertion failure

    If buf->idx is at end, don't set end past it...

    Fixes https://github.com/behdad/harfbuzz/issues/173

 src/hb-ot-layout-gsubgpos-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit abadc1717d997b69f987fdf1be9e12156d2d13d6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 17:52:08 2015 -0800

    Try to better handle OOM situations

    Fixes assert fail in https://github.com/behdad/harfbuzz/issues/161
    with libharfbuzz-fuzzing.

 src/hb-ot-layout-gsubgpos-private.hh |  2 +-
 src/hb-ot-layout.cc		      |  2 +-
 src/hb-ot-shape-complex-hangul.cc    |  2 +-
 src/hb-ot-shape-complex-indic.cc     |  2 +-
 src/hb-ot-shape-complex-thai.cc      |  2 +-
 src/hb-ot-shape-complex-use.cc       |  8 +-------
 src/hb-ot-shape-normalize.cc	      | 10 +++++-----
 src/hb-ot-shape.cc		      |  2 +-
 8 files changed, 12 insertions(+), 18 deletions(-)

commit ec625f7dfb5f6df19d35d81af6605d05e08321f2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 16:37:59 2015 -0800

    Try to fix gnome-continuous build fail

 test/fuzzing/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit ff16ef3379e06afe44b5e78b8893aeae0cee2b5b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 18 16:27:32 2015 -0800

    Enable building a bounded version of the library for fuzzing

    test/fuzzing/hb-fuzzer links against libharfbuzz-fuzzing.so now.

 src/Makefile.am	  | 16 ++++++++++++++++
 test/fuzzing/Makefile.am |  9 ++-------
 test/fuzzing/README	  |  6 ++----
 3 files changed, 20 insertions(+), 11 deletions(-)

commit e0082ae60dbd87d433f3b2b9d2bfa64b9a4c3663
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 17 18:42:13 2015 -0800

    Move things around

 src/hb-private.hh | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit dde8cc87bd880bd35baf764820f4c85bd0a58696
Merge: e97835a 167c327
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 17 18:40:10 2015 -0800

    Merge pull request #163 from fanc999/msvc.src

    Update the sources so they will compile under Visual Studio

commit 167c3271778cd1a8c4433b9d2230901ce17c099e
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Mon Nov 9 17:17:56 2015 +0800

    Fix build on MSVC >= 2012

    Use the DEFINE_ENUM_FLAG_OPERATORS macro in winnt.h on Visual Studio,
    which defines the bitwise operators for the enumerations that we
    want to
    mark as hb_mark_as_flags_t, which will take care of the situation
    on newer
    Visual Studio (>= 2012), where the build breaks with C2057 errors
    as the
    underlying types of the enumerations is not clear to the compiler
    when we
    do a bitwise op within the declaration of the enumerations themselves.

    Also disable the C4200 (nonstandard extension used : zero-sized
    array in
    struct/union) and C4800 ('type' : forcing value to bool 'true' or
    'false'
    (performance warning)) warnings as the C4200 is the intended
    scenario and
    C4800 is harmless but is so far an unavoidable side effect of using
    DEFINE_ENUM_FLAG_OPERATORS.

 src/hb-buffer-private.hh	    |  6 +++---
 src/hb-ot-layout-common-private.hh |  2 +-
 src/hb-ot-layout-private.hh	    |  4 ++--
 src/hb-ot-map-private.hh	    |  2 +-
 src/hb-private.hh		    | 11 +++++++++++
 5 files changed, 18 insertions(+), 7 deletions(-)

commit 4d27bb87468a1b84387e7ce084e3d92c0fc8f065
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Fri Nov 6 14:28:30 2015 +0800

    hb-ot-shape-complex-arabic.cc: Fix build on Visual Studio

    Visual Studio does not like declaring a enum variable within a for
    statement, so fix the build by declaring the enum before doing the for
    loop.

 src/hb-ot-shape-complex-arabic.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit a49e7b7e40127beba25f39ef3c10d7a77e2bb0f0
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Tue Nov 3 18:49:34 2015 +0800

    MSVC builds: Add fallback implementation for pre-2013 MSVC

    Pre-2013 MSVC does not have scalbn() and scalbnf(), which are used
    in the
    utility programs.  Add  fallback implementations for these, which
    can be
    used when necessary.

 util/options.hh | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit 998e8dda938cfef0146f1bfc4e8973a0e12d7d35
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:	Mon Nov 2 16:55:29 2015 +0800

    util: Fix build on Visual Studio

    Use the fallback implementation for lround() only on pre-2013 Visual
    Studio, and ensure we are clear about the types of the parameters for
    lround() and scalbnf(), since Visual Studio can be quite picky on
    ambiguous parameter types.	Also, use g_ascii_strcasecmp() rather than
    strcasecmp() as we are already using GLib for this code and we are
    assured that g_ascii_strcasemp() is available.

    For scalbnf() on pre-2013 Visaul Studio, a fallback implementation is
    needed, but use another forced-included header for those compilers,
    which
    will be added later.

    Also use (char)27 on Visual Studio builds as '\e' is not a recognized
    escape sequence, which will do the same thing.

 util/ansi-print.cc   | 16 +++++++++-------
 util/helper-cairo.cc | 20 ++++++++++----------
 util/options.cc      |  2 +-
 3 files changed, 20 insertions(+), 18 deletions(-)

commit e97835ad43f5c68e8cb29599246cae0f4461d663
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 10 11:37:01 2015 -0800

    [util] Fix crash when --output-file is specified but not
    --output-format

 util/options.hh | 3 +++
 1 file changed, 3 insertions(+)

commit d5f0d7c9fb14255388ab616f56e178cb7ca10ec2
Merge: 04ff23e 529a933
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Nov 7 07:50:58 2015 -0800

    Merge pull request #167 from KonstantinRitt/unicode_cp_opt

    Micro optimizations to UTF-16 and UTF-32 codecs

commit 04ff23e73d847ab3a5da0e9fac4fbca19aefd284
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 16:29:44 2015 -0800

    [arabic] Improve stretch length calculation

    Err on the side of being too short, than too wide.	Reduces chance
    of overlaps with neighboring glyphs.

 src/hb-ot-shape-complex-arabic.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 59821ab8b413df3a444c38b80582a5137e364a70
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 16:27:44 2015 -0800

    [arabic] Don't stretch over cased letters

    Addresses
    https://github.com/behdad/harfbuzz/commit/6e6f82b6f3dde0fc6c3c7d991d9ec6cfff57823d#commitcomment-14248516

 src/hb-ot-shape-complex-arabic.cc		    | 24
 +++++++++++++++++++++-
 src/hb-unicode-private.hh			    | 20
 ------------------
 .../script-syriac/misc/abbreviation-mark.txt	    |  4 ++--
 3 files changed, 25 insertions(+), 23 deletions(-)

commit 5337db29af39084d677a63154f404eca0c20cfeb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 16:18:09 2015 -0800

    Revert "Don't process lookups if buffer is in error"

    This reverts commit f92bd86cc8c11d262d1830c631cb7c63fc9d4bc8.

    We don't want to be like cairo, where as soon as there's an error,
    nothing works anymore.  So, lets process lookups as long as there's
    no new memory needed.  That's also a model that hides fewer bugs.

 src/hb-ot-layout.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 529a93312815dff3c2f37f880bf6ccb428bd3da0
Author: Konstantin Ritt <ritt.ks@gmail.com>
Date:	Sat Nov 7 02:00:04 2015 +0400

    Micro optimization to hb_utf16_t and hb_utf32_t ::prev()

    Implement reverse lookup instead of re-using next()

 src/hb-utf-private.hh | 29 +++++++++++++++++++----------
 1 file changed, 19 insertions(+), 10 deletions(-)

commit 44ae9be7a29eebd6003cad2fdb90b40512a9c8eb
Author: Konstantin Ritt <ritt.ks@gmail.com>
Date:	Sat Nov 7 01:58:38 2015 +0400

    Nano optimization to hb_utf16_t and hb_utf32_t ::next()

 src/hb-utf-private.hh | 17 ++++++-----------
 1 file changed, 6 insertions(+), 11 deletions(-)

commit a6d7668a954a763a053f8af8edbff4731aa43729
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 09:46:54 2015 -0800

    [fuzzing] Cap max buffer len at 128

 test/fuzzing/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit f1c4adbcd3f6275e81e118ddadc9396f82daeccf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 09:46:05 2015 -0800

    Fix typo

 src/hb-buffer-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 68b507a3c3c62c28c38e13fee733702bb703b6ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 00:09:26 2015 -0800

    Make sure we make progress in OOM situations

 src/hb-buffer-private.hh |  7 ++-----
 src/hb-buffer.cc	  | 31 +++++++++++++++++++++++--------
 2 files changed, 25 insertions(+), 13 deletions(-)

commit 5a7eb5d4d862f402136044c19ead87ad098bd78f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Nov 6 00:01:24 2015 -0800

    [fuzzing] Add test case for OOM

    From https://github.com/behdad/harfbuzz/issues/161

 .../sha1sum/3511ff5c1647150595846ac414c595cccac34f18.ttf | Bin 0 ->
 1483 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   2 +-
 test/shaping/tests/fuzzed.tests			  |   1 +
 3 files changed, 2 insertions(+), 1 deletion(-)

commit f0599db761d7fc2d585d86e757a797f75ebc7499
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 23:52:41 2015 -0800

    Fix hang in OOM situations

    Fixes https://github.com/behdad/harfbuzz/issues/161

 src/hb-buffer-private.hh | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit f92bd86cc8c11d262d1830c631cb7c63fc9d4bc8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 23:52:29 2015 -0800

    Don't process lookups if buffer is in error

 src/hb-ot-layout.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4301703bddb63a01651a0d58474bb15ac0ebbcf6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 23:44:59 2015 -0800

    Limit buffer max size growth

    https://github.com/behdad/harfbuzz/issues/161

 src/hb-buffer-private.hh | 11 +++++++++++
 src/hb-buffer.cc	  |  8 ++++++++
 src/hb-ot-shape.cc	  |  6 ++++++
 test/fuzzing/Makefile.am |  2 ++
 4 files changed, 27 insertions(+)

commit 19300183a6f0bac0d23f7a994b40a51e9c90d6e1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 23:08:50 2015 -0800

    [fuzzing] Add build system

 configure.ac		   |  1 +
 test/Makefile.am	   |  2 +-
 test/fuzzing/Makefile.am  | 44
 ++++++++++++++++++++++++++++++++++++++++++++
 test/fuzzing/README	   |  2 ++
 test/fuzzing/hb-fuzzer.cc |  4 ++--
 5 files changed, 50 insertions(+), 3 deletions(-)

commit 9c9ad214af43685b00f6d8493b7807d6607d4e2d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 22:50:52 2015 -0800

    [fuzzer] Add README

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-154202645

 test/fuzzing/README | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 6e6f82b6f3dde0fc6c3c7d991d9ec6cfff57823d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 17:29:03 2015 -0800

    Implement SYRIAC ABBREVIATION MARK with 'stch' feature

    The feature is enabled for any character in the Arabic shaper.
    We should experiment with using it for Arabic subtending marks.
    Though, that has a directionality problem as well, since those
    are used with digits...

    Fixes https://github.com/behdad/harfbuzz/issues/141

 src/hb-ot-shape-complex-arabic.cc		    | 219
 ++++++++++++++++++++-
 src/hb-unicode-private.hh			    |  19 ++
 .../shaper-arabic/script-syriac/misc/MANIFEST	    |	1 +
 .../script-syriac/misc/abbreviation-mark.txt	    |  11 ++
 4 files changed, 244 insertions(+), 6 deletions(-)

commit c743ec5886a1f6d57de26da33a770a8706be83d6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 17:33:57 2015 -0800

    [ft] Fix extents with negative scales

    Fixes https://github.com/behdad/harfbuzz/issues/162

 src/hb-ft.cc | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 73fec3992acb492829bde1d885f1ebeed8dcc133
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 15:22:18 2015 -0800

    Reserve a few scratch-flags bits for complex shapers

 src/hb-buffer-private.hh | 5 +++++
 1 file changed, 5 insertions(+)

commit 136863371c1402769426d892aef1b92f9ca1a25e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 13:24:15 2015 -0800

    Add new shaper method postprocess_glyphs()

    Unused currently.  To be used for Syriac stretch implementation.

    https://github.com/behdad/harfbuzz/issues/141

 src/hb-ot-shape-complex-arabic.cc  | 3 ++-
 src/hb-ot-shape-complex-default.cc | 1 +
 src/hb-ot-shape-complex-hangul.cc  | 7 ++++---
 src/hb-ot-shape-complex-hebrew.cc  | 1 +
 src/hb-ot-shape-complex-indic.cc   | 1 +
 src/hb-ot-shape-complex-myanmar.cc | 2 ++
 src/hb-ot-shape-complex-private.hh | 9 +++++++++
 src/hb-ot-shape-complex-thai.cc    | 1 +
 src/hb-ot-shape-complex-tibetan.cc | 1 +
 src/hb-ot-shape-complex-use.cc     | 1 +
 src/hb-ot-shape.cc		    | 9 ++++++---
 11 files changed, 29 insertions(+), 7 deletions(-)

commit 6c0ebd02c99e7536975ba7194832a1f33abd7faf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Nov 5 11:37:48 2015 -0800

    [util] If font has color, generate PNG with color

 util/helper-cairo.cc | 33 ++++++++++++++++++++++++++-------
 util/helper-cairo.hh |  6 +++++-
 util/view-cairo.cc   |  7 ++++++-
 3 files changed, 37 insertions(+), 9 deletions(-)

commit e95eb23a4ee920eab1e2f4eec9cf490bb431452c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:55:11 2015 -0800

    Don't try zeroing marks by GDEF if there are no non-ASCII

    This one is a hack, but should be ok.

 src/hb-ot-shape.cc | 4 ++++
 1 file changed, 4 insertions(+)

commit 7fa54ed75aa30ae1d6ee9136ccb83b630c24fb65
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:54:49 2015 -0800

    Don't try zeroing mark attachments by Unicode if there's no non-ASCII

 src/hb-ot-shape.cc | 3 +++
 1 file changed, 3 insertions(+)

commit 550bd14d2b21ec2a2b509ff42f4df4341dbf2d46
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:58:58 2015 -0800

    Actually commit changes for previous commit

 src/hb-buffer-private.hh	|  2 ++
 src/hb-ot-layout-gpos-table.hh | 15 ++++++++-------
 2 files changed, 10 insertions(+), 7 deletions(-)

commit ff31b3c1b8a2a21b57dba37eb5bb5db0579e0640
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:42:41 2015 -0800

    Skip GPOS cursive / attachment adjustmnent if none happened

    I'm starting to really like how free these new scratch_flags are.

 src/hb-ot-layout-gpos-table.hh | 3 +++
 1 file changed, 3 insertions(+)

commit 0f407325f6923db11d332585e8250e3646cb74d6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:28:44 2015 -0800

    Minor

 src/hb-ot-shape.cc | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 497a6c2071cd0638e4c6af07621d01335fd963a9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:24:19 2015 -0800

    Skip forming clusters if text is all ASCII

 src/hb-ot-shape.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 28de104f15b80df4b678267c4488b7d09a42720c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 22:00:25 2015 -0800

    Move variable-sized struct member to end

    Hopefully makes clang build happy

 src/hb-font-private.hh | 21 ++++++++++-----------
 src/hb-font.cc		| 20 ++++++++++++++++++++
 2 files changed, 30 insertions(+), 11 deletions(-)

commit 5bc28b5f688ee90d103d052e98bc15d6e0e7e0b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 21:53:16 2015 -0800

    Optimize positioning for when h_origin is nil

 src/hb-ot-shape.cc | 38 ++++++++++++++++++++------------------
 1 file changed, 20 insertions(+), 18 deletions(-)

commit 762770c964f9f0591bf4c44427f73ea3e1c51733
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 21:42:55 2015 -0800

    Add font->has_...() to check for individual nil font funcs

    Hopefully this wouldn't break any compiler.  There was some magic
    moments to getting this to compile...

 src/hb-font-private.hh | 19 +++++++++++++++++--
 src/hb-font.cc		|  7 +++++++
 2 files changed, 24 insertions(+), 2 deletions(-)

commit 88e9a9bcae61421d9dd65715d25e5f20b2847c03
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 21:16:26 2015 -0800

    Minor reshaping of hb_font_funcs_t implementation

    In anticipation of further changes.  No functional changes.

 src/hb-font-private.hh | 80
 ++++++++++++++++++++++++++------------------------
 src/hb-font.cc		|  4 +--
 2 files changed, 43 insertions(+), 41 deletions(-)

commit a6a7715bac8b0c8f5473b84bc649c315ad4d2d51
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 20:51:21 2015 -0800

    Comments

 src/hb-font-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6c48ec830ffac00a920d047ed77acd1b05549074
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 20:47:42 2015 -0800

    [ot] Remove font funcs that do nothing

 src/hb-ot-font.cc | 95
 ++++---------------------------------------------------
 1 file changed, 7 insertions(+), 88 deletions(-)

commit 75ea2daa1d9bbe235cd4a8570efb1913d58c3c62
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 20:43:59 2015 -0800

    [ot] Port ot font funcs to allocated object

 src/hb-ot-font.cc | 47 ++++++++++++++++++++++++++++++++++++++---------
 1 file changed, 38 insertions(+), 9 deletions(-)

commit 44f82750807475aa5b16099ccccd917d488df703
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 20:40:05 2015 -0800

    [ft] Remove font funcs that do nothing

 src/hb-ft.cc | 29 ++++-------------------------
 1 file changed, 4 insertions(+), 25 deletions(-)

commit 7918c261efd283e0428ce7836e9e42768a6aa05c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 20:37:49 2015 -0800

    [ft] Port ft font funcs to allocated object

 src/hb-ft.cc | 45 ++++++++++++++++++++++++++++++++++++---------
 1 file changed, 36 insertions(+), 9 deletions(-)

commit da29b43794cfa3f9a602c34b33c5d8a9c36f87b5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 20:22:44 2015 -0800

    Separate nil font-funcs from parent-peeking font-funcs

    API change: all fonts created with hb_font_create() now inherit from
    (ie have parent) hb_font_get_empty().

 src/hb-font.cc       | 211
 +++++++++++++++++++++++++++++++++++----------------
 test/api/test-font.c |   2 +-
 2 files changed, 145 insertions(+), 68 deletions(-)

commit bee901b38ef3c26a04f69c299c8d5e028a0090e9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 19:28:17 2015 -0800

    Optimize positioning direction calculations

    It makes the binary smaller AND faster.  Yumm!

 src/hb-font-private.hh | 40 +++++++++++++++++++++++++++++++++++++++
 src/hb-ot-shape.cc	| 51
 +++++++++++++++++++++++++++-----------------------
 2 files changed, 68 insertions(+), 23 deletions(-)

commit e3e4bb011ae1a2f1ba05e7ea450595b185304bec
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 18:58:02 2015 -0800

    Don't do fractions if buffer is ASCII-only

 src/hb-buffer-private.hh    | 5 +++--
 src/hb-ot-layout-private.hh | 1 +
 src/hb-ot-shape.cc	     | 3 ++-
 3 files changed, 6 insertions(+), 3 deletions(-)

commit 6986208ba3b395534f4c7bcfa51df6bf9038f717
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 18:46:22 2015 -0800

    Optimize runs without Default_Ignorable's

    Now that we have a buffer-wide scratch flags facility, use it to
    optimize away a few passes.

 src/hb-buffer-private.hh     |  3 ++-
 src/hb-ot-layout-private.hh  |  4 +++-
 src/hb-ot-shape-normalize.cc |  4 ++--
 src/hb-ot-shape.cc	      | 10 ++++++----
 src/hb-private.hh	      |  3 +++
 5 files changed, 16 insertions(+), 8 deletions(-)

commit 14c2de321826c36037adde859ccca3e2011325a9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 18:00:57 2015 -0800

    Limit max edits during sanitize to 8

    Used to be 100.  If a tabe needs more than one or two edits, it's
    probably completely bogus...

    Might help with speeding up fuzzing for
    https://github.com/behdad/harfbuzz/issues/157

 src/hb-open-type-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9cbc39aef962a95b0eba32c24ff9c415d1316d56
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 18:00:53 2015 -0800

    Minor

 src/hb-ot-shape-normalize.cc | 2 ++
 1 file changed, 2 insertions(+)

commit 52e6c4e15893ed1cb0997795912a07b3e446b65a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 17:45:06 2015 -0800

    If font doesn't support U+2011, fall back to U+2010

    Test passes now.

 src/hb-ot-shape-normalize.cc | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 75483aafa6ad02d6391712d082d093823edcd758
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 17:43:36 2015 -0800

    Untangle if/else waterfall

 src/hb-ot-shape-normalize.cc | 40
 +++++++++++++++++++++++++++-------------
 1 file changed, 27 insertions(+), 13 deletions(-)

commit 04fd8517f85ae9aa05b44f25578d2b19abfef7cb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 17:38:22 2015 -0800

    Add tests for hyphen fallback

    U+2011 is <noBreak> equivaent of U+2010, so we should do the fallback
    for it.  Currently fails.

 test/shaping/Makefile.am				   |   1 +
 .../sha1sum/1c04a16f32a39c26c851b7fc014d2e8d298ba2b8.ttf  | Bin 0 ->
 820 bytes
 test/shaping/fonts/sha1sum/MANIFEST			   |   2 ++
 test/shaping/tests/MANIFEST				   |   1 +
 test/shaping/tests/hyphens.tests			   |   2 ++
 5 files changed, 6 insertions(+)

commit 550417117da7e14457a11f49a20145311f58587b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 17:37:30 2015 -0800

    [test] Drop hintings when subsetting fonts to record

 test/shaping/record-test.sh | 1 +
 1 file changed, 1 insertion(+)

commit 49ef630936325b2e56a870fcef9aa8473a8f8526
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 17:27:07 2015 -0800

    Adjust the width of various spaces if font does not cover them

    See discussion here:
    https://github.com/behdad/harfbuzz/commit/81ef4f407d9c7bd98cf62cef951dc538b13442eb

    There's no way to disable this fallback, but I don't think it would
    be needed.	Let's hope for the best!

    Fixes https://github.com/behdad/harfbuzz/issues/153

 src/hb-buffer-private.hh	     |	7 ++++
 src/hb-buffer.cc		     |	2 ++
 src/hb-ot-shape-fallback-private.hh |	4 +++
 src/hb-ot-shape-fallback.cc	     | 67
 +++++++++++++++++++++++++++++++++++++
 src/hb-ot-shape-normalize.cc	     |	1 +
 src/hb-ot-shape.cc		     |	3 ++
 src/hb-unicode-private.hh	     | 56 +++++++++++++++++--------------
 test/shaping/tests/spaces.tests     | 24 ++++++-------
 8 files changed, 126 insertions(+), 38 deletions(-)

commit aa7044de0ceacd71cab19212d266c3a66c03b41e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 16:25:57 2015 -0800

    Generalize flags types

 src/hb-buffer-private.hh	    |  3 +++
 src/hb-ot-layout-common-private.hh |  5 +++++
 src/hb-ot-layout-private.hh	    |  8 +++++---
 src/hb-ot-map-private.hh	    | 16 +---------------
 src/hb-ot-shape.cc		    |  2 +-
 src/hb-private.hh		    | 14 ++++++++++++++
 6 files changed, 29 insertions(+), 19 deletions(-)

commit 7793aad946e09b53523b30d57de85abd1d15f8b6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 14:48:46 2015 -0800

    Normalize various spaces to space if font doesn't support

    This resurrects the space fallback feature, after I disabled
    the compatibility decomposition.  Now I can release HarfBuzz
    again without breaking Pango!

    It also remembers which space character it was, such that later
    on we can approximate the width of this particular space
    character.	That part is not implemented yet.

    We normalize all GC=Zs chars except for U+1680 OGHA SPACE MARK,
    which is better left alone.

 src/hb-ot-layout-private.hh			    |  47
 +++------------------
 src/hb-ot-shape-normalize.cc			    |  12 +++++-
 src/hb-unicode-private.hh			    |  40
 ++++++++++++++++++
 test/shaping/Makefile.am			    |	1 +
 .../1c2c3fc37b2d4c3cb2ef726c6cdaaabd4b7f3eb9.ttf   | Bin 0 -> 316 bytes
 test/shaping/fonts/sha1sum/MANIFEST		    |	1 +
 test/shaping/tests/MANIFEST			    |	1 +
 test/shaping/tests/spaces.tests		    |  17 ++++++++
 8 files changed, 76 insertions(+), 43 deletions(-)

commit 8b3c7f9ede77052225cff8495d660860bf9c7629
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 15:30:48 2015 -0800

    [test] Support recording multiple lines of text in record-test.sh

 test/shaping/record-test.sh | 15 +++++++++++++--
 1 file changed, 13 insertions(+), 2 deletions(-)

commit 85658394809fe0593ab5dfb30fd96118765c7dc5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 14:46:52 2015 -0800

    Protect against possible invalid-memory access after OOM

 src/hb-buffer-private.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 4cc80bed25450af3d84a30ea417fa9275b15e014
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 14:46:10 2015 -0800

    Fix typo!

    Ouch!  Fortunately that function was unused.

 src/hb-buffer-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9ac4b9656dd78ffd129bc3d560a92e2692bc3058
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 14:18:39 2015 -0800

    Add Unicode space category

    Unused so far.

 src/hb-ot-layout-private.hh | 78
 +++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 76 insertions(+), 2 deletions(-)

commit 8249ec3f86510fd24462ce71ed64a6978f0ade17
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 13:26:17 2015 -0800

    Make top-byte of unicode_props available to be used differently per-GC

 src/hb-ot-layout-private.hh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit cc5d3a33882b52f906ee4346707700f5e846d2ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 13:21:25 2015 -0800

    Towards using top-byte of unicode-props for more things

 src/hb-ot-layout-gsubgpos-private.hh | 1 -
 src/hb-ot-layout-private.hh	      | 3 ++-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 2f38dde5a1ea5459789fabaee661cae9235d204e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Nov 4 13:17:33 2015 -0800

    Add _hb_glyph_info_is_unicode_mark()

    Unused right now.

 src/hb-ot-layout-private.hh | 6 ++++++
 1 file changed, 6 insertions(+)

commit 90d75f93bb85aeb627c4e6bb9e4cbd75895c99f7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 3 12:58:12 2015 -0800

    Tighten ccc-setting a bit and document it

 src/hb-ot-layout-private.hh | 12 +++++++++++-
 src/hb-unicode-private.hh   |	5 +++++
 2 files changed, 16 insertions(+), 1 deletion(-)

commit 2f0dfd43cdc2259e6117704f8077ab6951c761e5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 3 12:28:34 2015 -0800

    Fix test expectation

 test/shaping/tests/fuzzed.tests | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit df698f3299d92867e3305715f675b2621c316acd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 3 12:15:12 2015 -0800

    [ot-font] Fix hmtx table length checking, *again*

    Exactly the same problem that I fixed in
    63ef0b41dc48d6112d1918c1b1de9de8ea90adb5

    I rewrote the table checking yesterday in
    67f8821fb25d9bd55719f5e29a582ae1af4b02b3
    and introduced the exact same issue again. :(
    Good thing we have ongoing fuzzing going now.  Was discovered
    immediately by libFuzzer.  Thanks kcc!

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-153449473
    Fixes https://github.com/behdad/harfbuzz/issues/156

 src/hb-ot-font.cc					   |   4 ++--
 .../sha1sum/8240789f6d12d4cfc4b5e8e6f246c3701bcf861f.ttf  | Bin 0 ->
 633 bytes
 test/shaping/fonts/sha1sum/MANIFEST			   |   1 +
 test/shaping/tests/fuzzed.tests			   |   1 +
 4 files changed, 4 insertions(+), 2 deletions(-)

commit 3530cc2d7c3b7102902cb0e38b0bf9f46188078d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 3 11:34:47 2015 -0800

    [util] Fix option-parsing leaks

 util/helper-cairo.cc	|  7 +++++--
 util/main-font-text.hh | 22 ++++++++++++++++++---
 util/options.cc	| 21 ++++++++++----------
 util/options.hh	| 53
 +++++++++++++++++++++++++++++++++-----------------
 4 files changed, 70 insertions(+), 33 deletions(-)

commit 642135f3b2d6d6eb800153c76c4718239733c0e6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Nov 3 11:26:34 2015 -0800

    [util] In --debug mode, duplicate font data

    This has the effect that the font data will end up in a memory
    section malloc()ed exactly to its size.  This gives us better
    valgrind detection of out-of-bounds access.

    Previously, the font data was placed in a mmap()ed section or
    GString-allocated area, which didn't have proper protections
    at the end when running under valgrind.

 util/options.cc | 3 +++
 1 file changed, 3 insertions(+)

commit ed2024ef93ac3af214082016e5aa8c14db9d7515
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 17:58:12 2015 -0800

    [perf] Micro-optimize

 src/hb-ot-layout-private.hh | 23 ++++++++++++++---------
 1 file changed, 14 insertions(+), 9 deletions(-)

commit 76a5310a830c7ae12037b768c5043bef0ff733a0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 17:52:45 2015 -0800

    Remove irrelevant comment

    I tried moving the is_default_ignorable() function to an INTERNAL
    function.  That made the binary size grow by 5k AND things got a
    tad bit slower!

 src/hb-ot-layout-private.hh | 1 -
 1 file changed, 1 deletion(-)

commit 8259669fbd1b070fc02287325894caf1bc4d590e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 17:44:05 2015 -0800

    Minor

 src/hb-ot-layout-gsubgpos-private.hh | 2 +-
 src/hb-ot-shape-complex-thai.cc      | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 9382c471eabce8d36d3a73c97499ab60af422716
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 17:36:51 2015 -0800

    Combine unicode_props0/1 into a uint16

    Slightly faster.  In prep for more changes.

 src/hb-ot-layout-private.hh | 55
 ++++++++++++++++++++++++---------------------
 1 file changed, 29 insertions(+), 26 deletions(-)

commit 71277185454482cff9b0c10b85c416eb4d6e0ed9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 17:27:48 2015 -0800

    [perf] Only call combining_class() for marks

    Saves some time.  Also preparing for reusing the ccc byte for
    other stuff.

 src/hb-ot-layout-private.hh | 14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit 5ba450407b9d9856453e63a815499da8721ff6a7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 15:43:08 2015 -0800

    Make max context-length and max nesting level configurable

    ...at compile time.

 src/hb-ot-layout-common-private.hh   | 10 ++++++++--
 src/hb-ot-layout-gsub-table.hh       |  4 ++--
 src/hb-ot-layout-gsubgpos-private.hh | 20 ++++++++++----------
 3 files changed, 20 insertions(+), 14 deletions(-)

commit 67f8821fb25d9bd55719f5e29a582ae1af4b02b3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Nov 2 15:37:29 2015 -0800

    [ot] Make bad-hmtx handling match FreeType

    Also route fuzzing-related tests through hb-ot-font, to reduce
    dependency
    on FreeType behavior for badly-broken fonts.  Fixes failing test with
    FreeType master.

 src/hb-ot-font.cc		 | 24 ++++++++++++++----------
 test/shaping/tests/fuzzed.tests | 10 +++++-----
 2 files changed, 19 insertions(+), 15 deletions(-)

commit 672ca3b4e65a75fb3a418ec5d117ad242a98acbb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Oct 26 14:05:05 2015 -0700

    Use templates for making sure expression is constant

 src/hb-private.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 5c8174eda32c08187bc2ed40eefa1017f5b40668
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 18:51:40 2015 -0200

    Update comments for removal of compat decompositions

 src/hb-ot-shape-normalize.cc | 16 ++--------------
 1 file changed, 2 insertions(+), 14 deletions(-)

commit f6799700404c49ae0a6018fd51be19551c76768a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 17:20:55 2015 -0200

    Disable compatibility decomposition usage during normalization

    Fixes https://github.com/behdad/harfbuzz/issues/152

 src/hb-ot-shape-normalize.cc | 24 ------------------------
 1 file changed, 24 deletions(-)

commit ce889189c1f8ef5b400a17f623dcb8b935d1102b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 11:23:12 2015 -0200

    Fix two more -Wshadow warnings

    https://bugzilla.mozilla.org/show_bug.cgi?id=1215894

 src/hb-open-type-private.hh | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 4a6b1eedbb0044b57505eea65a329d2dc4f9f917
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 11:20:55 2015 -0200

    Fix one more -Wshadow warning

    https://bugzilla.mozilla.org/show_bug.cgi?id=1215894

 src/hb-ot-layout-gsubgpos-private.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 6f932bc8f9045b224613a617af2b4f3450c79467
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 11:16:49 2015 -0200

    Fix a few more -Wshadow-local warnings

    https://bugzilla.mozilla.org/show_bug.cgi?id=1215894

 src/hb-ot-shape-complex-indic.cc   | 10 +++++-----
 src/hb-ot-shape-complex-myanmar.cc | 10 +++++-----
 src/hb-ot-shape-complex-use.cc     | 10 +++++-----
 3 files changed, 15 insertions(+), 15 deletions(-)

commit b90cb366d7723c28758c6b75a0770613fbb5456e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 11:13:21 2015 -0200

    Fix one -Wshadow-compatible-local warning

    From https://bugzilla.mozilla.org/show_bug.cgi?id=1215894

 src/hb-ot-shape-complex-indic.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 50e5750bd8670b4cf4463471a2348d4c99c9d054
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 11:10:10 2015 -0200

    Avoid unnecessary cast to 64-bit

    Fixes https://github.com/behdad/harfbuzz/issues/146

    Or I think it should.

 src/hb-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 305d2fbf5a2db51447c8ed894a48a88896930673
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 21 11:04:28 2015 -0200

    Add HB_FALLTHROUGH

    Borrowed from https://bugzilla.mozilla.org/show_bug.cgi?id=1215411

 src/hb-ot-shape-complex-indic.cc |  2 +-
 src/hb-ot-shape-complex-thai.cc  |  2 +-
 src/hb-ot-shape-fallback.cc	  |  4 +++-
 src/hb-private.hh		  | 30 ++++++++++++++++++++++++++++++
 4 files changed, 35 insertions(+), 3 deletions(-)

commit f35b3e931ddacd075c5d0810e9b17de07b232ee2
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Fri Sep 11 09:48:12 2015 +0430

    Add a prototype of DirectWrite as a shaping backend

 src/hb-directwrite.cc | 827
 ++++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-directwrite.h  |  34 +++
 src/hb-shaper-list.hh |   3 +
 3 files changed, 864 insertions(+)

commit 6486e3755482563ecd89aeb3f8348ed190945e26
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 20 16:39:41 2015 -0200

    Fix typo

 Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 753ea7b90904c951c199861409458bea182abb37
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 20 15:21:18 2015 -0200

    Add BUILD.md to dist

 Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 5d7a30fde09320c2c62c7c73570ce3f2e298eba6
Merge: 904b0dc 2fb95a0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 20 15:19:41 2015 -0200

    Merge pull request #148 from ebraminio/inst

    Add BUILD.md based on harfbuzz.org docs

commit 904b0dc3811464cf61dc9457664de95ee4f61a86
Merge: 86cadc2 ba096bc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Oct 19 16:59:43 2015 -0200

    Merge pull request #147 from ebraminio/dockerci

    [ci] change to docker infrastructure

commit ba096bcc28ca80e2096e0a15191848fcd175e395
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Mon Oct 19 21:41:01 2015 +0330

    [ci] change to docker infrastructure

 .travis.yml | 24 ++++++++++++++++--------
 1 file changed, 16 insertions(+), 8 deletions(-)

commit 2fb95a0c9d2cb8b03b7c158706d6b0e41283a6df
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:	Mon Oct 19 22:02:12 2015 +0330

    Add BUILD.md based on harfbuzz.org docs

 BUILD.md | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)

commit 86cadc2cd4171050e9d74306b76c42f6ec74b861
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Oct 15 20:25:29 2015 -0300

    1.0.6

 NEWS	      | 13 +++++++++++++
 configure.ac |  2 +-
 2 files changed, 14 insertions(+), 1 deletion(-)

commit ca97ea7aa2cb7186f432aaba76f4f151aa90c1d0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Oct 15 20:20:22 2015 -0300

    [ft] Revert change-of-behavior of hb_ft_font_create() introduced
    in 1.0.5

    The default FreeType load flags where changed from FT_LOAD_NO_HINTING
    to FT_LOAD_DEFAULT in 2a9627c5641cd000e2adff0e42a0dc687b53ec70.
    This is crashing HarfBuzz-enabled FreeType as I suppose it causes
    infinite recursion between HB and FT autohinter...

    Revert the behavior change.

    Fixes https://github.com/behdad/harfbuzz/issues/143

 src/hb-ft.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 338ffec9e4a5819f2be21c3a320a567378c977b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Oct 15 12:55:57 2015 -0300

    Add tests for a couple of fixed issues found by libFuzzer

    From:
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-147616887
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-148289957

 .../sha1sum/375d6ae32a3cbe52fbf81a4e5777e3377675d5a3.ttf | Bin 0 ->
 1024 bytes
 .../sha1sum/641bd9db850193064d17575053ae2bf8ec149ddc.ttf | Bin 0 ->
 305 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   2 ++
 test/shaping/tests/fuzzed.tests			  |   2 ++
 4 files changed, 4 insertions(+)

commit 63ef0b41dc48d6112d1918c1b1de9de8ea90adb5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Oct 15 12:47:22 2015 -0300

    [ot-font] Fix hmtx wrong table length check

    Discovered by libFuzzer.  Ouch!

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-148289957

 src/hb-ot-font.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 613e630617074eb9b62b794cc37c9b42a7fb079b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 13 23:33:28 2015 -0300

    Reduce max nesting level from 8 to 6

    We probably should implement better system to catch cyclic lookups.
    But for now, this speeds up worst case behavior with broken fonts
    considerably without compromising legitimate usecases.

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-147788447

 src/hb-ot-layout-common-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ab170529246ad80830bef2b3c8b48e9a8d2b7483
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 13 10:55:33 2015 -0300

    1.0.5

 NEWS	      | 24 ++++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 25 insertions(+), 1 deletion(-)

commit ed13e2ce509408f849255be1d3cc3dbd7dbb3ba2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 13 10:32:56 2015 -0300

    [ot-font] Fix leak

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-147616887

 src/hb-ot-font.cc | 1 +
 1 file changed, 1 insertion(+)

commit 55db94be2b754ba9b9121f09abcf8496c798affc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 13 00:33:59 2015 -0400

    Add test for previous commit

 .../sha1sum/0509e80afb379d16560e9e47bdd7d888bebdebc6.ttf   | Bin 0 ->
 61 bytes
 test/shaping/fonts/sha1sum/MANIFEST			    |	1 +
 test/shaping/tests/fuzzed.tests			    |	1 +
 3 files changed, 2 insertions(+)

commit f96664974774bfeb237a7274f512f64aaafb201e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Oct 13 00:30:50 2015 -0400

    Fix another memory access issue discovered by libFuzzer

    Fixes
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-146984679

 src/hb-ot-layout-gpos-table.hh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit c1a5dc46c2231f7b62421e06b9766ccfebaf3ef5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Oct 12 17:39:52 2015 -0400

    [fuzz] Add fuzzing script from kcc@

    https://github.com/behdad/harfbuzz/issues/139

 test/fuzzing/hb-fuzzer.cc | 47
 +++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 47 insertions(+)

commit cc6ea308d4c99b9dd6d625fa3a9b0ef62fa2614f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Oct 12 17:21:52 2015 -0400

    Extern "C" custom-allocator declerations

 src/hb-private.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 98c6fccc00062ead7a86892dd059aa13d266b981
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sun Oct 11 21:41:04 2015 -0400

    Add test for ee9b0b6cb5fdb08671ab064f26c299135f828260

 .../sha1sum/5a5daf5eb5a4db77a2baa3ad9c7a6ed6e0655fa8.ttf   | Bin 0 ->
 61 bytes
 test/shaping/fonts/sha1sum/MANIFEST			    |	1 +
 test/shaping/tests/fuzzed.tests			    |	1 +
 3 files changed, 2 insertions(+)

commit 50f489a0a013fc589626bb532a9f64f50bb41f58
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sun Oct 11 20:59:29 2015 -0400

    Typo

 src/hb-font-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ee9b0b6cb5fdb08671ab064f26c299135f828260
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 9 14:23:15 2015 -0400

    Fix another sanitize bug

    Also discovered by "libFuzzer".

 src/hb-open-type-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 34379b49e6922b86c15ee62f7fe3bf016cdc2514
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 9 12:34:02 2015 -0400

    Add test for previous fix

 test/shaping/Makefile.am				    |	1 +
 .../sha1sum/1a6f1687b7a221f9f2c834b0b360d3c8463b6daf.ttf   | Bin 0 ->
 64 bytes
 test/shaping/fonts/sha1sum/MANIFEST			    |	1 +
 test/shaping/tests/MANIFEST				    |	1 +
 test/shaping/tests/fuzzed.tests			    |	1 +
 5 files changed, 4 insertions(+)

commit f396fbb000dc1c8acddbf6a16e193b328c5e551e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 9 12:25:55 2015 -0400

    Fix return value of sanitize when subformat is not readable

    This is a fix on top of the previous issue fixed in
    c917965b9e6fe2b21ed6c51559673288fa3af4b7.

    This was caught by "libFuzzer" testing.

 src/hb-open-type-private.hh	      |  2 ++
 src/hb-ot-layout-gpos-table.hh       | 15 +++++++--------
 src/hb-ot-layout-gsub-table.hh       | 13 ++++++-------
 src/hb-ot-layout-gsubgpos-private.hh |  8 ++++----
 4 files changed, 19 insertions(+), 19 deletions(-)

commit 77a1a2bc18e7b04d4e352a8777ccce345b2f8659
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 9 12:20:58 2015 -0400

    Add hb_dispatch_context_t

 src/hb-open-type-private.hh	      | 26 ++++++++++++++++++++++----
 src/hb-ot-layout-gsubgpos-private.hh | 36
 ++++++++++++------------------------
 src/hb-ot-layout.cc		      |  8 +++-----
 3 files changed, 37 insertions(+), 33 deletions(-)

commit 3e905e396bcd745bda88e751998a76556c5cb8c6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Oct 8 12:51:02 2015 -0400

    Add hb_font_set_parent()

    No reason to not have it.  Makes life easier later.
    We (hb-ft, hb-ot-font, etc) can use this API to inject new
    parent into a font...

 src/hb-font.cc       | 26 ++++++++++++++++++++++++++
 src/hb-font.h	      |  4 ++++
 test/api/test-font.c | 12 ++++++++++++
 3 files changed, 42 insertions(+)

commit edeb3dabf4a589d67c3f1da7ba43a74e4d3a9afd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Oct 8 12:47:15 2015 -0400

    [ft] Add version for new API

 src/hb-ft.cc | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 2a9627c5641cd000e2adff0e42a0dc687b53ec70
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 7 17:33:20 2015 -0400

    [ft] API: Add hb_font_[sg]et_load_flags() API

    This changes the default load_flags of fonts created using
    hb_ft_font_create() from NO_HINTING to DEFAULT.  Hope that doesn't
    break too much client code.

    Code calling hb_ft_font_set_funcs() is unaffected.

 src/hb-ft.cc | 163
 +++++++++++++++++++++++++++++++++++++++--------------------
 src/hb-ft.h  |  13 +++--
 2 files changed, 118 insertions(+), 58 deletions(-)

commit 3224a594dcf2164b5585b4ccba34f244af3f61b9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Oct 7 17:33:02 2015 -0400

    Minor

 src/hb-ot-font.cc | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 52b418555b62a3b25399f202c1fa72ab7288c224
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sat Oct 3 13:20:55 2015 +0100

    Allow compiling with custom allocators

    User can define hb_malloc_impl, etc, to name of custom allocator
    functions
    that have the same signature as malloc.

 src/hb-private.hh | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit 88da7bba9fa4665b33f5bfcd45add7443097eaf3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 2 14:38:20 2015 +0100

    Default font scale to face upem

    Makes for a better default and avoids nasty inheritance issues.
    See mailing list thread "Default hb_font_t scale".

 src/hb-font.cc       |  2 ++
 test/api/test-font.c | 13 ++++++++-----
 2 files changed, 10 insertions(+), 5 deletions(-)

commit 1866e17114b41d565eb066e7d9393c2ff3e0a12b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 2 14:21:29 2015 +0100

    Make hb_font_create_sub_font() NOT make parent immutable

    We don't rely on that.  However, whenever hb_font_make_immutable()
    is called, it makes its parenting chain immutable.

 src/hb-font.cc       |  4 +++-
 test/api/test-font.c | 21 +++++++++++++++------
 2 files changed, 18 insertions(+), 7 deletions(-)

commit 980e25cad2e58c31f5361862b9223d94ec47fc7a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 2 08:21:12 2015 +0100

    Fix hb-ot-shape-normalize with empty buffer

    Part of https://github.com/behdad/harfbuzz/issues/136

 src/hb-ot-shape-normalize.cc | 2 ++
 1 file changed, 2 insertions(+)

commit a5efaac4ff61b587f228830b265b39fe8e5e4e47
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 2 08:02:29 2015 +0100

    Replace a couple of malloc()s with calloc()

 src/hb-face.cc       | 2 +-
 src/hb-shape-plan.cc | 2 +-
 src/hb-shaper.cc     | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 26ba4d1e1fb8949632fe08e6a7600badfba4f142
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Oct 2 07:25:52 2015 +0100

    Fix segfault with empty buffer in hb_shape_plan_execute()

    Move the empty-buffer check from hb_shape_full() to
    hb_shape_plan_execute().

    Reported by Simon Cozens.

 src/hb-shape-plan.cc | 9 +++++++--
 src/hb-shape.cc      | 5 -----
 2 files changed, 7 insertions(+), 7 deletions(-)

commit 432ffc47a46d41bea17d839d0d3980e654c6e638
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Sep 30 22:51:16 2015 +0100

    1.0.4

 NEWS	      | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit b47159011ca518c3b94d782ed16a91ffe9dd2ab2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 29 14:57:02 2015 +0100

    Define return_trace()

    Not functional change (expected!).

 src/hb-open-file-private.hh	      |  20 +--
 src/hb-open-type-private.hh	      |  62 +++----
 src/hb-ot-cmap-table.hh	      |  56 +++----
 src/hb-ot-glyf-table.hh	      |   4 +-
 src/hb-ot-head-table.hh	      |   2 +-
 src/hb-ot-hhea-table.hh	      |   2 +-
 src/hb-ot-hmtx-table.hh	      |   2 +-
 src/hb-ot-layout-common-private.hh   | 108 ++++++-------
 src/hb-ot-layout-gdef-table.hh       |  44 ++---
 src/hb-ot-layout-gpos-table.hh       | 252 +++++++++++++++--------------
 src/hb-ot-layout-gsub-table.hh       | 304
 ++++++++++++++++++-----------------
 src/hb-ot-layout-gsubgpos-private.hh | 205 +++++++++++------------
 src/hb-ot-layout-jstf-table.hh       |  35 ++--
 src/hb-ot-maxp-table.hh	      |   5 +-
 src/hb-ot-name-table.hh	      |  14 +-
 src/hb-private.hh		      |   6 +-
 16 files changed, 575 insertions(+), 546 deletions(-)

commit c917965b9e6fe2b21ed6c51559673288fa3af4b7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 29 14:45:35 2015 +0100

    Add missing returns

    Fixes possible invalid read of two bytes.

    Reported by Behzad Najjarpour Jabbari, Secunia Research.

 src/hb-ot-layout-gpos-table.hh       | 14 +++++++-------
 src/hb-ot-layout-gsub-table.hh       | 12 ++++++------
 src/hb-ot-layout-gsubgpos-private.hh |  8 ++++----
 3 files changed, 17 insertions(+), 17 deletions(-)

commit f3159ba5141c2ab0e430e64742972df140f91c43
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 29 14:34:56 2015 +0100

    Micro-optimize hb_language_from_string()

    As measured / improved by Benson Limketkai.

 src/hb-common.cc | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit f2ad935e19338a29113492150f0c5a5fd5befd75
Author: Sascha Brawer <sascha@brawer.ch>
Date:	Sun Jun 28 03:29:47 2015 +0200

    Handle language tags that indicate phonetic IPA transcription

    The BCP-47 registry defines a variant subtag "fonipa" that can be used
    in combination with arbitrary other language tags. For example,
    "rm-CH-fonipa-sursilv" indicates the Sursilvan dialect of Romansh
    as used in Switzerland, transcribed used the International Phonetic
    Alphabet.

    http://www.iana.org/assignments/language-subtag-registry/language-subtag-registry

 src/hb-ot-tag.cc	| 15 ++++++++++++++-
 test/api/test-ot-tag.c |  7 +++++++
 2 files changed, 21 insertions(+), 1 deletion(-)

commit b8811429b6810c4f13be087b593a862c17d9d987
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Sep 3 15:53:22 2015 +0430

    Fix Since tags

    Fixes https://github.com/behdad/harfbuzz/issues/103

 src/hb-blob.cc		    | 24 +++++++++----------
 src/hb-buffer-serialize.cc | 10 ++++----
 src/hb-buffer.cc	    | 58
 +++++++++++++++++++++++-----------------------
 src/hb-buffer.h	    |  9 +++++++
 src/hb-common.cc	    | 24 +++++++++----------
 src/hb-common.h	    |  3 +++
 src/hb-coretext.cc	    |  3 +++
 src/hb-font.h		    | 18 +++++++-------
 src/hb-ft.cc		    |  6 ++---
 src/hb-graphite2.cc	    |  6 +++++
 src/hb-ot-layout.cc	    |  2 +-
 src/hb-ot-tag.cc	    |  2 +-
 src/hb-set.h		    |  3 +++
 src/hb-shape.cc	    |  2 +-
 src/hb-unicode.cc	    | 18 +++++++-------
 src/hb-unicode.h	    | 10 ++++----
 16 files changed, 111 insertions(+), 87 deletions(-)

commit 5d74ff02ab01df67808b416af8bb9cefb06f841e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Sep 3 14:55:59 2015 +0430

    Fix Since: version tags on font and face APIs

    A while back we marked every API as version:1.0.  We should fix
    them all
    to reflect real version they were introduced.  This is a start.

    Patch from Nikolay Sivov.

 src/hb-face.cc | 22 ++++++++---------
 src/hb-font.cc | 76
 +++++++++++++++++++++++++++++-----------------------------
 2 files changed, 49 insertions(+), 49 deletions(-)

commit 7f5405397406a24c5a001b5ef43dcf4d6926415e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 17:03:50 2015 +0100

    1.0.3

 NEWS	      | 11 +++++++++++
 configure.ac |  2 +-
 2 files changed, 12 insertions(+), 1 deletion(-)

commit 5828c45d7a816ccd0a7f10a665ea3cf8cfd63b05
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:26:35 2015 +0100

    [indic] Add comments to merge_clusters calls

 src/hb-ot-shape-complex-indic.cc | 21 ++++++++++++++++-----
 1 file changed, 16 insertions(+), 5 deletions(-)

commit bdc8215949a7add742cc800b4fdea6acaa37d152
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:24:54 2015 +0100

    [thai] Respect cluster-level > 0

 src/hb-ot-shape-complex-thai.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5b31fe383ead726ec77062501ed3bb24c02842b3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:24:34 2015 +0100

    [use] Merge /before/ reordering

 src/hb-ot-shape-complex-use.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0d438f89bd9422c66838c776eb4aa867de0a2ad8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:24:13 2015 +0100

    [hangul] Merge /before/ reordering

 src/hb-ot-shape-complex-hangul.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f883de664fc4bfe01e30c89e07e31dc113f906d9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:23:40 2015 +0100

    [OT] Merge /before/ reordering

 src/hb-ot-shape.cc | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit c403d6320074455a5e8e48902c0ac4ee9685e33d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:15:25 2015 +0100

    [myanmar] Use buffer->sort() to sort cluster

    This can possibly produce more granular clusters.

 src/hb-ot-shape-complex-myanmar.cc | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit e995d33c10a4bd9404699d01bddb2b69d811e9ed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:13:32 2015 +0100

    [OT] Merge clusters when reordering marks for normalization

    Fixes https://bugzilla.gnome.org/show_bug.cgi?id=541608
    and cluster test.

 src/hb-buffer-private.hh     |  2 ++
 src/hb-buffer.cc	      | 21 +++++++++++++++++++++
 src/hb-ot-shape-normalize.cc |  2 +-
 3 files changed, 24 insertions(+), 1 deletion(-)

commit b6d7d161a87b5dde710924e5c557d39c302f5630
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:12:44 2015 +0100

    [tests] Add Hebrew test for normalization under cluster-level=1

    Currently fails.
    https://bugzilla.gnome.org/show_bug.cgi?id=541608

 .../sha1sum/43ef465752be9af900745f72fe29cb853a1401a5.ttf | Bin 0 ->
 4272 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   1 +
 test/shaping/tests/cluster.tests			  |   1 +
 3 files changed, 2 insertions(+)

commit 93099748e39740a3f6f003c83d9dec1d21660ce8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 16:11:27 2015 +0100

    Minor

 src/hb-private.hh | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 85846b3de7491b6a07fed6a2c0c6c1b09943b249
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 15:07:52 2015 +0100

    Use insertion-sort instead of bubble-sort

    Needed for upcoming merge-clusters fix.

 src/hb-buffer.cc			    |  4 +--
 src/hb-ot-shape-complex-arabic-fallback.hh |  6 ++--
 src/hb-ot-shape-complex-indic.cc	    |  2 +-
 src/hb-ot-shape-complex-myanmar.cc	    |  2 +-
 src/hb-ot-shape-normalize.cc		    |  6 ++--
 src/hb-private.hh			    | 56
 +++++++++++++-----------------
 6 files changed, 34 insertions(+), 42 deletions(-)

commit fad2674874591b4a1df822603144c8864f5364c1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Sep 1 14:45:46 2015 +0100

    Minor

 test/Makefile.am	  | 4 ++++
 test/api/Makefile.am	  | 4 ++++
 test/shaping/Makefile.am | 4 ++++
 3 files changed, 12 insertions(+)

commit 23e4fac6de913201f263a73e13d3c1fab31d1bdd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 31 19:41:01 2015 +0100

    Update git.mk from upstream

 git.mk | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit 5783e05f81bbf6debf2618c8994d6852630d9847
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 31 19:18:10 2015 +0100

    [docs] Move docs/reference/ contents into docs/

 configure.ac				     |	 3 +-
 docs/Makefile.am			     | 117
 ++++++++++++++++++++++++++-
 docs/{reference => }/harfbuzz-docs.xml      |	 0
 docs/{reference => }/harfbuzz-overrides.txt |	 0
 docs/{reference => }/harfbuzz-sections.txt  |	 0
 docs/reference/Makefile.am		     | 118
 ----------------------------
 docs/{reference => }/usermanual-ch01.xml    |	 0
 docs/{reference => }/usermanual-ch02.xml    |	 0
 docs/{reference => }/usermanual-ch03.xml    |	 0
 docs/{reference => }/usermanual-ch04.xml    |	 0
 docs/{reference => }/usermanual-ch05.xml    |	 0
 docs/{reference => }/usermanual-ch06.xml    |	 0
 docs/{reference => }/version.xml.in	     |	 0
 13 files changed, 117 insertions(+), 121 deletions(-)

commit cd5e3a13a6e0b6606d3a421f8cd44cdfb8314907
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 31 19:16:41 2015 +0100

    [docs] Fix out-of-tree build

 docs/reference/Makefile.am		  |  9 ++++++++-
 docs/reference/harfbuzz-docs.xml	  | 12 ++++++------
 docs/{ => reference}/usermanual-ch01.xml |  0
 docs/{ => reference}/usermanual-ch02.xml |  0
 docs/{ => reference}/usermanual-ch03.xml |  0
 docs/{ => reference}/usermanual-ch04.xml |  0
 docs/{ => reference}/usermanual-ch05.xml |  0
 docs/{ => reference}/usermanual-ch06.xml |  0
 8 files changed, 14 insertions(+), 7 deletions(-)

commit 3899795fa3c3e058e3885ec7a6638f0597a752cc
Merge: d205965 01e16e8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 31 10:46:01 2015 +0100

    Merge pull request #131 from simoncozens/docs

    Use gtk-doc to build user's manual as well as reference

commit 01e16e88f50b65b82dcb84773f532f18a351319f
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Mon Aug 31 10:40:17 2015 +0100

    Combine user / reference information into gtk-doc generated manual.

 docs/reference/harfbuzz-docs.xml | 91
 +++++++++++++++++++++++-----------------
 1 file changed, 52 insertions(+), 39 deletions(-)

commit 11a07c4729174e1d4af028103ecb0a351e4c2707
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Mon Aug 31 10:39:10 2015 +0100

    Correct tag hierarchy, to allow for table-of-contents entries.

 docs/usermanual-ch01.xml | 12 ++++++------
 docs/usermanual-ch02.xml |  8 ++++----
 docs/usermanual-ch03.xml | 24 ++++++++++++------------
 docs/usermanual-ch04.xml | 16 ++++++++--------
 docs/usermanual-ch05.xml | 12 ++++++------
 5 files changed, 36 insertions(+), 36 deletions(-)

commit 387d6af428ddd5d4f211fe5748412011013a3826
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Mon Aug 31 10:31:09 2015 +0100

    Missing tag (oops).

 docs/usermanual-ch02.xml | 1 +
 1 file changed, 1 insertion(+)

commit d205965286798af4b7ad07e1eafa58288bee4bdb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 31 10:12:05 2015 +0100

    [docs] Fix typo

 docs/usermanual-ch03.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c424b41705b50055c7f92b268cf78a2680af73af
Merge: 31594b9 5470e74
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 31 09:53:16 2015 +0100

    Merge pull request #129 from simoncozens/docs

    First two chapters. More to follow.

commit 31594b98af0c9181982c77d8d3803753007f8fd4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sun Aug 30 17:33:04 2015 +0100

    [test] Fix test-object

    See previous commit.

 test/api/test-object.c | 4 ----
 1 file changed, 4 deletions(-)

commit 326b5ebf5748f547e4eb7388d66b79fe23130e2a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sun Aug 30 17:29:21 2015 +0100

    Poison freed objects such that double-free is detected

    Previously we were setting refcount of freed objects to the inert
    value, which
    was harmful because it caused further destroy()s of the freed object
    to NOT
    call free() and hence hide the bug.  Indeed, after eb0bf3ae6688b7
    test-object
    was double-free'ing objects and this was never caught on Linux.
    It only was
    caught as crashing on Mac.

    Now we poison refcount upon freeing and check that it's valid
    whenever reading
    it.  Makes test-object fail now.

 src/hb-object-private.hh | 21 ++++++++++++++++-----
 1 file changed, 16 insertions(+), 5 deletions(-)

commit 5470e744dd264c2dc33437a68d20bcf7c5ffb905
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Sat Aug 29 08:21:18 2015 +0100

    Current state and skeleton outline

 docs/usermanual-ch03.xml | 77
 ++++++++++++++++++++++++++++++++++++++++++++++++
 docs/usermanual-ch04.xml | 18 +++++++++++
 docs/usermanual-ch05.xml | 13 ++++++++
 docs/usermanual-ch06.xml |  8 +++++
 4 files changed, 116 insertions(+)

commit 6578575cc8aeb05341f2053039acfcd735707674
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 25 20:24:59 2015 +0100

    [GPOS] Fix cursive connection with mix of RTL and non-RTL lookups

    See thread "Issue with cursive attachment" started by Khaled.
    Turned out fixing this wasn't as bad as I had assumed.  I like the
    new code better; we now have a theoretical model of cursive
    connections that is easier to reason about.

 src/hb-ot-layout-gpos-table.hh | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

commit 7368da67244ea53195cd9b95a5c57485df695732
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 25 20:28:39 2015 +0100

    [test] Add test for cursive-positioning with mixed directions

    Fails now.	Fix coming.  See thread "Issue with cursive attachment"
    started by Khaled.	Test fonts were made by modifying test font
    from Khaled to add more anchors.

 test/shaping/Makefile.am				  |   1 +
 .../sha1sum/298c9e1d955f10f6f72c6915c3c6ff9bf9695cec.ttf | Bin 0 ->
 2520 bytes
 test/shaping/fonts/sha1sum/MANIFEST			  |   2 ++
 .../sha1sum/c4e48b0886ef460f532fb49f00047ec92c432ec0.ttf | Bin 0 ->
 2512 bytes
 test/shaping/tests/MANIFEST				  |   1 +
 test/shaping/tests/cursive-positioning.tests		  |   2 ++
 6 files changed, 6 insertions(+)

commit f0807654da160bd7ceb9aff5b8338ec0b643171c
Author: Simon Cozens <simon@simon-cozens.org>
Date:	Tue Aug 25 19:57:15 2015 +0100

    First two chapters. More to follow.

 docs/usermanual-ch01.xml | 115 ++++++++++++++++++++++++++++++
 docs/usermanual-ch02.xml | 182
 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 297 insertions(+)

commit 58f2a73fb95af42e264a91cdef7bb5a89e965601
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 25 18:55:34 2015 +0100

    [GPOS] Rewrite cursive attachment slightly differently

    In anticipation for upcoming fix for bug reported by
    Khaled in thread "Issue with cursive attachment".

 src/hb-ot-layout-gpos-table.hh | 36 ++++++++++++++++++++++++------------
 1 file changed, 24 insertions(+), 12 deletions(-)

commit fdd1770e006ca2d2973c049177ceda87a575e07f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 24 13:49:55 2015 +0100

    Add API/cmdline to show glyph extents when serializing buffer

    New API: HB_BUFFER_SERIALIZE_FLAG_GLYPH_EXTENTS

    hb-shape now accepts --show-extents.

    Patch from Simon Cozens.

 src/hb-buffer-serialize.cc | 17 +++++++++++++++++
 src/hb-buffer.h	    |  3 ++-
 util/hb-shape.cc	    |  2 ++
 util/options.cc	    |  1 +
 util/options.hh	    |  2 ++
 5 files changed, 24 insertions(+), 1 deletion(-)

commit 2cee5b68a07b99214ef9428fe5d03e7b378a558f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 24 13:45:12 2015 +0100

    [ot-font] Fix short-offset calculation

 src/hb-ot-font.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b50fcfa82994f93568a54dd1eb7fd327f6db5586
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Sun Aug 23 14:42:20 2015 +0100

    [ot-font] Implement glyph_extents() for TrueType fonts

    This brings ot-fonts into almost-complete shape and mostly in par with
    ft font.

 src/Makefile.am	 |   1 +
 src/hb-font.h		 |   9 +++--
 src/hb-ot-font.cc	 |  90 +++++++++++++++++++++++++++++++++++++++--
 src/hb-ot-glyf-table.hh | 104
 ++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot-head-table.hh |   3 +-
 5 files changed, 198 insertions(+), 9 deletions(-)

commit 0299b45000b5047c0b9bf0fe51f3b8b68a7982f8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Fri Aug 21 12:44:36 2015 +0100

    Make BYTE a real type

 src/hb-open-type-private.hh | 16 +++++++++++++++-
 1 file changed, 15 insertions(+), 1 deletion(-)

commit ed6962c795ae7c54aaee9ed5667fa65ccf7412bf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Aug 20 15:39:53 2015 +0100

    [coretext] Use i32 instead of u32 as well

    Shouldn't cause *any* functional changes, but is more correct.

 src/hb-coretext.cc | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 163c435f1807c138da9f74f09d29d913eb9e29e9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Thu Aug 20 15:39:06 2015 +0100

    [uniscribe] Fix negative offsets

    Ouch!

 src/hb-uniscribe.cc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 789b89ef7130ffe5f22c571fc3cb4e6d35456654
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Aug 19 13:39:57 2015 +0100

    1.0.2

 NEWS	      | 13 +++++++++++++
 configure.ac |  2 +-
 2 files changed, 14 insertions(+), 1 deletion(-)

commit 958c268fa3a520666436e77a2111a3b564a36d96
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Aug 19 13:22:12 2015 +0100

    [coretext] Add TODO item

 src/hb-coretext.cc | 1 +
 1 file changed, 1 insertion(+)

commit 7c5bee09d9c7c25672c7c77572ebae0b731892d0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Wed Aug 19 13:20:31 2015 +0100

    [uniscribe] Fix font scale handling

    By default shape at upem (or ppem), and scale results.
    Similar to work done in CoreText backend, but using upem as default.

 src/hb-uniscribe.cc | 25 +++++++++++++++++++------
 1 file changed, 19 insertions(+), 6 deletions(-)

commit 902e74a098dad8c3b487856284f9fdf99b04f9f1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 18:55:03 2015 +0100

    Commented-out code to print buffer before each lookup

    To be turned into a useful HB_DEBUG_SHAPE infrastructure...

 src/hb-ot-layout.cc | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 75504a50488a6aac0b9789f728fb5b87e641d4c3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 18:47:02 2015 +0100

    Allow serializing buffer with output-buffer being used

    Ie, don't call get_positions() if positions are not
    requested for serialization.

 src/hb-buffer-serialize.cc | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit e47b772a56af44a9a4f9ec907ee2091b725b94c1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 18:42:47 2015 +0100

    [ot] Change buffer content type right after we map to glyphs

    Needed for upcoming debug output changes.

 src/hb-ot-shape.cc | 2 ++
 1 file changed, 2 insertions(+)

commit d104415e4c1e0f9140f794cd8d09c6460c63e966
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 17:33:34 2015 +0100

    [Android.mk] Update for SEA removal and USE addition

 Android.mk | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ddd6bf12f1cabaa298feed820313483b9893528c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 15:55:09 2015 +0100

    Don't declare dependency on freetype in harfbuzz.pc

    See comments.

 src/Makefile.am | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 2c8b3b2e5312c9858584f568b1528c57e5bb8a10
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 14:36:43 2015 +0100

    [debug] Print lookup index in debug-apply output

 src/hb-ot-layout-gpos-table.hh       | 5 ++++-
 src/hb-ot-layout-gsub-table.hh       | 5 ++++-
 src/hb-ot-layout-gsubgpos-private.hh | 7 +++++--
 src/hb-ot-layout.cc		      | 3 ++-
 4 files changed, 15 insertions(+), 5 deletions(-)

commit 50ad7788eeb7160caef4ec78e65c7c630e601b06
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 18 10:22:16 2015 +0100

    [coretext] Remove assert that kicks in on Mac OS 10.6

    http://crbug.com/419769

 src/hb-coretext.cc | 18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit 2b646fa07f5f9d4d10d563a91d22a2750b5fc771
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Mon Aug 17 16:03:28 2015 +0200

    Remove unused function

 src/hb-ot-shape-complex-use.cc | 8 --------
 1 file changed, 8 deletions(-)

commit 23237b0279a04407addf33f599c45faa60f002ca
Author: ThePhD <phdofthehouse@gmail.com>
Date:	Fri Aug 14 01:19:08 2015 -0400

    Last apparent boolean fix!

 src/hb-ot-shape-complex-use.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5c99cf93d6242803bddcac2ca8300fdec7e0f8a7
Merge: 8ad89f0 539a610
Author: ThePhD <phdofthehouse@gmail.com>
Date:	Fri Aug 14 01:02:00 2015 -0400

    Merge branch 'master' into vc++-fixes

commit 539a610e2e72375e598ab29fd390ed9ec93816d5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:	Tue Aug 11 12:58:49 2015 +0200

    Add Libs.private and Requires.private to harfbuzz.pc

    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=64501

 configure.ac	    | 12 +++++++++---
 src/Makefile.am    | 15 ++++++++++++---
 src/harfbuzz.pc.in |  2 ++
 3 files changed, 23 insertions(+), 6 deletions(-)

commit c7dfe316f8c0fc04b7976fca5e58eb46d91b4821
Author: jfkthame <jfkthame@gmail.com>
Date:	Fri Aug 7 17:55:03 2015 +0100

    Don't rely on .cluster in _hb_ot_shape_normalize()

    Fixes https://github.com/behdad/harfbuzz/pull/124

 src/hb-ot-shape-normalize.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

